/*************************************
Pavel Potapov, virtualTEM, 2013-2014
**************************************/

result("4")

number OFFLine 
GetPersistentNumberNote("_temDM-Scripts"+":OFFLine",OFFLine);
if(OffLine!=1){result("X");throw(-128);}


//service 112 commands

number CorrectLeftRight112(number W,number L,number R,number &Lin,number &Rin,number &Lout,number &Rout)
	{
	if((L>=W)||(R<=0)){return 0; }// empty overlap
	
	if(L>=0) {Lin = L;Lout = 0;}
	else    {Lin = 0;Lout = -L;}
	if(R<W) {Rin = R;Rout = R-L;}
	else 	{Rin = W;Rout = W-L;}	
	
	return 1	//some overlap
	}
	
image FlexibleSelection1DV112(image in,number t,number b)
	{
	//allow to select [t,b] in image "in" even if 
	//t,b are negative or exceed  "in"'s height		
	//black pixel are returned in exceed areas
	number dummy,H
	getSize(in,dummy,H)
		
	t=trunc(t)
	b=trunc(b)
	number Tin,Bin
	number Tout,Bout	
	number overlap = 1
	if(!CorrectLeftRight112(H,t,b,Tin,Bin,Tout,Bout) ) overlap = 0
	
//result("\nin "+Tin+" "+" "+Bin+" "+(Bin-Tin))
//result("\nout "+Tout+" "+Bout+"     "+(Bout-Tout))
	image out:= realimage("",4,1,b-t)
	
	if(overlap) out[Tout,0,Bout,1] = in[Tin,0,Bin,1]
	
	return out
	}


image FlexibleSelection2D112(image in,number t,number l,number b,number r)
	{
	//allow to select [t,l,b,r] in image "in" even if 
	//t,l,b,r are negative or exceed  "in"'s height,width		
	//black pixel are returned in exceed areas
	number W,H
	getSize(in,W,H)
		
	t=trunc(t)
	l=trunc(l)
	b=trunc(b)
	r=trunc(r)
//result("\nini "+T+" "+L+" "+B+" "+R)	
	number Tin,Lin,Bin,Rin
	number Tout,Lout,Bout,Rout	
	number overlap = 1
	if(!CorrectLeftRight112(W,l,r,Lin,Rin,Lout,Rout) ) overlap = 0
	if(!CorrectLeftRight112(H,t,b,Tin,Bin,Tout,Bout) ) overlap = 0
	
//result("\nin "+Tin+" "+Lin+" "+Bin+" "+Rin+"     "+(Bin-Tin)+"     "+(Rin-Lin))
//result("\nout "+Tout+" "+Lout+" "+Bout+" "+Rout+"     "+(Bout-Tout)+"     "+(Rout-Lout))
	image out:= realimage("",4,r-l,b-t)
	
	if(overlap) out[Tout,Lout,Bout,Rout] = in[Tin,Lin,Bin,Rin]
	
	return out
	}
	
number PositionOfFeature112(number Width,number drift_pxl)
	{
	number OnCam = 1/2+drift_pxl/width
	number ostat = OnCam-trunc(OnCam)
	if(ostat<0) ostat = 1+ostat
	
	return ostat*width
	}
	
number DriftFeatureWithTime112(number binnedWidth,number DriftXPerMin,number X,number Z,number Alpha,number isX,number PixelSizeX)
{
	number tick0 = VMgetvalue112("InitialTimeTick")
	number dt = CalcOSSecondsBetween(tick0,GetOSTickCount())/60
	number CenterX = round(PositionOfFeature112(binnedWidth,(DriftXPerMin*dt+X+Z*Sin(Alpha/57.30)+isX)/PixelSizeX) ) 
return CenterX
}
		
string MisfitSize112() return "the image size is invalid for these acquisition parameters and this camera"

image StigmaticDistorsion112(number AstX,number AstY,number dir,number width)	
	{
	number Ast=sqrt(AstX**2+AstY**2)

	number theta 
	if(astX<0) {astX=-astX; astY=-astY;}
	if(!(AstX==0)) theta =atan(-AstY/AstX)
	else Theta=1.5708
	if(dir<0) Theta+=1.57
	
	number CT=cos(theta)
	number ST=sin(theta)
	
	number w = width
	number h = width
	if(dir>=0) 	{w+=(width*modulus(AstX)); h+=(width*modulus(AstY));}
	else 			{w+=(width*modulus(AstY)); h+=(width*modulus(AstX));}
	
	image def:= IntegerImage("def",2,0,w,h)
	def = sqrt( ( ((icol-w/2)*CT + (irow-h/2)*ST)/(1+Ast) )**2+( (irow-h/2)*CT - (icol-w/2)*ST)**2)
	
	return def
	}

image SinSmear112(image temp,number radius,number trans,number Int)
	{
	number r1 = radius-Trans
	number r2 = radius+Trans
	
	number w
	image im = temp.imageclone()
	
//temp.showimage()
	im = tert(temp<r1,Int,0)
	im = tert(temp>=r1,Int/2*(1+cos((temp-r1)/(r2-r1)*3.14159)),im)
	im = tert(temp<r2,im,0)
	
	return im
	}
	
image Particle112(number Size,number Galo,number Smear, number AstX,number AstY,number Int)
	{
	number radius = size/2	
	number Trans = Galo+modulus(Smear)
	number width = 2*(radius+Trans)
	if(width<=0) {result("\nParticle info inconsistant");width =2;}
//result("\nparticle width "+width+" Trans "+Trans)

	image def := StigmaticDistorsion112(AstX,AstY,smear,width)
	image im = SinSmear112(def ,radius,Trans,Int)

	return im
	}

image Profile112(number Size,number SizeCore,number Galo,number Smear,number Mode, number AstX,number AstY,number Int,number IntCore)
	{
	number radius = size/2	
	number radiusCore = SizeCore/2	
	number Trans = Galo+modulus(Smear)
	number width = 2*(radius+Trans)
	IntCore = IntCore-Int
	if(width<=0) {result("\nParticle info inconsistant");width =2;}
//result("\nparticle width "+width+"Trans "+Trans)
	
	image temp
	if(mode==0)	//2D profile
		{		
		temp := StigmaticDistorsion112(AstX,AstY,smear,width)			
		}
	if(mode==1)	//horisontal profile
		{
		temp:= realimage("",4,width,1)
		temp =tert(icol>width/2,icol-width/2,width/2-icol)
		}
	if(mode==2)	//vertical profile
		{
		temp:= realimage("",4,1,width)
		temp =tert(irow>width/2,irow-width/2,width/2-irow)
		}	
			
	image im = SinSmear112(temp,radius,Trans,Int)
	image core = SinSmear112(temp,radiusCore,Trans,IntCore)
		
	im += core

	return im
	}
	
image DiffuseRing112(number Radius,number Galo,number Smear,number AstX,number AstY,number Int)
	{
	number Trans = Galo + modulus(Smear)	
	number width =2*(Radius+Trans)
	if(width<=0) {result("\nDiffuse ring parameters are inconsistant");width =2;}
	
	image def := StigmaticDistorsion112(AstX,AstY,smear,width)
	image im = imageclone(def)
	
	im = tert(def>(Radius-Trans),Int*(1+sin((def-(Radius-Trans))/Trans*3.14159-1.57))/2,0)
	im = tert(def>(Radius+Trans),0,im)
		
	return im
	}

void InsertSubImage112(image &im, image ToInsert,number CenterX,number CenterY)
	{
	number Width,Height
	GetSize(im,Width,Height)
	if((CenterX>0)&&(CenterX<Width)&&(CenterY>0)&&(CenterY<Height))
		{
		number wS,hS
		getSize(ToInsert,wS,hS)		
		number tS=0,lS=0,bS=hS,rS=wS	
		number top=round(CenterY-hS/2) , left=round(CenterX-wS/2), bottom=top+hS, right = left+wS

		//crop
		if(left<0) 		{lS-=left;left=0;} //cutting from left
		if(right>Width) {rS-=(right-width);right=width;}  //cutting from right
		if(top<0) 		{tS-=top;top=0;} 	//cutting from top
		if(bottom>Height) {bS-=(bottom-height); bottom=height;}	//cutting from bottom
//result("\nwidth "+width+" height "+height+" wS "+wS+" hS "+hS)
//result("\ntop "+top+" left "+left+" bottom "+bottom+" right "+right)
//result("\ntS "+tS+" lS "+lS+" bS "+bS+" rS "+rS)
		im[top,left,bottom,right] += ToInsert[tS,lS,bS,rS]
		}
	}

image BinningDistort112(image feature,number binX,number binY)
	{
	number wF,hF
	getSize(feature,wF,hF)
	image ToInsert
	if(binX==binY)
		{
		ToInsert:= imageclone(feature)
		ToInsert = feature
//ToInsert.showimage()
		}
	else
		{				//feature compressed in max binning direction
		if(binY>binX) 
			{
			ToInsert:= IntegerImage("ToInsert",4,1,wF,hF*binX/binY)
			ToInsert = binY/binX*warp(feature,icol,irow*binY/binX)
			}
		if(binX>binY) 
			{
			ToInsert:= IntegerImage("ToInsert",4,1,wF*binY/binX,hF)
			ToInsert = binX/binY*warp(feature,icol*binX/binY,irow)
			}
		}
	return ToInsert
	}

number GetIllumination112(number exp,number PixelSizeX,number PixelSizeY,number CameraWidth)
{		//light falling at one binned pixel										//this is for EELS 
//instrument constrains
number maxIllumination = 1000000	
number C2 = EMGetC2()
number Spot = EMGetSpotSize()

number Illum =exp*PixelSizeX*PixelSizeY*(1.3**(10-spot)) *2*maxIllumination

if(EMGetImagingOpticsMode() == "IMAGING")
	{
	Illum /=(((C2-100)/50)**2)	//dependence on C2
								//50  - standard 
								//100 - converge to point = 1000000

	if(Illum>maxIllumination) Illum = maxIllumination	//no divergence
	}
	
if(EMGetImagingOpticsMode() == "DIFFRACTION")
	{
	Illum *= 200
	Illum /= (C2/50)**2	//dependence on C2
						//50  - standard
	}
	
//EELS correction
	Illum *= CameraWidth

	
return Illum
} 


//advanced introduction of part of Camera commands
//camera manipulations

number CameraGetActiveCameraID() 
{
number CurrentCamera
GetPersistentNumberNote("CameraManager:Current Camera",CurrentCamera)
return CurrentCamera
}

void CameraSetActiveCameraID(number CamID)
{
SetPersistentNumberNote("CameraManager:Current Camera",CamID)
}

Number CameraGetNumberOfCameras()
{
TagGroup CamList
getPersistentTagGroup().TagGroupGetTagAsTagGroup(CCL_Path112(),CamList)
return CamList.TagGroupCountTags()
}

String CameraGetName(number CamID)
{
string name
GetPersistentStringNote(CCL_Path112()+":["+CamID+"]:Name",name)
return Name
}

void CameraGetSize(number CamID,number &Width,number &Height)
{
GetPersistentPointNote(CCL_Path112()+":["+CamID+"]:CCD:Active Size (pixels)",Width,Height)
}

void CameraCameraGetPixelSize(number CamID,number &XpixelSize,number &YpixelSize)
{
number W,H
CameraGetSize(CamID,W,H)
number Cam_mm =VMgetValue112("Camera:["+CamID+"]:Size_mm")
XPixelSize = Cam_mm/W
YPixelSize = Cam_mm/H
}

number sscgetsize(number &Width,number &Height)		//ND
{
CameraGetSize(CameraGetActiveCameraID(),Width,Height)
number sucess
if((width!=0)&&(height!=0)) sucess=1
else throw("Cannot find a camera")
return sucess
}

number sscgetsizeBinned(number &Width,number &Height,number binning)	//ND
{
sscgetsize(Width,Height)
if(binning>0)
	{
	Width /= binning
	Height /= binning
	}
else throw("Binning must be greater than 0 !!")
}

void CameraGetDefaultParameters(number CamID,number &exposure,number &xBin,number &yBin,number &processing,number &top,number &left,number &bottom,number &right)
{
getReadArea112(CamID,"Imaging","Acquire","Record",top,left,bottom,right)
Processing  = getProcessing112(CamID,"Imaging","Acquire","Record")
getBinning112(CamID,"Imaging","Acquire","Record",xBin,yBin)
exposure = getExposure112(CamID,"Imaging","Acquire","Record")
}

number CameraGetHeight112(string Location)		//NOT GATAN command
{
	//higher number -> higher located wide_angle
number height = 0 
if(Location=="wide_angle") height = 3
if(Location=="high_resolution") height = 2
if(Location=="filter") height = 1
return height
}

String CameraGetDeviceLocation(number CamID) 
{
string Location
GetPersistentStringNote(CCL_Path112()+"["+CamID+"]:Location",Location)
return Location
}

number CameraIsRetractable(number CamID)
{
return TagGroupDoesTagExist(getPersistentTagGroup(),lab112()+":VirtualTEM:Camera:["+CamID+"]:Inserted")
}

number CameraGetInserted(number CamID)
{
number inserted = 1
if(CameraIsRetractable(CamID)==1) inserted = VMgetValue112("Camera:["+CamID+"]:Inserted")
return inserted
}

number CameraSetInserted(number CamID,number inserted)
{
if(inserted>0) inserted =1
if(CameraIsRetractable(CamID)==1) {VMsetValue112("Camera:["+CamID+"]:Inserted",inserted);return 1;}
else if(inserted==0) return 0
}

number CameraCheckPrepared112(number CamID)		//NOT GATAN command
{
if(EMGetScreenPosition()!=2)  {result("\nscreen down");return 0;}	//screen block
number height = CameraGetDeviceLocation(CamID).CameraGetHeight112()
for(number i= 0;i<CameraGetNumberOfCameras();i++)
	{
//result("\ni "+i+" curH "+height+" location#"+CameraGetDeviceLocation(i)+"# "+CameraGetDeviceLocation(i).CameraGetHeight112())
	if(height < CameraGetDeviceLocation(i).CameraGetHeight112())
		{
		if(CameraGetInserted(i)!=0) {result("\nhigher camera inserted");return 0;} //block by heigher camera
		}
	}
if(CameraIsRetractable(CamID)) if(CameraGetInserted(CamID)!=1) 
									{
									result("\nCamera not inserted")
									return 0;	//not inserted
									}
return 1
} 

void CameraPrepareForAcquire(number CamID)
{
EMSetScreenPosition(2) //lift the screen
number height = CameraGetDeviceLocation(CamID).CameraGetHeight112()
for(number i= 0;i<CameraGetNumberOfCameras();i++)
	{
	if(height < CameraGetDeviceLocation(i).CameraGetHeight112())
		{
		if(CameraSetInserted(i,0)!=1)throw("higher located non-retractablr camera block !")  //block by non-retractable camera 
		}
	}
if(CameraIsRetractable(CamID)) CamID.CameraSetInserted(1)
} 


//service 112 commands: write image,spectrum info

void CameraSetImageInfo112(number CameraID,image &im, string IllMode,number exp,number binX,number binY,number &PixelSizeX,number  &PixelSizeY)
{
number Cam_mm = VMgetValue112("Camera:["+CameraID+"]:Size_mm")
number CameraWidth,CameraHeight
CameraGetSize(CameraID,CameraWidth,CameraHeight)
number Magnification
string units
if(IllMode == "IMAGING")
	{
	Magnification = EMGetMagnification()
	units ="nm"
	PixelSizeX = (Cam_mm/Magnification*1000000)/CameraWidth*BinX	//in nm
	PixelSizeY = (Cam_mm/Magnification*1000000)/CameraHeight*BinY	//in nm
	}
if(IllMode == "DIFFRACTION")
	{
	Magnification = EMGetCameraLength() 
	units ="1/nm"
	PixelSizeX = (Cam_mm/Magnification*1000)/CameraWidth*BinX	//in 1/nm
	PixelSizeY = (Cam_mm/Magnification*1000)/CameraHeight*BinY	//in 1/nm
	}

ImageSetDimensionCalibration(im,0,0,PixelSizeX,units,1)
ImageSetDimensionCalibration(im,1,0,PixelSizeY,units,1)

SetStringNote(im,"DataBar:Acquisition Date",GetDate(0))
SetStringNote(im,"DataBar:Acquisition Time",GetTime(1))
SetNumberNote(im,"DataBar:Exposure Time (s)",exp) 
SetStringNote(im,"Microscope Info:Name","Virtual TEM") 
SetStringNote(im,"Microscope Info:Imaging Mode",IllMode) 
if(IllMode == "IMAGING") SetNumberNote(im,"Microscope Info:Indicated Magnification",Magnification) 
if(IllMode == "DIFFRACTION") SetNumberNote(im,"Microscope Info:Indicated Magnification",Magnification) 
SetNumberNote(im,"Microscope Info:Voltage",EMgetHighTension()) 
}

void CameraSetSpectrumInfo112(image &im,number exp,number binY,number  origin,number disp)
{
origin =round(origin)
ImageSetDimensionCalibration(im,0,origin,disp,"eV",1)

SetStringNote(im,"Microscope Info:Name","Virtual TEM") 
SetNumberNote(im,"Microscope Info:Voltage",EMgetHighTension()) 

SetNumberNote(im,"EELS:Acquisition:Exposure (s)",exp)
SetStringNote(im,"EELS:Acquisition:Date",GetDate(0))
SetStringNote(im,"EELS:Acquisition:Start time",GetTime(1))

SetNumberNote(im,"EELS Spectrometer:dispersion index",IFGetActiveDispersionIndex())
SetNumberNote(im,"EELS Spectrometer:Drift tube voltage (V)",IFGetEnergyOffset(3))
SetNumberNote(im,"EELS Spectrometer:HT offset (V)",IFGetEnergyOffset(2))
SetNumberNote(im,"EELS Spectrometer:Prism offset (V)",IFGetEnergyOffset(1))
SetStringNote(im,"EELS Spectrometer:Instrument name","Virtual Filter")
}

/*   BASIC CAMERA ACQUIRE COMMAND  */

realimage CameraAcquire112(number CameraID,number Processing,number exp,number binX,number binY,number top,number left,number bottom,number right)
	{
	
//check acquisition area
top= round(top);left = round(left);bottom = round(bottom);right = round(right)
if((binX<1)||(binY<1)) throw("inline DM typically crashes when input binning is less than 1")
if((left<0)||(top<0)) throw(MisfitSize112())
if((right<left)||(bottom<top)) throw(MisfitSize112())
number CameraWidth, CameraHeight 
CameraGetSize(CameraID,CameraWidth, CameraHeight) //active size, not readout !

if((CameraWidth<(right-left)*binX)||(CameraHeight<(bottom-top)*binY)) throw(MisfitSize112())
			//top,left,bottom,right here take binnning into account

//check processing
if(Processing!=CameraGetGainNormalizedEnum())	
	{
if(Processing!=CameraGetDarkSubtractedEnum())	
		{
if(Processing!=CameraGetUnprocessedEnum())
			{
			throw("This processing type is not supported")	
			}
		}
	}

//read Info from microscope
number Defocus = EMGetFocus()
number C2 = EMGetC2()
number Spot = EMGetSpotSize()
number nHT
GetPersistentNumberNote("Microscope Info:Voltage",nHT)
number HT = VMgetvalue112("HighTension_V")
number Magnification = EMGetMagnification()
	Magnification /= 1000000
number CameraLength = EMGetCameraLength() 
	CameraLength/=1000
number AstX,AstY,AstCX,AstCY
EMGetObjectiveStigmation(AstX,AstY)
EMGetCondensorStigmation(AstCX,AstCY)
number X,Y,Z,alpha,betha
EMGetStageXY(X,Y)
Z = EMGetStageZ()
alpha= EMGetStageAlpha()
betha = EMGetStageBeta()
number ssX,ssY,isX,isY,bsX,bsY,btX,btY,driftX,driftY
EMGetStageXY(ssX,ssY)
EMGetImageShift(isX,isY)
ssX *= 1000	//convert from micron to nm
ssY *= 1000	//convert from micron to nm
isX += ssX	//stage and image shifts are summed
isY += ssY  //stage and image shifts are summed
EMGetBeamShift(bsX,bsY)
EMGetBeamTilt(btX,btY)
VMgetcouple112("StageDrift_nm",driftX,driftY)
number ATC = 0.1		//astigmatism-beamTilt coupling

//read camera info
number Xdef,Ydef,sizeDef,DefectedPixels,Saturation,temperature,Cam_mm
ReadCameraInfo112(CameraID,Xdef,Ydef,sizeDef,DefectedPixels,Saturation,temperature,Cam_mm)
	
//read particle info
number size = VMgetvalue112("Particle:Size_nm")
number sizeCore = VMgetvalue112("Particle:Size Core_nm")
number minGalo = VMgetvalue112("Particle:Galo_nm")
number Al = VMgetvalue112("Particle:Al")
number AlCore = VMgetvalue112("Particle:Al Core")
number Thickness = VMgetvalue112("Particle:Thickness")
number Transparancy = VMgetvalue112("Particle:Transparancy")

//setting the filter mode
number Mode112 = 0		//TEM
number CameraFiltered = IFGetFilterCameraID() 
if(CameraID==CameraFiltered) 
	{
	if(IFCgetFilterMode()) //0-EELS,1-TEM
		{
		if(IFGetSlitIn()) 
			{
			Mode112 = 1		//EFTEM
			}
		else Mode112 = 0
		}
	else					
		{
		Mode112= 2			//EELS
		}
	}
	
//result("\ncameraID "+CameraID+" filteredcam "+CameraFiltered+" Mode112 "+mode112+" slitIn "+IFGetSlitIn()+ " filtermode "+IFCgetFilterMode())	

//read filter information		
number SpectrumOffset,EnergyShift,EnergyAdjust,DriftTube,Eloss,wobble
number SlitIn,SlitWidth,Apperture,OffsetOn,DTon,DTwobleOn
number FEGfwhm, disp, origin, ZoomChannel,Alav
number EELSreduction = 1
if(Mode112!=0)	//imaging
	{ 
	if(IFCGetOffsetOn()) SpectrumOffset = IFGetEnergyOffset(2) 
	EnergyShift = IFGetEnergyOffset(1) 
	EnergyAdjust = IFGetEnergyOffset(4) 	
	if(IFCGetDriftTubeOn()) DriftTube = IFGetEnergyOffset(3) 
	Eloss = DriftTube + SpectrumOffset - EnergyShift - EnergyAdjust
	Apperture= IFGetActiveApperture()
	SlitWidth = IFGetSlitWidth()
	FEGfwhm = VMgetValue112("FEG:FWHM")
	}
if(Mode112==2)	//spectroscopy
	{
	EELSreduction = VMgetValue112("Filter:EELS reduction")
	disp = IFGetActiveDispersion()
	ZoomChannel = IFGetSpectroscopyZoomChannel()
	origin = ZoomChannel + (GetFEGenergy112()+Eloss)/disp
	if(IFCGetDriftTubeWobbleOn() ) wobble = IFCGetDriftTubeWobbleVoltage()

//result("\n "+Size_pix+"  "+SizeCore_pix+" "+MinGalo +"nm"+" "+MinGalo_pix+" smear "+smear+" Size0_pix "+Size0_pix)	
	Alav = GetAveragedAl112()
	}
	
//preparing image
string IllMode = EMGetImagingOpticsMode()
number Width = right-left
number Height = bottom-top
realimage im:= IntegerImage("Frame",4,1,Width,Height)
number PixelSizeX, PixelSizeY,PixelSize 
CameraSetImageInfo112(CameraID,im,IllMode,exp,binX,binY,PixelSizeX,PixelSizeY)	//pixel size returned
PixelSize = min(PixelSizeX,PixelSizeY) //minimal Pixel size choosen

//prepare simulation parameters
number ApperRadius=2*CameraHeight	//default imaging apperture
number appertureIndex = IFGetActiveApperture()
if(appertureIndex==1) ApperRadius =CameraHeight/2
if(appertureIndex==2) ApperRadius =CameraHeight/4
number Smear,CenterX,CenterY
number Size_pix,SizeCore_pix,MinGalo_pix,CenterbX,CenterbY,BeamRadius	//imaging	
number AstDir,Size0_pix,Galo,radius					//diffraction	
if(IllMode == "IMAGING")
	{
	//check STEM
	if(EMGetIlluminationMode()=="STEM")
		{
		if(OKCancelDialog("Switch to TEM ?")) EMSetIlluminationMode("TEM")
		else exit(0)
		}
		
	Size_pix = size/pixelSize/EELSreduction
	SizeCore_pix = sizeCore/pixelSize/EELSreduction
	MinGalo_pix = MinGalo/pixelSize/EELSreduction
	number eVvsNM = 2
	Smear = Defocus+Z+(HT-nHT)*eVvsNM
	if(Mode112!=0) Smear -= Eloss*eVvsNM
	Smear *= (Magnification/30/pixelSize)/EELSreduction	//in pixel
//result("\nSmear "+Smear+" HT "+HT+" nHT "+nHT)
	CenterX = DriftFeatureWithTime112(CameraWidth/binX,driftX,X,Z,Alpha,isX,PixelSizeX) - left
	CenterY = DriftFeatureWithTime112(CameraHeight/binY,-driftY,-Y,-Z,betha,-isY,PixelSizeY) - top	
	CenterbX= CameraWidth/2 + bsX/PixelSizeX*binX	//not binned
	CenterbY= CameraHeight/2 - bsY/PixelSizeY*binY	//not binned
	BeamRadius = Magnification/Cam_mm*200*0.705*CameraWidth //whole view at x100K,upper cam
	BeamRadius *= modulus(C2-100)/50 	//standard size at C2=50
//result("\nBeamRadius "+BeamRadius+" "+CameraHeight/binY*0.705)
	}
if(IllMode == "DIFFRACTION")
	{
	if(defocus!=0)  AstDir = -defocus/modulus(defocus)/1000	//direction of astigmatism
	else  AstDir = -0.001
		
	Size0_pix = 5*(C2/100)/pixelSize/EELSreduction	//diameter of the direct beam
	if(EMGetIlluminationMode()=="STEM") Size0_pix *= 3
	Galo = 0.1*Size0_pix
	Radius = 5/pixelSize				//radius of diffuse ring
	smear = Size0_pix/EELSreduction
//result("\nC2 "+C2+" Size0_pix "+Size0_pix+" AstDir "+AstDir)
	CenterX = CameraWidth/binX/2+10*btX/PixelSizeX -left
	CenterY = CameraHeight/binY/2-10*btY/PixelSizeY -top
//result("\nRadius "+Radius+" smear "+smear)
	}

//set illumination
number EELScorrection = 1
if(Mode112==2) 
	{
	if(IllMode == "IMAGING")
		{
		EELScorrection =  CameraWidth/binX*EELSreduction
		}				//merge on Camera width and on Y
	if(IllMode == "DIFFRACTION")
		{
		EELScorrection =  Size0_pix*EELSreduction
		}				//merge on direct beam and on Y
	}
number Illum = GetIllumination112(exp,PixelSizeX,PixelSizeY,EELScorrection)
	
//elastic vs inelastic scattering	
number Elas,Inel,InelCore
if(Mode112!=0) 
	{		
	Elas = Illum * ElasticIntensity112(FEGfwhm,Eloss,SlitWidth)	
	Inel = Illum * InElasticIntensity112(Eloss,SlitWidth,Al,thickness)
	InelCore = Illum * InElasticIntensity112(Eloss,SlitWidth,AlCore,thickness)
	}
else Elas = Illum 
//result("\nIllum "+Illum+" Elas "+Elas+" Inel "+Inel+" InelCore "+InelCore)	

//simulation	
if(Mode112<2) // TEM/EFTEM
	{		
	if(IllMode == "IMAGING")
		{
		image feature = -Particle112(Size_pix,MinGalo_pix,Smear,AstX+btX*ATC,AstY+btY*ATC,Elas*Transparancy)	
	
		if(Mode112==1) feature += Profile112(Size_pix,SizeCore_pix,MinGalo_pix,Smear,0,AstX+btX*ATC,AstY+btY*ATC,inel,inelCore)	
		image ToInsert = BinningDistort112(feature,binX,binY)							//2D profile
//showimage(Toinsert)	
//result("\nCenterX "+CenterX+" CenterY "+CenterY)
		InsertSubImage112(im,ToInsert,CenterX,CenterY)

		//Illuminate and set condensor
		im += Elas
//imageclone(im).showimage()
		
		if(BeamRadius<(CameraHeight*0.706)) //beam smaller than camera view
			{
			number Ast=sqrt(AstCX**2+AstCY**2)
			
			number theta 
			if(astCX<0) {astCX=-astCX; astCY=-astCY;}
			if(!(AstCX==0)) theta =atan(-AstCY/AstCX)
			else theta = 1.5708
			if(c2>100) Theta+=1.57
			
			number CT=cos(theta)
			number ST=sin(theta)	
			im=tert(sqrt( ( (((icol*binX+left)-CenterbX)*CT + ((irow*binY+top)-CenterbY)*ST)/(1+Ast) )**2+( ((irow*binY+top)-CenterbY)*CT - ((icol*binX+Left)-CenterbX)*ST)**2)>BeamRadius,0,im)
			}
		}

	if(IllMode == "DIFFRACTION")
		{	
		image beam0 = Particle112(Size0_pix,Galo,AstDir,AstX+btX*ATC,AstY+btY*ATC,Illum*(1-Transparancy))
	
		image amorph = DiffuseRing112(Radius,smear,AstDir,AstX+btX*ATC,AstY+btY*ATC,Illum*Transparancy)
		
		number w,h,w0,h0
		getSize(beam0,w0,h0)
		getSize(amorph,w,h)
		amorph[(h-h0)/2,(w-w0)/2,(h+h0)/2,(w+w0)/2] += beam0	

		image ToInsert = BinningDistort112(amorph,binX,binY)

		InsertSubImage112(im,ToInsert,CenterX,CenterY)
		}

	//apperture 		
	if(appertureIndex>0) {im = tert(sqrt((icol*binX-CameraWidth/2)**2+(irow*binY-CameraHeight/2)**2)<ApperRadius,im,0);}	
	}	

if(Mode112==2) // EELS
	{
	//always frame transfer for spectroscopy
	top += round(CameraHeight/binY/4)
	bottom += round(CameraHeight/binY/4)
	if(bottom>CameraHeight/binY*3/4) throw("The requested acquisition area doesnot fit the frame transfer readout !")
	
	//find spectrum area
	number topS,leftS,bottomS,rightS	//here local borders for spectroscopy only
	getReadArea112(CameraID,"Spectroscopy","Acquire","Acquire",topS,leftS,bottomS,rightS) //no frame transfer accounted
	topS /=binY ; leftS /=binX; bottomS /=binY; rightS /=binX
	
	//always frame transfer for spectroscopy
	topS += (CameraHeight/binY/4)
	bottomS += (CameraHeight/binY/4)
	topS =round(topS);leftS = round(leftS);bottomS =round(bottomS);rightS = round(rightS)
	
	number SpecWidth = rightS-leftS
	number SpecHeight = min(bottomS-topS,CameraHeight/binY/EELSreduction)
	SpecHeight = min(SpecHeight,ApperRadius*2/binY/EELSreduction)		
	if(IllMode == "DIFFRACTION") SpecHeight = min(SpecHeight,Size0_pix) //ZLP illumination
	SpecHeight =round(SpecHeight)
	topS = round(topS + ((bottomS-topS)-SpecHeight)/2)	//corrected for narrower area
//result("\ntop "+top+" bottom "+bottom+ " topS "+topS+" bottomS "+bottomS)
//result("\nSpecHeight "+SpecHeight+" TopS "+TopS+" centerY "+centerY)		

	//simulate spectrum
	image profile
	if(IllMode == "IMAGING") 
		{   
		profile = Profile112(Size_pix,SizeCore_pix,MinGalo_pix,Smear,2,AstX+btX*ATC,AstY+btY*ATC,Al,AlCore)																	//Vertical profile
		} 															//vertical profile
		
	if(IllMode == "DIFFRACTION")
		{   
		profile = Profile112(Size0_pix,0,MinGalo_pix,Smear,2,AstX+btX*ATC,AstY+btY*ATC,Alav,AlCore)																	//Vertical profile
 		}													//vertical profile			
	//setting at the right center	
	centerY = SpecHeight/2+(top+centerY-CameraHeight/binY/2)/EELSreduction	//transform to spec
	number ProfH,dummy
	getSize(profile,dummy,ProfH)
	number featureTop = ProfH/2 - centerY
//result("\n "+" centerY "+centerY+"  TopS "+TopS+" ProfH "+ProfH+"  featureTop  "+ featureTop)	
	image profileCrop := FlexibleSelection1DV112(profile,featureTop,featureTop+SpecHeight)
//profileCrop.showimage()
	if(!IFGetSlitIn()) SlitWidth=0
	image spectrum = Illum*GenerateSpectrum112(SpecWidth,disp,origin,EnergyAdjust,wobble,SlitWidth,FEGfwhm,thickness,profileCrop)
//spectrum.showimage() //SpecWidth x SpecHeight image

	//insert in image
	im = FlexibleSelection2D112(spectrum,top-topS,left-leftS,bottom-topS,right-leftS)	

	CameraSetSpectrumInfo112(im,exp,binY,origin,disp)
	}

//Blanking	
if(CameraCheckPrepared112(CameraID)!=1) {result("\nCamera BLOCKED");im =0;}

//dark reference and gain correction	
if(Processing==CameraGetDarkSubtractedEnum()||Processing==CameraGetUnprocessedEnum()) 
	{
	DefectedPixels =1/DefectedPixels
	image RevertedGain = IntegerImage("Rgain",4,1,Width,Height)
	RevertedGain=tert(sqrt((icol*binX-xdef*CameraWidth+Left)**2+(irow*binY-ydef*CameraHeight+top)**2)<sizeDef*CameraWidth/2,DefectedPixels,1)
	im /= RevertedGain 
	}
if(processing==CameraGetUnprocessedEnum() )
	{
	number Dark = exp*binX*binY*(2000+(temperature+20)*200)
	im += Dark	
	}	

//Saturation check
if(max(im>Saturation)) im = tert(im>Saturation,Saturation,im)

return im	
}

/**************************
SIMULATED Camera commands
**************************/	

//acquire

realimage CameraAcquire(number CamID,number exposure,number xBin,number yBin,number processing,number top,number left,number bottom,number right)
{
return CameraAcquire112(CamID,processing,exposure,Xbin,Ybin,top,left,bottom,right)
}

realimage CameraAcquire(number CamID,number exposure,number xBin,number yBin,number Processing)
{
number top,left,bottom,right
getReadArea112(CamID,"Imaging","Acquire","Record",top,left,bottom,right)
return CameraAcquire(CamID,exposure,Xbin,Ybin,processing,top/yBin,left/xBin,bottom/yBin,right/xBin)
}

realimage CameraAcquire(number CamID,number exposure,number xBin,number yBin)
{
number Processing = getProcessing112(CamID,"Imaging","Acquire","Record")
return CameraAcquire(CamID,exposure,Xbin,Ybin,processing)
}

realimage CameraAcquire(number CamID,number exposure)
{
number xBin,yBin
getBinning112(CamID,"Imaging","Acquire","Record",xBin,yBin)
return CameraAcquire(CamID,exposure,Xbin,Ybin)
}

realimage CameraAcquire(number CamID)
{
number exposure = getExposure112(CamID,"Imaging","Acquire","Record")
return CameraAcquire(CamID,exposure)
}

realimage sscUnprocessedBinnedAcquire(number exp,number bin,number t,number l,number b,number r)	//ND
{
return CameraAcquire(CameraGetActiveCameraID(),exp,bin,bin,CameraGetUnprocessedEnum(),t,l,b,r)
}

realimage sscDarkSubtractedBinnedAcquire(number exp,number bin,number t,number l,number b,number r)	//ND
{
return CameraAcquire(CameraGetActiveCameraID(),exp,bin,bin,CameraGetDarkSubtractedEnum(),t,l,b,r)
}

realimage sscGainNormalizedBinnedAcquire(number exp,number bin,number t,number l,number b,number r)	//ND
{
return CameraAcquire(CameraGetActiveCameraID(),exp,bin,bin,CameraGetGainNormalizedEnum(),t,l,b,r)
}

realimage sscUnprocessedAcquire(number exp,number t,number l,number b,number r)						//ND
{
return CameraAcquire(CameraGetActiveCameraID(),exp,1,1,CameraGetUnprocessedEnum(),t,l,b,r)
}

realimage sscDarkSubtractedAcquire(number exp,number t,number l,number b,number r)					//ND
{
return CameraAcquire(CameraGetActiveCameraID(),exp,1,1,CameraGetDarkSubtractedEnum(),t,l,b,r)
}

realimage sscGainNormalizedAcquire(number exp,number t,number l,number b,number r)			//ND
{
return CameraAcquire(CameraGetActiveCameraID(),exp,1,1,CameraGetGainNormalizedEnum(),t,l,b,r)
}

realimage AcquireSpectrum112(number exposure,number yBin,number Processing)		//NOT GATAN command
{
number CamID = IFGetFilterCameraID()
number top,left,bottom,right
getReadArea112(CamID,"Spectroscopy","Acquire","Acquire",top,left,bottom,right)
//result("\nCamID "+CamID+" "+top+" "+left+" "+bottom+" "+right)
CameraPrepareForAcquire(CamID)	
return CameraAcquire112(CamID,Processing,exposure,1,ybin,top/ybin,left,bottom/ybin,right)
}

image RenderSpectrum112(image Spec2D)			//service 112 command
{
number W,H
getSize(Spec2D,W,H)
image spec1D := realImage("",4,W,1)
spec1D[icol,0] += spec2D
number origin,disp
string unit
ImageGetDimensionCalibration(spec2D,0,origin,disp,unit,1)
ImageSetDimensionCalibration(spec1D,0,origin,disp,unit,1)
TagGroupCopyTagsFrom(ImageGetTagGroup(spec1D),ImageGetTagGroup(spec2D))
return spec1D
}


//create image

realimage CameraCreateImageForAcquire(number CamID,number xBin,number yBin,number processing,number top,number left,number bottom,number right)
{
realimage im:= IntegerImage("Frame",4,1,right-left,bottom-top)
return im
}

realimage CameraCreateImageForAcquire(number CamID,number xBin,number yBin,number processing)
{
number top,left,bottom,right
getReadArea112(CamID,"Imaging","Acquire","Record",top,left,bottom,right)
return CameraCreateImageForAcquire(CamID,xBin,yBin,processing,top/Ybin,left/Xbin,bottom/Ybin,right/Xbin)
}

realimage CameraCreateImageForAcquire(number CamID,number xBin,number yBin)
{
return CameraCreateImageForAcquire(CamID,xBin,yBin,CameraGetUnprocessedEnum())
}

realimage CameraCreateImageForAcquire(number CamID)
{
number xBin,yBin
getBinning112(CamID,"Imaging","Acquire","Record",xBin,yBin)
return CameraCreateImageForAcquire(CamID,xBin,yBin,CameraGetUnprocessedEnum())
}


//acquire in place

number CameraAcquireInPlace(number CamID,realimage &im,number exposure,number xBin,number yBin,number processing,number top,number left,number bottom,number right)
{
number W,H
getSize(im,W,H)
//result("\nw "+w+" h "+h+" bin "+Xbin+" "+Ybin+" t "+top+" l "+left+" b "+bottom+" r "+right)
if(  (trunc(right-left)!=W)   ||    (trunc(bottom-top)!=H)    ) throw(MisfitSize112())
im = CameraAcquire(CamID,exposure,xBin,yBin,processing,top,left,bottom,right)
return 1
}

number CameraAcquireInPlace(number CamID,realimage &im,number exposure,number xBin,number yBin,number processing)
{
number top,left,bottom,right
getReadArea112(CamID,"Imaging","Acquire","Record",top,left,bottom,right)
return CameraAcquireInPlace(CamID,im,exposure,Xbin,Ybin,processing,top/Ybin,left/Xbin,bottom/Ybin,right/Xbin)
}

number CameraAcquireInPlace(number CamID,realimage &im,number exposure,number xBin,number yBin)
{
number Processing  = getProcessing112(CamID,"Imaging","Acquire","Record")
//result("\nProcessing "+Processing)
return CameraAcquireInPlace(CamID,im,exposure,Xbin,Ybin,processing)
}

number CameraAcquireInPlace(number CamID,realimage &im,number exposure)
{
number xBin,yBin
getBinning112(CamID,"Imaging","Acquire","Record",xBin,yBin)
return CameraAcquireInPlace(CamID,im,exposure,Xbin,Ybin)
}

number CameraAcquireInPlace(number CamID,realimage &im)
{
number exposure = getExposure112(CamID,"Imaging","Acquire","Record")
return CameraAcquireInPlace(CamID,im,exposure)
}

void sscXYbinnedAcquireInPlace(realimage &im,number top,number left,number bottom,number right,number exposure,number xBin,number yBin,number Processing) //ND
{
CameraAcquireInPlace(CameraGetActiveCameraID(),im,exposure,xBin,yBin,processing,top,left,bottom,right)			//ND
}

void sscUnprocessedBinnedAcquireInPlace(realimage &im,number exp,number bin,number top,number left,number bottom,number right)	//ND
{
CameraAcquireInPlace(CameraGetActiveCameraID(),im,exp,bin,bin,CameraGetUnprocessedEnum(),top,left,bottom,right)
}

void sscDarkSubtractedBinnedAcquireInPlace(realimage &im,number exp,number bin,number top,number left,number bottom,number right)	//ND
{
CameraAcquireInPlace(CameraGetActiveCameraID(),im,exp,bin,bin,CameraGetDarkSubtractedEnum(),top,left,bottom,right)
}

void sscGainNormalizedBinnedAcquireInPlace(realimage &im,number exp,number bin,number top,number left,number bottom,number right)	//ND
{
CameraAcquireInPlace(CameraGetActiveCameraID(),im,exp,bin,bin,CameraGetGainNormalizedEnum(),top,left,bottom,right)
}

//reference

realimage CameraGetBlankDarkReference(number CamID,number exposure,number xBin,number yBin,number top,number left,number bottom,number right)
{
realimage im:=Integerimage("Dark Reference",4,1,(right-left),(bottom-top))
return im
}

realimage CameraGetOrAcquireDarkReference(number CamID,number exposure,number xBin,number yBin,number top,number left,number bottom,number right)
{
realimage im:=CameraGetBlankDarkReference(CamID,exposure,xBin,yBin,top,left,bottom,right)
number temperature = VMgetValue112("Camera:["+CamID+"]:Temperature")
im = exposure*Xbin*Ybin*(2000+(temperature+20)*200)
return im
}

realimage sscGetDarkReference(number exposure,number bin,number top,number left,number bottom,number right)	//ND
{
return CameraGetOrAcquireDarkReference(CameraGetActiveCameraID(),exposure,Bin,Bin,top,left,bottom,right)
}

realimage CameraGetGainReference(number CamID,number xBin,number yBin)
{
number W,H
sscgetsize(W,H)
W /= xBin
H /= yBin
realimage im:=Realimage("Gain Reference",4,W,H)	
number Xdef,Ydef,sizeDef,DefectedPixels,Saturation,temperature,CameraID,Cam_mm
ReadCameraInfo112(CamID,Xdef,Ydef,sizeDef,DefectedPixels,Saturation,temperature,Cam_mm)
im=tert(sqrt((icol-xdef*w)**2+(irow-ydef*h)**2)<sizeDef*w/2,1/DefectedPixels,1)	
return im
}

realimage sscGetGainReference(number bin) return CameraGetGainReference(CameraGetActiveCameraID(),Bin,Bin)	//ND

void CameraClearDarkReferences( ) {}	//dummy


//read, shutter

void sscBinnedRead(realimage &im,number bin,number t,number l,number b,number r)
	{
	number t0 = VMgetValue112("Shutter:open at")	
	number t = VMgetValue112("Shutter:accumulated")	
	number dt

	if(t!=0) //if shutter was opened
		{
		t = GetOSTickCount()
		dt += CalcOSSecondsBetween(t0,t)
		VMsetValue112("Shutter:open at",t) 
		}
	sscXYbinnedAcquireInPlace(im,t,l,b,r,dt,bin,bin,1)
	SetNumberNote(im,"DataBar:Exposure Time (s)",dt)	
	VMsetValue112("Shutter:accumulated",0)
	}	
	
void sscRead(realimage &im,number t,number l,number b,number r)
	{
	sscBinnedRead(im,1,t,l,b,r)
	}
	
void sscClear()
	{
	VMsetValue112("Shutter:accumulated",0)
	}

void sscOpenShutter()
	{
	number t0 = VMgetValue112("Shutter:open at")
	if(t0==0) t0 = GetOSTickCount()	//if shutter was closed
	VMsetValue112("Shutter:open at",t0)	
	}
	
void sscCloseShutter()
	{
	number t0 = VMgetValue112("Shutter:open at")
	number t
	if(t0!=0) t = GetOSTickCount() //if shutter was opened
	
	number dt = VMgetValue112("Shutter:accumulated")
	dt += CalcOSSecondsBetween(t0,t)
	VMsetValue112("Shutter:accumulated",dt)
	VMsetValue112("Shutter:open at",0)	
	}


//temperature

number CameraHasTemperatureControl(number CamID)
{
return TagGroupDoesTagExist(getPersistentTagGroup(),lab112()+":VirtualTEM:Camera:["+CamID+"]:Temperature")
}

number CameraUsesTargetTemperature(number CamID)
{
return TagGroupDoesTagExist(getPersistentTagGroup(),lab112()+":VirtualTEM:Camera:["+CamID+"]:Target Temperature")
}

number CameraGetTargetTemperature(number CamID )
{
if(CameraHasTemperatureControl(CamID) ) return VMgetValue112("Camera:["+CamID+"]:Target Temperature")
else throw("Camera "+CamID+" has no temperature control")
}

number CameraGetActualTemperature(number CamID )
{
if(CameraHasTemperatureControl(CamID) ) return VMgetValue112("Camera:["+CamID+"]:Temperature")
else throw("Camera "+CamID+" has no temperature control")
}

void CameraSetTargetTemperature(number CamID,number targetTemp)
{
VMsetValue112("Camera:["+CamID+"]:Target Temperature",targetTemp)
}

void CameraGetTemperatureRange(number CamID,number &minTemp,number &maxTemp,number &resolution)
{
if(CameraHasTemperatureControl(CamID) ) 
	{
	minTemp = VMgetValue112("Camera:["+CamID+"]:Temperature min")
	maxTemp = VMgetValue112("Camera:["+CamID+"]:Temperature max ")
	resolution = VMgetValue112("Camera:["+CamID+"]:Temperature resolution")
	}
else throw("Camera "+CamID+" has no temperature control")
}

number CameraIsTemperatureStable(number CamID )
{
number T = CameraGetTargetTemperature(CamID)
number TT =CameraGetTargetTemperature(CamID)
number R,minT,maxT 
CameraGetTemperatureRange(CamID,minT,maxT,R)
if(modulus(T-TT)<=R) return 1
else return 0
}

result(")")
