/*************************************
Pavel Potapov, virtualTEM, 2013-2014
**************************************/

result("5")

number OFFLine 
GetPersistentNumberNote("_temDM-Scripts"+":OFFLine",OFFLine);
if(OffLine!=1){result("X");throw(-128);}
 
class SimulateContinuousAcqusition112: thread
{  
object Running,StopRun
imageDocument imdoc
realimage im
ImageDisplay imDisp

Number CameraID
number binningX,binningY,exp,processing
number ImdocID,ViewCloseID
number t,l,b,r
number secstay

object init(object self,number expP,number binningXP,number binningYP,number processingP,number tP,number lP,number bP,number rP)
	{
	exp=expP
	processing = processingP
	GetPersistentNumberNote(CM_Path112()+":Current Camera",CameraID)
	
	Running = NewSignal(1)
	StopRun = NewSignal(0)
	
	CameraID = CameraGetActiveCameraID() 
	CameraPrepareForAcquire(CameraID)
	
	imdoc = ImDocID.GetImageDocumentByID()
	
	if(!Imdoc.ImageDocumentIsValid()||!(binningXP==binningX)||!(binningYP==binningY)||!(tP==t)||!(lP==l)||!(bP==b)||!(rP==r)) 
		{ 		
		t=tP;l=lP;b=bP;r=rP;binningX=binningXP;binningY=binningYP;

		im:=CameraAcquire112(CameraID,Processing,exp,binningX,binningY,t/binningY,l/binningX,b/binningY,r/binningX) 
		ImageSetName(im,"View")
		showImage(im)
		imDoc = ImageGetOrCreateImageDocument(im)
		ImDocID = imDoc.ImageDocumentGetID()
		ViewCloseID = imdoc.ImageDocumentGetWindow().WindowAddWindowListener(self,"window_closed:ViewWindowClosed;")			
		}
	
	VMsetValue112("Running ContiniousSimulator",self.ScriptObjectGetID())
 
	imdisp = im.ImageGetImageDisplay(0)	
	imDisp.ImageDisplayAddKeyListener("KeyListener","HandleKey112( key )")	
	
	secstay =0.01
	
	return self
	}
	 
void RunThread(object self)
	{
	number t0,t
	while(1)
		{		
//pausing/stopping a thread
number canceled
try {Running.waitonSignal(secstay,StopRun);} // wait secstay till Running is signed,
catch // StopRun is signed
	{
	canceled=1;              	
	if(ImageDocumentDoesImageWithIDExist(imdoc,0)) 
		{
		imdoc.ImageDocumentGetWindow().WindowRemoveWindowListener(ViewCloseID)
		}
	break;
	} 	
if(canceled==1) {exit(0);} 

		number t0=GetOSTickCount()

//result("\nbinningX "+binningX+" binningY "+binningY+" b "+b+" r "+r)
CameraAcquireInPlace(CameraID,im,exp,binningX,binningY,Processing,t/binningY,l/binningX,b/binningY,r/binningX) 	
		
//updateimage(im)
		imdisp.ImageDisplaySetContrastLimits(0,max(im))
		
		number dt = CalcOSSecondsBetween(t0,GetOSTickCount())
		if(secstay!=999999)	//if not paused during sscXY
			{
			if(exp>dt) secstay = exp-dt //during this execution cannot be  paused
			else secstay = 0.01
			}	
		Running.resetSignal() //activate secstay
		//result ("\n"+secstay)
		}
	} 	
	
void Stop(object self)
	{
	Running.resetSignal()
	StopRun.setSignal()
	}
	
void Pause(object self)
	{
	secstay =999999
	Running.resetSignal()
	}
	
void Release(object self)
	{
	secstay =0.01
	Running.setSignal()
	}

imagedocument GetImDoc(object self) return imdoc	
void SetExposure(object self,number expP) exp=expP
void IncreaseExposure(object self) {exp*=2;}
void DecreaseExposure(object self) {exp/=2;}

void ViewWindowClosed(object self, number e_fl, DocumentWindow Win)
	{	
	imDisp.ImageDisplayRemoveKeyListener( "KeyListener" ) 
//result("\nView window closed")
	Running.resetSignal()
	secstay=0.01
	StopRun.setSignal()
	}

~SimulateContinuousAcqusition112(object self) 
	{
	VMsetValue112("Running ContiniousSimulator",0)
	result("\nSimulateContinuousAcqusition destroyed")
	}
}   

result(")")