/*************************************
Pavel Potapov, virtualTEM, 2013-2014
**************************************/

result("8")

interface DSinterface
{
void RunningScan(object DSpanel);
void EnableButtons(object DSpanel,number enabled);
void EnableAll(object DSpanel,number enabled);
void Stop(object STEMsimulator);
void ResetContinuous(object STEMsimulator);
}

//Native DS commands: Parameters

Number DSCountSignals( )
{
TagGroup Ptg = GetPersistentTagGroup()
TagGroup Detectors
Ptg.TagGroupGetTagAsTagGroup(lab112()+":VirtualTEM:DigiScan:Detectors",Detectors)

return Detectors.TagGroupCountTags( )
}

TagGroup CreateSignalParam112(number Selected,number Depth,number ImageID)
{
TagGroup Signal =  NewTagGroup()

Signal.TagGroupSetTagAsShort("Depth",Depth)
Signal.TagGroupSetTagAsShort("Selected",Selected)
Signal.TagGroupSetTagAsLong("Image ID",ImageID)

return Signal
}

number DSCreateParameters(number width,number height,number rotation,number pixelTime,number lineSynchEnabled)
{
TagGroup Parameters = NewTagGroup()

Parameters.TagGroupSetTagAsLong("Width",width)
Parameters.TagGroupSetTagAsLong("Height",height)
Parameters.TagGroupSetTagAsFloat("Rotation",rotation)
Parameters.TagGroupSetTagAsFloat("Pixel Time",pixelTime)
Parameters.TagGroupSetTagAsShort("LineSynch",lineSynchEnabled)

TagGroup Signals = NewTagList()
Signals.TagGroupInsertTagAsTagGroup(1,CreateSignalParam112(0,2,0)) 
Signals.TagGroupInsertTagAsTagGroup(2,CreateSignalParam112(0,2,0))
Signals.TagGroupInsertTagAsTagGroup(3,CreateSignalParam112(0,2,0))
Parameters.TagGroupSetTagAsTagGroup("Signals",Signals)

TagGroup Ptg = GetPersistentTagGroup()
TagGroup AllParameters
Ptg.TagGroupGetTagAsTagGroup(lab112()+":VirtualTEM:DigiScan:Parameters",AllParameters)
AllParameters.TagGroupAddTagGroupAtEnd(Parameters)

return TagGroupCountTags(AllParameters)
}

TagGroup DSgetParameters112()
{
TagGroup Ptg = GetPersistentTagGroup()
TagGroup AllParameters
Ptg.TagGroupGetTagAsTagGroup(lab112()+":VirtualTEM:DigiScan:Parameters",AllParameters)

return AllParameters
}

number DSadjustParameterID112(number paramID)
{
TagGroup Ptg = GetPersistentTagGroup()
TagGroup AllParameters
Ptg.TagGroupGetTagAsTagGroup(lab112()+":VirtualTEM:DigiScan:Parameters",AllParameters)
if((paramID<=0)||(TagGroupCountTags(AllParameters)<paramID)) throw("Invalid parameters ID !")
else return (paramID-1)	//parameterID 1,2,3... while in the list it is 0,1,2...
}

number DSParametersExist(number paramID)
{
number exist = 0
try {DSadjustParameterID112(paramID);exist = 1;}
catch{break;}

return exist
}

void DSDeleteParameters(number paramID)
{
ParamID = DSadjustParameterID112(paramID)
TagGroup Ptg = GetPersistentTagGroup()
TagGroup AllParameters
Ptg.TagGroupGetTagAsTagGroup(lab112()+":VirtualTEM:DigiScan:Parameters",AllParameters)
AllParameters.TagGroupDeleteTagWithIndex(ParamID)
}

number DSGetWidth(number paramID)
{ 
TagGroup Par = DSgetParameters112()
number Width
TagGroupGetTagAsLong(Par,"["+DSadjustParameterID112(paramID)+"]:Width",Width)

return Width
}

number DSGetHeight(number paramID)
{ 
TagGroup Par = DSgetParameters112()
number Height
TagGroupGetTagAsLong(Par,"["+DSadjustParameterID112(paramID)+"]:Height",Height)

return Height
}

number DSGetPixelTime(number paramID)
{ 
TagGroup Par = DSgetParameters112()
number PixelTime
TagGroupGetTagAsFloat(Par,"["+DSadjustParameterID112(paramID)+"]:Pixel Time",PixelTime)

return PixelTime
}

number DSGetRotation(number paramID)
{ 
TagGroup Par = DSgetParameters112()
number Rotation
TagGroupGetTagAsFloat(Par,"["+DSadjustParameterID112(paramID)+"]:Rotation",Rotation)

return Rotation
}

number DSGetLineSynch(number paramID)
{ 
TagGroup Par = DSgetParameters112()
number LineSynch
TagGroupGetTagAsFloat(Par,"["+DSadjustParameterID112(paramID)+"]:LineSynch",LineSynch)

return LineSynch
}

number DSGetSignalAcquired(number paramID,number Index)
{ 
TagGroup Par = DSgetParameters112()
number Selected
TagGroupGetTagAsFloat(Par,"["+DSadjustParameterID112(paramID)+"]:Signals:["+Index+"]:Selected",Selected)

return Selected
}

number DSGetParameters(number paramID,number &width,number &height,number &rotation,number &pixelTime,number &lineSynchEnabled)
{ 
TagGroup Par = DSgetParameters112()
number exist = 0
try{ParamID = DSadjustParameterID112(paramID);exist=1;}
catch{break;}

if(exist)
	{
	TagGroupGetTagAsLong(Par,"["+paramID+"]:Width",Width)
	TagGroupGetTagAsLong(Par,"["+paramID+"]:Height",Height)
	TagGroupGetTagAsFloat(Par,"["+paramID+"]:Rotation",Rotation)
	TagGroupGetTagAsFloat(Par,"["+paramID+"]:Pixel Time",PixelTime)
	TagGroupGetTagAsFloat(Par,"["+paramID+"]:LineSynch",lineSynchEnabled)
	}
return exist
}

number DSSetParametersSignal(number paramID,number Index,number dataType,number selected,number imageID)
{
TagGroup Par = DSgetParameters112()
number exist = 0
try{ParamID = DSadjustParameterID112(paramID);exist=1;}
catch{break;}

if(exist)
	{
	TagGroupSetTagAsShort(Par,"["+paramID+"]:Signals:["+Index+"]:Selected",selected)
	TagGroupSetTagAsShort(Par,"["+paramID+"]:Signals:["+Index+"]:Depth",dataType)
	TagGroupSetTagAsLong(Par,"["+paramID+"]:Signals:["+Index+"]:Image ID",imageID)
	}
return exist
}

image DSgetParametersSignals112(number paramID)
{
TagGroup Par = DSgetParameters112()
ParamID = DSadjustParameterID112(paramID)

image Detectors:=integerimage("",2,0,5,3)
for(number j=0;j<3;j++)
	{
	number selected,dataType,imageID
	TagGroupGetTagAsShort(Par,"["+paramID+"]:Signals:["+j+"]:Selected",selected)
	TagGroupGetTagAsShort(Par,"["+paramID+"]:Signals:["+j+"]:Depth",dataType)
	TagGroupGetTagAsLong(Par,"["+paramID+"]:Signals:["+j+"]:Image ID",imageID)
	Detectors.setPixel(0,j,selected)	// 0 -selected
	Detectors.setPixel(1,j,imageID)		// 1 -imageID
	Detectors.setPixel(2,j,dataType)	// 2 -depth
	}
return Detectors
}

void ResetAllParameters112()
{
TagGroup Ptg = GetPersistentTagGroup()
TagGroup AllParameters
Ptg.TagGroupGetTagAsTagGroup(lab112()+":VirtualTEM:DigiScan:Parameters",AllParameters)

AllParameters.TagGroupDeleteAllTags()
}

//The parameters list is nullified at each new DM restart
ResetAllParameters112()


//Native DS commands: Beam position

void DSSetScanControl(number contr)
{
VMsetValue112("DigiScan:Beam control",contr)
}

number DSHasScanControl()
{
return VMgetValue112("DigiScan:Beam control")
}

number DSHasScanControl_112()
{
if(VMgetValue112("DigiScan:Beam control")) return 1
else throw("DigiScan has no beam control")
}

void DSGetBeamDSPosition(number &ds_x,number &ds_y)
{
if(DSHasScanControl_112()) VMGetCouple112("DigiScan:Beam Position",ds_x,ds_y)
}

void DSsetBeamDSPosition(number ds_x,number ds_y)
{
if(DSHasScanControl_112()) VMsetCouple112("DigiScan:Beam Position",ds_x,ds_y)
}

void DSSetBeamVertical(number ds_y )
{
if(DSHasScanControl_112()) VMsetValue112("DigiScan:Beam Position_Y",ds_y)
}

void DSSetBeamHorizontal(number ds_x)
{
if(DSHasScanControl_112()) VMsetValue112("DigiScan:Beam Position_X",ds_x)
}

void DSSetBeamAt(number ds_x,number ds_y) DSsetBeamDSPosition(ds_x,ds_y)

void DSMoveBeamTo(number ds_x,number ds_y )DSsetBeamDSPosition(ds_x,ds_y)

void DSInitBeamAt(number ds_x,number ds_y )DSsetBeamDSPosition(ds_x,ds_y)

void DSMoveBeamToCenter( ) DSsetBeamDSPosition(0,0)

void DSSetBeamToParkPosition112( )
{
number ParkX,ParkY
GetPersistentNumberNote(DigiScanPath112()+":X Beam Park Position",ParkX)
GetPersistentNumberNote(DigiScanPath112()+":Y Beam Park Position",ParkY)
VMsetCouple112("DigiScan:Beam Position",ParkX,ParkY)
}

void DSSetBeamToSafePosition( )
{
if(DSHasScanControl_112()) DSSetBeamToParkPosition112()
}

void DSPositionBeam(image dsRefImage,number x,number y )
{
number Dx,Dy
DSCalcDSCoordFromImage(dsRefImage,x,y,Dx,Dy)
DSsetBeamDSPosition(Dx,Dy)
}

//Native DS commands: Pixel Time

number DSGetMinPixelTime(number DataType,number SignalIndex)
{
return 0.5
}

number DSGetMaxPixelTime()
{
return 500000
}

number CorrectPixelTime112(number PixelTime,number DataType,number SignalIndex)
{
number minTime = DSGetMinPixelTime(DataType,SignalIndex)
number maxTime = DSGetMaxPixelTime()
if(PixelTime<minTime) PixelTime = minTime
if(PixelTime>maxTime) PixelTime = maxTime

return PixelTime
}


//Native DS commands: Acquisition commands

void DSStartAcquisition( Number paramID,number continuous,number synchronous)
{
TagGroup Par = DSgetParameters112()
number Width,Height,Rotation,PixelTime,lineSynchEnabled
if(!DSGetParameters(ParamID,Width,Height,Rotation,PixelTime,lineSynchEnabled)) throw("cannot retrive parameters !!")
//result("\n"+width+" "+height+" "+rotation+" "+pixelTime+" "+lineSynchEnabled)
image Detectors = DSgetParametersSignals112(paramID)

object 	STEMSimullator =  alloc(SimulateSTEMAcqusition112)
//synchronous, lineSynch are dummy
STEMSimullator.init(Width,Height,Detectors,Rotation,PixelTime,continuous,1,0,0).StartThread()

VMsetValue112("Running STEMsimulator ParameterID",paramID)
}

image PrepareDetectors112(number signalIndex,image refImage,image dst)
{
image Detectors:=integerimage("",2,0,5,3)
Detectors.setPixel(0,signalIndex,1)
Detectors.setPixel(1,signalIndex,dst.ImageGetID())
Detectors.setPixel(2,signalIndex,refImage.ImageGetDataElementBitSize()/8)

return Detectors
}

number DSAcquireData112(image im,number signalIndex,number pixelTime,number rotation,number lineSync,number mode)
{
PixelTime = CorrectPixelTime112(PixelTime,im.ImageGetDataElementBitSize(),SignalIndex)

im.showimage()
number Width,Height
im.getSize(Width,Height)

image Detectors = PrepareDetectors112(signalIndex,im,im)

object 	STEMSimullator =  alloc(SimulateSTEMAcqusition112)
//synchronous, lineSynch are dummy
STEMSimullator.init(Width,Height,Detectors,rotation,pixelTime,0,1,0,0).StartThread()

DSSetBeamToParkPosition112( )

return PixelTime
}

number DSAcquireData(image im,number signalIndex,number pixelTime,number rotation,number lineSync)
{
DSAcquireData112(im,signalIndex,pixelTime,rotation,lineSync,0)
}

number DSScanROI(image refImage,image dstImage,number top,number left,number bottom,number right,number pixelTime,number rotation)
{
if(!refImage.DSIsValidDSImage()) throw("reference image is not of DigiScan source !!")

number Width = right - left
number Height = bottom - top
	number w,h
	dstImage.getSize(w,h)
	if(w/h!=Width/Height)
	{
	throw("VirtualTEM does not support scanning with different XvsY scale!!")
	}
number DataSize = refImage.ImageGetDataElementBitSize()/8

dstImage.showimage()
number rotation0
GetNumberNote(refImage,STEMinfoLabel_112()+":Rotation",rotation0)
rotation += rotation0

number signalIndex
GetNumberNote(refImage,STEMinfoLabel_112()+":Signal Index",signalIndex) 
image Detectors = PrepareDetectors112(signalIndex,refImage,dstImage)

pixelTime = CorrectPixelTime112(PixelTime,dstImage.ImageGetDataElementBitSize(),SignalIndex)

number Width0,Height0
refImage.getSize(Width0,Height0)
number zoom = max(w,h)/max(Width0,Height0)*width/w
number offsetX = w/width*(Width0-left-right)/2
number OffsetY = h/height*(Height0-bottom-top)/2
object 	STEMSimullator =  alloc(SimulateSTEMAcqusition112)
//synchronous, lineSynch are dummy
STEMSimullator.init(w,h,Detectors,rotation,pixelTime,0,zoom,offsetX,offsetY).StartThread()

DSSetBeamToParkPosition112( )

return pixelTime
}

void DSScanSubRegion(image refImage,image dstImage,number top,number left,number bottom,number right,number pixelTime)
{
DSScanROI(refImage,dstImage,top,left,bottom,right,pixelTime,0)
}

void DSScanSubRegion(image refImage,image dstImage,number top,number left,number bottom,number right)
{
number PixelTime
GetNumberNote(refImage,STEMinfoLabel_112()+":Sample Time",PixelTime)
DSScanSubRegion(refImage,dstImage,top,left,bottom,right,pixelTime)
}

void DSScanSubRegion(image refImage,image dstImage,number left,number top)
{
number width,height
dstImage.getSize(width,height)
number bottom = top + height
number right = left + width
DSScanSubRegion(refImage,dstImage,top,left,bottom,right)
}

void DSScanSubRegion(image refImage,image dstImage,number left,number top,number pixelTime)
{
number width,height
dstImage.getSize(width,height)
number bottom = top + height
number right = left + width
DSScanSubRegion(refImage,dstImage,top,left,bottom,right,pixelTime)
}

number DSScanProfile(image refImage,image dstImage,number y1,number x1,number y2,number x2,number pixelTime)
{
if(!refImage.DSIsValidDSImage()) throw("reference image is not of DigiScan source !!")
number SignalIndex
GetNumberNote(refImage,STEMinfoLabel_112()+":Signal Index",signalIndex)
pixelTime = CorrectPixelTime112(PixelTime,dstImage.ImageGetDataElementBitSize(),SignalIndex)

number Width0,Height0
refImage.getSize(Width0,Height0)
number Width,Height
dstImage.getSize(Width,Height)

number x0,y0
GetNumberNote(refImage,STEMinfoLabel_112()+":Horizontal Image Center",x0)
GetNumberNote(refImage,STEMinfoLabel_112()+":Vertical Image Center",y0)

number dx = x2-x1
number dy = y2-y1
number d21S = dx**2+dy**2
number d01 = sqrt((x0-x1)**2+(y0-y1)**2)
number d02 = sqrt((x0-x2)**2+(y0-y2)**2)
number OffsetY = -(dy*x0-dx*y0-x1*y2+x2*y1)/d21S
number offsetX = (d01)/(d01+d02)-0.5
OffsetY *= Width
OffsetX *= Width

number rot0 
GetNumberNote(refImage,STEMinfoLabel_112()+":Rotation",rot0)
number rot = rot0 +atan2(dy,dx)*57.2958
//result("\nrot "+rot)
number zoom = sqrt(d21S)/Width0

SimulateSTEMprofile112(dstImage,SignalIndex,Rot,pixelTime,zoom,OffsetX,OffsetY)
return pixelTime
}

void DSRestart(number scanMode )
{
image im := getFrontImage()

number signalIndex,pixelTime,rotation,lineSync,Mode
GetNumberNote(im,STEMinfoLabel_112()+":Signal Index",signalIndex)
GetNumberNote(im,STEMinfoLabel_112()+":Sample Time",PixelTime)
GetNumberNote(im,STEMinfoLabel_112()+":Rotation",rotation)
GetNumberNote(im,STEMinfoLabel_112()+":Scan Mode",Mode)

if(scanMode==0) ScanMode = Mode
else scanMode -= 1

DSAcquireData112(im,signalIndex,pixelTime,rotation,lineSync,scanMode)
}


//Native DS commands:  Buttons

void DSInvokeButton(number buttonID,number option)
{
string AcqName
if(buttonID==1) AcqName = "Search"
if(buttonID==2) AcqName = "Preview"
if(buttonID==3) AcqName = "Record"
if((buttonID==0)||(buttonID==4))
	{
	DSRestart(option)
	VMgetValue112("VM_panel_DigiScan ID").GetScriptObjectFromID().StartThread("RunningScan")
	}
if(buttonID==5)
	{
	DSStopAcquisition(-1)
	VMgetValue112("VM_panel_DigiScan ID").GetScriptObjectFromID().EnableButtons(1)
	}
if((buttonID>0)&&(buttonID<4))	
	{
	number pTime,Width,Height,Mode, rotation
	GetPersistentNumberNote(DigiScanPath112()+":Digiscan 2:Setup:"+AcqName+":Sample Time",pTime)
	GetPersistentNumberNote(DigiScanPath112()+":Digiscan 2:Setup:"+AcqName+":Image Width",Width)
	GetPersistentNumberNote(DigiScanPath112()+":Digiscan 2:Setup:"+AcqName+":Image Height",Height)
	GetPersistentNumberNote(DigiScanPath112()+":Digiscan 2:Setup:"+AcqName+":Scan Mode",Mode)
	GetPersistentNumberNote(DigiScanPath112()+":Rotation",rotation)

	number imID
	number ParID = DSCreateParameters(Width,Height,rotation,pTime,0)
	for(number i=0;i<3;i++)  
		{
		number selected,Depth
		GetPersistentNumberNote(DigiScanPath112()+":Digiscan 2:Setup:"+AcqName+":Signal "+i+":Depth",Depth)
		GetPersistentNumberNote(DigiScanPath112()+":Digiscan 2:Setup:"+AcqName+":Signal "+i+":Selected",Selected)
		DSSetParametersSignal(parID,i,Depth,selected,imID)
		}
		
	DSStartAcquisition(parID,Mode,0)
	VMgetValue112("VM_panel_DigiScan ID").GetScriptObjectFromID().StartThread("RunningScan")
	}
}

void DSDialogEnabled(number enabled)
{
object DSpanel = VMgetValue112("VM_panel_DigiScan ID").GetScriptObjectFromID()
if(DSpanel.ScriptObjectIsValid())
	{
	DSpanel.EnableAll(enabled)
	}
}

result(")")