/*************************************
Pavel Potapov, virtualTEM, 2013-2014
**************************************/

result("2")
number OFFLine 
GetPersistentNumberNote("_temDM-Scripts"+":OFFLine",OFFLine);
if(OffLine!=1){result("X");throw(-128);}
 
/**************************
Microscope control commands
***************************/
 
//service 112 commands
void UpdateMode112(string Mode)
	{
	object Panel
	number PanelID
	//getPersistentNumberNote(Name112()+":VirtualTEM:VM_panel_II ID",PanelID)
	PanelID = VMgetvalue112("VM_panel_II ID")
	if(!PanelID==0) 
		{
		Panel = PanelID.GetScriptObjectFromID()
		if(Mode=="DIFFRACTION") 	Panel.LookUpElement("OperationMode").DLGValue(1)
		if(Mode=="IMAGING") 		Panel.LookUpElement("OperationMode").DLGValue(0)
		}
	}

number GetCameraIDfromLocation112(string Location)
{
TagGroup Ptg = GetPersistentTagGroup()
TagGroup CamList 
Ptg.TagGroupGetTagAsTagGroup(CCL_Path112(),CamList)
number CamNumber =  CamList.TagGroupCountTags()
//result("\n"+CamNumber)
for(number i=0;i<CamNumber;i++)
	{
	if(GetPersistentStringNote(CCL_Path112()+"["+i+"]:Configuration:Location")==Location)
		{
		return i
		}
	}
throw("No camera located at "+Location)
return (-1)
}
	
//SIMULATED EM commands

number EMIsReady(void) return 1

void EMWaitUntilReady(void) {}	//dummy

number EMInitialize(void) return 1		//ND

number EMIsMicroscopeInitialized(void)	return 1		//ND

void EMUpdateCalibrationState(void)  {}

TagGroup EMGetCalibrationStateTags(void)   
	{
	TagGroup Ptg = GetPersistentTagGroup()
	TagGroup CalTg
	TagGroupGetTagAsTagGroup(Ptg,"Microscope Info",CalTg)
	if(CalTg.TagGroupIsValid()) return CalTg
	else throw("No Calibration Tags in the system !!")
	}
string EMGetMicroscopeName() return "Virtual TEM"


	//Modes

string EMGetImagingOpticsMode()
	{
	string Mode
	GetPersistentStringNote(lab112()+":VirtualTEM:Operation Mode",Mode)
	
	if(Mode=="") Mode = "IMAGING"
	
	return Mode
	}
	
number EMCanGetImagingOpticsMode() 
	{
	if(EMGetImagingOpticsMode()!="") return 1
	else return 0
	}
	
number EMIsDiffractionMode(string Mode) 	//ND
	{
	if((Mode=="DIFFRACTION")&&(EMGetImagingOpticsMode()==Mode)) return 1
	else return 0
	}
	
number EMIsImagingMode(string Mode) 		//ND
	{
	if((Mode=="IMAGING")&&(EMGetImagingOpticsMode()==Mode)) return 1
	else return 0
	}
	
number EMCanGetIlluminationMode(void) return 1

string EMGetIlluminationMode()
	{
	string Mode
	GetPersistentStringNote(lab112()+":VirtualTEM:Illumination Mode",Mode)
	
	if(Mode=="") Mode = "TEM"
	
	return Mode
	}

void EMSetIlluminationMode(string Mode)
	{
	SetPersistentStringNote(lab112()+":VirtualTEM:Illumination Mode",Mode)
	}

number EMIsSTEMMode(string Mode)	//"TEM" or "STEM" input
	{
	if((Mode=="STEM")&&(EMGetIlluminationMode()==Mode)) return 1
	else return 0
	}
	
number EMIsTEMMode(string Mode)	//"TEM" or "STEM" input
	{
	if((Mode=="TEM")&&(EMGetIlluminationMode()==Mode)) return 1
	else return 0
	}

TagGroup EMGetImagingOpticsModes()
	{
	TagGroup Modes = NewTagList()
	Modes.TagGroupInsertTagAsString(0,"IMAGING")
	Modes.TagGroupInsertTagAsString(1,"DIFFRACTION")
	return Modes
	}
	
TagGroup EMGetIlluminationModes()
	{
	TagGroup Modes = NewTagList()
	Modes.TagGroupInsertTagAsString(0,"TEM")
	Modes.TagGroupInsertTagAsString(1,"STEM")
	return Modes
	}

string EMGetOperationMode()
	{
	string Mode 
	if(EMGetIlluminationMode()=="TEM") Mode = EMGetImagingOpticsMode()
	else Mode = "SCANNING"
	return Mode
	}
	
string JFEF_GetImagingOpticsMode() return EMGetImagingOpticsMode()		//ND

number JFEF_CanGetImagingOpticsMode() return EMCanGetImagingOpticsMode()//ND

number JFEF_IsDiffractionMode(string Mode) EMIsImagingMode(Mode)		//ND

number JFEF_IsImagingMode(string Mode) EMIsDiffractionMode(Mode)		//ND
	
	
	// Magnification
	
string MagTableError112(string Type) return (Type+" map is probably not right configured")

number EMgetMagIndex() return VMgetValue112("Mag index")

void EMsetMagIndex(number MagIndex) 
	{	
	TagGroup Ptg = GetPersistentTagGroup()
	if(TagGroupDoesTagExist(Ptg,lab112()+":VirtualTEM:Mag Table:["+MagIndex+"]:xM")) 
		{
		VMsetValue112("Mag index",MagIndex);
		if(EMIsImagingMode("IMAGING"))
			{
			number mag = VMgetValue112("Mag Table:["+MagIndex+"]:xM")
			UpdatePanel_112("I","Magnification",mag)
			mag *= 1000000;
			SetPersistentNumberNote("Microscope Info:Indicated Magnification",mag)
			}
		}
	else throw(MagTableError112("Magnification"))
	}
	
number EMGetMagnification() 
	{
	if(!IsTableReasonable112("Mag Table:[0]:xM")) throw(MagTableError112("Magnification"))
	number MagIndex,Mag 
	MagIndex= EMgetMagIndex()
	Mag = VMgetvalue112("Mag Table:["+MagIndex+"]:xM")	
	return mag*1000000
	}
	

number EMGetCalibratedMag(string deviceLocation,TagGroup stateInfo,number &calMag,number matchOptions)
	{
	//stateinfo is dummy
	GetCameraIDFromLocation112(deviceLocation)
	calMag = EMGetMagnification();
	return 1
	}
	
number EMGetCalibratedMag(string deviceLocation,TagGroup stateInfo,number &calMag)		//old ND
	{
	//stateinfo is dummy
	return EMGetCalibratedMag(deviceLocation,stateInfo,calMag,0)
	}

void EMSetMagnification(number Magnification) 		//ND
	{
	TagGroup Ptg = GetPersistentTagGroup()
	
	number found
	for(number i=0;i<100;i++)	//maximal 100 magnification indexes
		{
		if(TagGroupDoesTagExist(Ptg,lab112()+":VirtualTEM:Mag Table:["+i+"]:xM")) 
			{
			number mag	
			TagGroup Tmag 
			TagGroupGetTagAsTagGroup(Ptg,lab112()+":VirtualTEM:Mag Table",Tmag)  
			Tmag.TagGroupGetTagAsFloat(":["+i+"]:xM",mag)
				//result("\n"+i+" "+mag)
			if(modulus(Magnification/1000000-mag)<0.00001) 
				{
				found=1;
				EMsetMagIndex(i);
				}
			}		
		else break		
		}
		
	if(found==0) throw("Magnification map is probably not right configured")
	}
	
number EMCanGetMagnification() return IsTableReasonable112("Mag Table:[0]:xM")

number EMCanGetMagnification(number &can) 		//ND
	{
	if(IsTableReasonable112("Mag Table:[0]:xM")) {can=1;return 1;} ;
	else {can=0;return 0;} 
	}

number JFEF_GetMagnification() return EMGetMagnification()		//ND

number JFEF_CanGetMagnification() return EMCanGetMagnification()	//ND

	// Camera Length

number EMgetLengthIndex112() return VMgetValue112("Length index")

void EMsetLengthIndex112(number LengthIndex) 
	{	
	TagGroup Ptg = GetPersistentTagGroup()
	if(TagGroupDoesTagExist(Ptg,lab112()+":VirtualTEM:Length Table:["+LengthIndex+"]:m")) 
		{
		VMsetValue112("Length index",LengthIndex);
		if(EMIsDiffractionMode("DIFFRACTION"))
			{
			number Length = VMgetValue112("Length Table:["+LengthIndex+"]:m")
			UpdatePanel_112("I","Magnification",Length)
			Length *=1000;
			SetPersistentNumberNote("Microscope Info:Indicated Magnification",Length)

			}
		}
	else throw(MagTableError112("Camera Length"))
	}
	
number EMGetCameraLength() 
	{
	if(!IsTableReasonable112("Length Table:[0]:m")) throw(MagTableError112("Camera Length"))
	number LengthIndex,Length 
	LengthIndex = EMgetLengthIndex112()
	Length = VMgetvalue112("Length Table:["+LengthIndex+"]:m")	
	return Length*1000
	}
	
number EMGetCalibratedCameraLength(string deviceLocation,TagGroup stateInfo,number &calCL, number matchOptions)
	{
	//stateInfo is dummy
	GetCameraIDFromLocation112(deviceLocation)
	calCL = EMGetCameraLength();
	return 1;
	}
	
number EMGetCalibratedCameraLength(string deviceLocation,TagGroup stateInfo,number &calCL)		//old
	{
	//stateInfo is dummy
	EMGetCalibratedCameraLength(deviceLocation,stateInfo,calCL,0)
	}
	
void EMSetCameraLength(number Length) 
	{
	TagGroup Ptg = GetPersistentTagGroup()
	
	number found
	for(number i=0;i<100;i++)	//maximal 100 magnification indexes
		{
		if(TagGroupDoesTagExist(Ptg,lab112()+":VirtualTEM:Length Table:["+i+"]:m")) 
			{
			number Len
			TagGroup TLen
			TagGroupGetTagAsTagGroup(Ptg,lab112()+":VirtualTEM:Length Table",TLen)  
			TLen.TagGroupGetTagAsFloat(":["+i+"]:m",Len)
				//result("\n"+i+" "+Length)
			if(modulus(Length/1000-len)<0.001) 
				{
				found=1;
				EMsetLengthIndex112(i)
				}
			}		
		else break		
		}
	}	
	
number EMCanGetCameraLength() return IsTableReasonable112("Length Table:[0]:m")

number JFEF_GetCameraLength() return EMGetCameraLength() 		//ND

number JFEF_CanGetCameraLength()return EMCanGetCameraLength()	//ND

string JFEFGetMagUnit( void )		//ND
	{
	if(EMCanGetImagingOpticsMode()) 
		{
		string OptMode = EMGetImagingOpticsMode()  
		if(OptMode=="IMAGING") return "nm"
		if(OptMode=="DIFFRACTION") return "1/nm"
		}
	else throw("can not get Imaging optics mode !")
	}
	
	//late introduction of the last mode-command: 
	//must be here because refers to getmagnification...
void EMSetImagingOpticsMode(string Mode)	//ND
	{
	if((Mode=="IMAGING")||(Mode=="DIFFRACTION"))
		{
		SetPersistentStringNote(lab112()+":VirtualTEM:Operation Mode",Mode)
		
		UpdateMode112(Mode)
		
		number current
		if(Mode=="IMAGING") current = EMGetMagnification()/1000000
		if(Mode=="DIFFRACTION") current = EMGetCameraLength()/1000
		UpdatePanel_112("I","Magnification",current)
		}
	}

	//Focus
		
number EMGetFocus() return VMgetValue112("Defocus_nm")	

number EMGetCalibratedFocus() return EMGetFocus()

void EMSetFocus(number Defocus) 
	{
	VMsetValue112("Defocus_nm",Defocus);
	UpdatePanel_112("I","Defocus_nm",Defocus)
	}
	
void EMSetCalibratedFocus(number Defocus) EMSetFocus(Defocus) 

void EMChangeFocus(number DeltaDefocus) 
	{
	number defocus
	VMchangeValue112("Defocus_nm",DeltaDefocus,Defocus);
	UpdatePanel_112("I","Defocus_nm",Defocus)
	}
	
void EMChangeCalibratedFocus(number DeltaDefocus) EMChangeFocus(DeltaDefocus) 

number JFEF_ChangeFocus(number DeltaDefocus) //ND
	{
	EMChangeFocus(DeltaDefocus)
	return 1
	}
	
	//Illumination
				 
number EMGetC2() 						//ND
	{
	number C2 = VMgetValue112("C2")
	if(C2<5) C2=5
	return 	C2
	}
	
void EMSetC2(number C2) 					//ND
	{
	VMsetValue112("C2",C2);
	UpdatePanel_112("III","C2",C2);
	}
	
number EMGetBrightness() 
	{
	number brightness = EMGetC2()*VMgetValue112("BrightnessToC2 scale")
	return round(brightness)
	}
	
void EMSetBrightness(number brightness)	
	{
	EMSetC2(brightness/VMgetValue112("BrightnessToC2 scale"))
	}
	
number EMGetSpotSize() 
	{
	number Spot = VMgetValue112("SpotSize")
	if(Spot<1) Spot=1
	if(Spot>10) Spot=10
	return Spot
	}
	
void EMSetSpotSize(number Spot) 
	{
	Spot=trunc(Spot)
	VMsetValue112("SpotSize",Spot);
	UpdatePanel_112("III","SpotSize",Spot);
	}
	

	//objective stigmator

void EMGetObjectiveStigmation(number &stigX,number &stigY) VMGetCouple112("Obj_Stig",stigX,stigY)

void EMGetCalibratedObjectiveStigmation(number &stigX,number &stigY) EMGetObjectiveStigmation(stigX,stigY)

void EMSetObjectiveStigmation(number stigX,number stigY)  
	{
	VMsetCouple112("Obj_Stig",stigX,stigY);
	UpdatePanel_112("I","Obj_Stig_X",stigX)
	UpdatePanel_112("I","Obj_Stig_Y",stigY)
	}

void EMSetCalibratedObjectiveStigmation(number stigX,number stigY) EMSetObjectiveStigmation(stigX,stigY)  

void EMChangeObjectiveStigmation(number deltaStigX,number deltaStigY) 
	{
	number stigX,stigY
	VMchangeCouple112("Obj_Stig",deltaStigX,deltaStigY,stigX,stigY);
	UpdatePanel_112("I","Obj_Stig_X",stigX)
	UpdatePanel_112("I","Obj_Stig_Y",stigY)
	}

void EMChangeCalibratedObjectiveStigmation(number deltaStigX,number deltaStigY) EMChangeObjectiveStigmation(deltaStigX,deltaStigY) 

void EMChangeStigmation(number deltaStigX,number deltaStigY) 	//old
	{
	EMChangeObjectiveStigmation(deltaStigX,deltaStigY)
	}

number JFEF_ChangeObjectiveStigmation(number deltaStigX,number deltaStigY)//ND
	{
	EMChangeStigmation(deltaStigX,deltaStigY)
	return 1
	}


	//condensor stigmator

void EMGetCondensorStigmation(number &stigX,number &stigY) VMGetCouple112("Condensor_Stig",stigX,stigY)

void EMGetCalibratedCondensorStigmation(number &stigX,number &stigY) EMGetCondensorStigmation(stigX,stigY)

void EMSetCondensorStigmation(number stigX,number stigY)  
	{
	VMsetCouple112("Condensor_Stig",stigX,stigY);
	UpdatePanel_112("III","Condensor_Stig_X",stigX);
	UpdatePanel_112("III","Condensor_Stig_Y",stigY);
	}

void EMSetCalibratedCondensorStigmation(number stigX,number stigY) EMSetCondensorStigmation(stigX,stigY) 

void EMChangeCondensorStigmation(number deltaStigX,number deltaStigY) 
	{
	number stigX,stigY
	VMchangeCouple112("Condensor_Stig",deltaStigX,deltaStigY,stigX,stigY);
	UpdatePanel_112("I","Condensor_Stig_X",stigX)
	UpdatePanel_112("I","Condensor_Stig_Y",stigY)
	}

void EMChangeCalibratedCondensorStigmation(number deltaStigX,number deltaStigY) EMChangeCondensorStigmation(deltaStigX,deltaStigY) 

number JFEF_ChangeCondensorStigmation(number deltaStigX,number deltaStigY)	//ND
	{
	EMChangeObjectiveStigmation(deltaStigX,deltaStigY) 
	}


	//Image shift
	
void EMGetImageShift(number &shiftX,number &shiftY) VMGetCouple112("ImageShift_nm",shiftX,shiftY)

void EMGetCalibratedImageShift(number &shiftX,number &shiftY)EMGetImageShift(shiftX,shiftY)

void EMSetImageShift(number shiftX,number shiftY) 
	{
	VMsetCouple112("ImageShift_nm",shiftX,shiftY);
	UpdatePanel_112("II","ImageShift_nm_X",shiftX)
	UpdatePanel_112("II","ImageShift_nm_Y",shiftY)
	}

void EMSetCalibratedImageShift(number shiftX,number shiftY) EMSetImageShift(shiftX,shiftY)

void EMChangeImageShift(number deltaShiftX,number deltaShiftY) 	
	{
	number shiftX,shiftY
	VMchangeCouple112("ImageShift_nm",deltaShiftX,deltaShiftY,shiftX,shiftY);
	UpdatePanel_112("II","ImageShift_nm_X",shiftX)
	UpdatePanel_112("II","ImageShift_nm_Y",shiftY)
	}

void EMImageShift(number deltaShiftX,number deltaShiftY) //old	
	{
	EMChangeImageShift(deltaShiftX,deltaShiftY)
	}

void EMChangeCalibratedImageShift(number deltaShiftX,number deltaShiftY) EMChangeImageShift(deltaShiftX,deltaShiftY) 

number JFEF_ImageShift(number deltaShiftX,number deltaShiftY)	//ND
	{
	EMChangeImageShift(deltaShiftX,deltaShiftY) 
	return 1
	}


	//Beam shift

void EMGetBeamShift(number &shiftX,number &shiftY) VMGetCouple112("BeamShift",shiftX,shiftY)

void EMGetCalibratedBeamShift(number &shiftX,number &shiftY) EMGetBeamShift(shiftX,shiftY)

void EMSetBeamShift(number shiftX,number shiftY) 
	{
	VMsetCouple112("BeamShift",shiftX,shiftY);
	UpdatePanel_112("III","BeamShift_X",shiftX)
	UpdatePanel_112("III","BeamShift_Y",shiftY)
	}

void EMSetCalibratedBeamShift(number shiftX,number shiftY) EMSetBeamShift(shiftX,shiftY) 

void EMChangeBeamShift(number deltaShiftX,number deltaShiftY) 
	{
	number shiftX,shiftY
	VMchangeCouple112("BeamShift",deltaShiftX,deltaShiftY,shiftX,shiftY);
	UpdatePanel_112("III","BeamShift_X",shiftX)
	UpdatePanel_112("III","BeamShift_Y",shiftY)	
	}	

void EMBeamShift(number deltaShiftX,number deltaShiftY) //old
	{
	EMChangeBeamShift(deltaShiftX,deltaShiftY) 	
	}

void EMChangeCalibratedBeamShift(number deltaShiftX,number deltaShiftY) EMChangeBeamShift(deltaShiftX,deltaShiftY)

number JFEF_BeamShift(number deltaShiftX,number deltaShiftY)	//ND
	{
	EMChangeBeamShift(deltaShiftX,deltaShiftY) 
	return 1
	}


	//Beam tilt
	
void EMGetBeamTilt(number &tiltX,number &tiltY) VMGetCouple112("BeamTilt",tiltX,tiltY)

void EMGetCalibratedBeamTilt(number &tiltX,number &tiltY) EMGetBeamTilt(tiltX,tiltY)

void EMSetBeamTilt(number tiltX,number tiltY)
	{
	VMsetCouple112("BeamTilt",tiltX,tiltY);
	UpdatePanel_112("III","BeamTilt_X",tiltX)
	UpdatePanel_112("III","BeamTilt_Y",tiltY)
	}

void EMSetCalibratedBeamTilt(number tiltX,number tiltY) EMSetBeamTilt(tiltX,tiltY)

void EMChangeBeamTilt(number deltaX,number deltaY) 
	{
	number tiltX, tiltY
	VMchangeCouple112("BeamTilt",deltaX,deltaY,tiltX, tiltY);
	UpdatePanel_112("III","BeamTilt_X",tiltX)
	UpdatePanel_112("III","BeamTilt_Y",tiltY)	
	}

void EMChangeTilt(number deltaX,number deltaY) //old
	{
	EMChangeBeamTilt(deltaX,deltaY)	
	}

void EMChangeCalibratedBeamTilt(number deltaX,number deltaY) EMChangeBeamTilt(deltaX,deltaY) 

number JFEF_ChangeTilt(number deltaX,number deltaY) //ND
	{
	EMChangeBeamTilt(deltaX,deltaY)
	return 1
	}

	//Stage
	//Note that in TEMs X,Y values are usually in microns not nm !!
	
number EMGetStageX() return VMGetOneInCouple112("Stage_nm",0)/1000

number EMGetStageY() return VMGetOneInCouple112("Stage_nm",1)/1000

void EMGetStageXY(number &X,number &Y) 
	{
	VMGetCouple112("Stage_nm",X,Y)
	X /= 1000
	Y /= 1000
	}
	
number EMGetStageZ() return VMgetValue112("Stage_nm_Z")/1000

void EMsetStageX(number X) 
	{
	X *= 1000
	VMsetOneInCouple112("Stage_nm",X,0);
	UpdatePanel_112("I","Stage_nm_X",X)
	}

void EMsetStageY(number Y) 
	{
	Y *= 1000
	VMsetOneInCouple112("Stage_nm",Y,1);
	UpdatePanel_112("I","Stage_nm_Y",Y)
	}

void EMsetStageXY(number X,number Y)
	{
	X *= 1000
	Y *= 1000
	VMsetCouple112("Stage_nm",X,Y);
	UpdatePanel_112("I","Stage_nm_X",X)
	UpdatePanel_112("I","Stage_nm_Y",Y)
	}

void EMsetStageZ(number Z) 
	{
	Z *= 1000
	VMsetValue112("Stage_nm_Z",Z);
	UpdatePanel_112("II","Stage_nm_Z",Z)
	}

number EMGetStageAlpha() return VMGetOneInCouple112("StageTilt_grad",0)

number EMGetStageBeta() return VMGetOneInCouple112("StageTilt_grad",1)

void EMsetStageAlpha(number alpha) 
	{
	VMsetOneInCouple112("StageTilt_grad",alpha,0);
	UpdatePanel_112("II","StageTilt_grad_X",alpha)
	}

void EMsetStageBeta(number beta) 
	{
	VMsetOneInCouple112("StageTilt_grad",beta,1);
	UpdatePanel_112("II","StageTilt_grad_Y",beta)
	}

image DecomposeOn5Registers112(number Dec,number register,image in) //NOT GATAN command
{
number rest = Dec-2*trunc(Dec/2)
in.setPixel(register,0,rest)
Dec = (Dec-rest)/2
register++
if(register>4) return in
else
	{
	return DecomposeOn5Registers112(Dec,register,in)
	}
//reccurent function
}

void EMGetStagePositions(number Flags,number &X,number &Y,number &Z,number &alpha,number &beta)
	{
	image registers := integerImage("",1,0,5,1)
	registers = DecomposeOn5Registers112(Flags,0,registers)
	if(registers.getPixel(0,0)==1) X = EMGetStageX()
	if(registers.getPixel(1,0)==1) Y = EMGetStageY()
	if(registers.getPixel(2,0)==1) Z = EMGetStageZ()
	if(registers.getPixel(3,0)==1) alpha= EMGetStageAlpha()
	if(registers.getPixel(4,0)==1) beta = EMGetStageBeta()
	}
	
void EMSetStagePositions(number Flags,number &X,number &Y,number &Z,number &alpha,number &beta)
	{
	image registers := integerImage("",1,0,5,1)
	registers = DecomposeOn5Registers112(Flags,0,registers)
	if(registers.getPixel(0,0)==1) EMSetStageX(X)
	if(registers.getPixel(1,0)==1) EMSetStageY(Y)
	if(registers.getPixel(2,0)==1) EMSetStageZ(Z)
	if(registers.getPixel(3,0)==1) EMSetStageAlpha(alpha)
	if(registers.getPixel(4,0)==1) EMSetStageBeta(beta)
	}
	
	
	//Screen

number EMGetScreenPosition()
	{	//O-DOWN, 2 -UP
	number position = VMgetValue112("Screen")
	position = 2 - Position
	
	return position
	}
	
void EMSetScreenPosition(number position)	//ND
	{
	position = 2 - position
	VMsetValue112("Screen",position)
	}
	
void LEO_SetScreenDown(number screenDown) 	//ND
	{
	if(screenDown==1) EMSetScreenPosition(0)//ND
	if(screenDown==0) EMSetScreenPosition(2)//ND
	}
	
void JEOLCOM_SetScreen(number screenPos)	//ND
	{
	if(screenPos==2) EMSetScreenPosition(2)
	else EMSetScreenPosition(0)
	}
	
	//High Tension

number EMGetHighTension() return VMgetValue112("HighTension_V")

number EMCanGetHighTension() if(!(VMgetValue112("HighTension_V")==0)) return 1 else return 0

void EMSetBeamEnergy(number HT) SetPersistentNumberNote("Microscope Info:Voltage",HT)	//ND eV??

number JFEF_GetHighTension() return EMGetHighTension()			//ND

number JFEF_CanGetHighTension() return EMCanGetHighTension()	//ND

number JFEFGetBeamEnergy() return EMGetHighTension()			//ND
	
result(")")