/*************************************
Pavel Potapov, virtualTEM, 2013-2014
**************************************/

result("3")

number OFFLine 
GetPersistentNumberNote("_temDM-Scripts"+":OFFLine",OFFLine);
if(OffLine!=1){result("X");throw(-128);}

//early introducing Camera commands: definition of processing Enumeration

number CameraGetUnprocessedEnum() return 1
number CameraGetDarkSubtractedEnum() return 2
number CameraGetGainNormalizedEnum() return 3


//service 112 commands

void getReadArea112(number CameraID,string Method,string Mode,string SubMode,number &t,number &l,number &b,number &r)
	{
	//this is software defined area, not physical camera size !!
	string Path = APS_Path112(CameraID)+":"+Method+":"+Mode+":"+SubMode+":High Level:CCD Read Area"
	GetPersistentRectNote(Path,t,l,b,r)
	}

void getBinning112(number CameraID,string Method,string Mode,string SubMode,number &BinX,number &BinY)
	{
	string Path = APS_Path112(CameraID)+":"+Method+":"+Mode+":"+SubMode+":High Level:Binning"
	GetPersistentPointNote(path,BinY,BinX)
	}

number getExposure112(number CameraID,string Method,string Mode,string SubMode)
	{
	number exp 
	string Path = APS_Path112(CameraID)+":"+Method+":"+Mode+":"+SubMode+":High Level:Exposure (s)"
//result("\n"+path)
	GetPersistentNumberNote(path,exp)
	return  exp
	}
	
number getProcessing112(number CameraID,string Method,string Mode,string SubMode)
	{
	number Processing
	string Type 
	string Path = APS_Path112(CameraID)+":"+Method+":"+Mode+":"+SubMode+":High Level:Processing"
	GetPersistentStringNote(path,Type)
	if(Type=="Unprocessed") Processing = CameraGetUnprocessedEnum()
	if(Type=="Dark Subtracted") Processing = CameraGetDarkSubtractedEnum()
	if(Type=="Gain Normalized") Processing = CameraGetGainNormalizedEnum()
	return Processing
	}	

string FilterPath112(void) return (lab112()+":VirtualTEM:Filter")
	
//SIMULATED IF commands

//general

number IFVerifyCommunication(void) return 1	//always O for virtual TEM

void IFWaitForFilter(void) {}	//zero delay

number IFGetFilterCameraID(void) return VMgetValue112("Filter:CameraID")

number IFGetSpectroscopyZoomChannel(void) 
	{ 
	return VMgetValue112("Camera:["+IFGetFilterCameraID()+"]:Zoom Channel")
	}

string IFCGetInstrumentName(void)  return "Virtual Filter"		//ND

number  IFCHasTVCamera(void) return 0										//ND

number IFCGetTVIn(void) throw("there is no TV camera in virtual Filter !")	//ND

number GIFGetTVIsInserted() throw("there is no TV camera in virtual Filter !")	//ND

void GIFSetTVIsInserted(number inserted) throw("there is no TV camera in virtual Filter !")//ND

void GIFDemagnetize(number demagPrism,number demagPre,number demagPost ) {}		//ND


//configuration

number IFSaveConfiguration(void)
	{
	TagGroup ptg =GetPersistentTagGroup()
	TagGroup filter
	ptg.TagGroupGetTagAsTagGroup(FilterPath112(),filter)  
	TagGroup Temp
	if(!Ptg.TagGroupDoesTagExist(FilterPath112()+" temp")) 
		{
		Temp = NewTagList()
		Ptg.TagGroupSetTagAsTagGroup(FilterPath112()+" temp",Temp)  
		}
	else Ptg.TagGroupGetTagAsTagGroup(FilterPath112()+" temp",Temp)
	Temp.TagGroupAddTagGroupAtEnd(filter) 
 
	return (temp.TagGroupCountTags()-1) 
	}

TagGroup IFGetConfiguration(number ID)
	{
	string FilterConfigID = " temp:["+ID+"]:"
	if(ID==(-999)) FilterConfigID = ""	//"VirtualTEM:Filter", i.e. main config
	
	TagGroup ptg =GetPersistentTagGroup()
	TagGroup filter
	Ptg.TagGroupGetTagAsTagGroup(FilterPath112()+FilterConfigID,filter)
	
	return filter
	}

TagGroup IFGetConfiguration(void) return IFGetConfiguration(-999) //main config returned

number IFRestoreConfiguration(number ID)
	{
	TagGroup ptg =GetPersistentTagGroup()
	TagGroup filter = IFGetConfiguration(ID)
		
	if(filter.TagGroupIsValid())
		{
		Ptg.TagGroupSetTagAsTagGroup(FilterPath112(),filter) 
		
		return 1
		}
	else return 0
	}

void IFSetConfiguration(TagGroup Configuration)
	{
	TagGroup ptg =GetPersistentTagGroup()
	if(Configuration.TagGroupIsValid()) Ptg.TagGroupSetTagAsTagGroup(FilterPath112(),Configuration)
	}

number IFgetNumberOfConfigurations(void) 
	{
	TagGroup ptg =GetPersistentTagGroup()
	TagGroup Temps
	Ptg.TagGroupGetTagAsTagGroup(FilterPath112()+" temp",Temps)
	
	return Temps.TagGroupCountTags()
	}


//readout area

void IFGetDefaultSpectroscopyReadArea(number &top,number &left,number &bottom,number &right)
{
number CameraID = IFGetFilterCameraID()
getReadArea112(CameraID,"Spectroscopy","Acquire","Acquire",top,left,bottom,right)
number W,H
GetPersistentPointNote(CCL_Path112()+":["+CameraID+"]:CCD:Active Size (pixels)", W,H)
}


//appertures

number IFGetNumberOfApertures(void) return (VMgetValue112("Filter:max Apperture_index")+1)

string IFGetApertureLabel(number index) 
{
return GetPersistentStringNote(lab112()+":VirtualTEM:Filter"+":Apperture Table:["+index+"]:apperture") 
}

number IFGetActiveApperture(void) return VMgetValue112("Filter:Apperture_index")

void IFSetActiveAperture(number index) 
{
VMsetValue112("Filter:Apperture_index",index)
UpdatePanel_112("Filter","Apperture",index)
}

number IFGetNumberOfApertures(number dummy) return IFGetNumberOfApertures()	//old

number IFCGetNumberOfApertures() return IFGetNumberOfApertures()			//ND

string IFCGetApertureLabel(number index) return IFGetApertureLabel(index)	//ND

number IFCGetAperture(void) return (IFGetNumberOfApertures() - IFGetActiveApperture()-1)	//ND

number IFCGetActiveAperture(void) return IFGetActiveApperture()  			//ND

void IFCSetActiveAperture(number index) IFSetActiveAperture(index)			//ND

void IFCSetAperture(number index) IFCSetActiveAperture(index)				//ND


//dispersion

number IFGetNumberOfDispersions(void) return (VMgetValue112("Filter:max Dispersion_index")+1)

number IFGetActiveDispersionIndex(void) return VMgetValue112("Filter:Dispersion_index")

number IFGetDispersion(number index)
{
if(!IsTableReasonable112("Filter:Dispersion Table:[0]:eV")) throw(MagTableError112("Dispersion")) 
return VMgetvalue112("Filter:Dispersion Table:["+Index+"]:eV")
}

number IFGetActiveDispersion(void)
{
return IFGetActiveDispersionIndex().IFGetDispersion()
}

string IFGetDispersionLabel(number index) 
{
number disp = IFGetDispersion(index)
string Label =round(disp*100)/100 +""
if(left(right(Label,2),1)==".") Label += "0"
Label += " eV/pixel"
if(disp<=0.1) Label = "*"+Label 
return label
}

string IFGetActiveDispersionLabel() 
{
return IFGetActiveDispersionIndex().IFGetDispersionLabel()
}

void IFSetActiveDispersionIndex(number index) 
{
TagGroup Ptg = GetPersistentTagGroup()
if(TagGroupDoesTagExist(Ptg,lab112()+":VirtualTEM:Filter:Dispersion Table:["+Index+"]:eV")) 
	{
	VMsetValue112("Dispersion index",Index);
	VMsetValue112("Filter:Dispersion_index",index)
	UpdatePanel_112("Filter","Dispersion",index)
	}
else throw(MagTableError112("Dispersion"))
}

number IFCGetNumberOfDispersions(void) return  IFGetNumberOfDispersions()	//ND

void IFCSetActiveDispersion(number index )									//ND
{	
IFSetActiveDispersionIndex(index)
}
		//NO set dispersion by value...
		
void IFCGetDispersionInfo(number index,number &dispersion,number &isFocusedAtSlit)	//ND
{
dispersion = IFGetDispersion(index)
if (dispersion<=0.1) isFocusedAtSlit = 1
else isFocusedAtSlit = 0
}
	
void IFCGetDispersionInfo(number index,number &dispersion,number &isFocusedAtSlit,number &isHidden,string &name)
{
IFCGetDispersionInfo(index,dispersion,isFocusedAtSlit)
isHidden = 0
name = IFGetDispersionLabel(index)
}
	
number IFCGetActiveDispersion(void) return IFGetActiveDispersion()			//ND


// slit

number GIFGetSlitInsertDelay(void) return VMgetValue112("Filter:SlitDelay")	//ND

number GIFSetSlitInsertDelay(number Delay) 									//ND
	{
	VMsetValue112("Filter:SlitDelay",Delay)
	return 1
	}

number IFGetSlitIn(void) return VMgetValue112("Filter:SlitIn")

number IFSetSlitIn(number inserted)
	{
	number delay = GIFGetSlitInsertDelay()
	sleep(delay)
	VMsetValue112("Filter:SlitIn",inserted);
	UpdatePanel_112("Filter","SlitIn",inserted)
	return 1;	//succeds always
	}

number IFGetSlitWidth(void) return VMgetValue112("Filter:SlitWidth")

number IFSetSlitWidth(number SlitWidth)
	{
	VMsetValue112("Filter:SlitWidth",SlitWidth);
	UpdatePanel_112("Filter","SlitWidth",SlitWidth)
	return 1;	
	}

number IFgetMaximumSlitWidth(void) return VMgetValue112("Filter:MaxSlitWidth")

number IFCGetSlitIn(void) return IFGetSlitIn()						//ND

void IFCSetSlitIn(number inserted) 	IFSetSlitIn(inserted)			//ND				

number IFCGetSlitWidth(void) return IFGetSlitWidth()				//ND

void IFCSetSlitWidth(number Width) IFsetSlitWidth(Width)			//ND

number IFCGetMaximumSlitWidth() return IFgetMaximumSlitWidth()		//ND

void IFCSetMaximumSlitWidth(number Width) VMsetValue112("Filter:MaxSlitWidth",Width)	//ND


//Spectroscopy vs Imaging Modes 

number IFSetSpectroscopyMode(void) 
	{
	VMsetValue112("Filter:FilterMode",0)
	UpdatePanel_112("Filter","Mode",2)
	return 1
	}
	

number IFSetEELSMode(void) return IFSetSpectroscopyMode()	//old

number IFSetImagingMode(void) 
	{
	VMsetValue112("Filter:FilterMode",1)
	UpdatePanel_112("Filter","Mode",1)
	return 1
	}
number IFSetImageMode(void)	return IFSetImagingMode()		//old

number IFIsInSpectroscopyMode(void)
	{
	if(VMgetValue112("Filter:FilterMode")==0) return 1
	else return 0
	}

number IFIsInEELSMode(void) return IFIsInSpectroscopyMode()	//old

number IsInImagingMode(void)
	{
	if(VMgetValue112("Filter:FilterMode")==1) return 1
	else return 0
	}

number IFIsInImageMode(void) return IsInImagingMode()	//old

number IFSetEFTEMMode(void) 
	{
	VMsetValue112("Filter:FilterMode",1)
	VMsetValue112("Filter:SlitIn",1)
	UpdatePanel_112("Filter","SlitIn",1)
	return 1
	}

number IFSetTEMMode(void) 
	{
	VMsetValue112("Filter:FilterMode",1)
	VMsetValue112("Filter:SlitIn",0)
	IFSetActiveAperture(0)
	UpdatePanel_112("Filter","SlitIn",0)
	UpdatePanel_112("Filter","Apperture",0)
	return 1
	}

number IFHasImagingMode(void) return 1	

number IFHasSpectroscopyMode(void) return 1

number IFCGetFilterMode(void) return VMgetValue112("Filter:FilterMode")	//ND

number GIFGetFilterMode(void) return VMgetValue112("Filter:FilterMode")	//ND

void IFCSetFilterMode(number mode )					//ND
	{
	if(Mode==1) IFSetImagingMode()
	if(Mode==0) IFSetSpectroscopyMode()
	}

void GIFSetFilterMode(number mode )	IFCSetFilterMode(mode)			//ND


//energy offsets

string IFGetEnergyOffsetDescriptor(number TechID)		
	{
	if(TechID==0) throw("Virtual TEM does not support the vendor defined technigue")
	if(TechID==1) return "prism offset"
	if(TechID==2) return "HT offset"
	if(TechID==3) return "drift tube"
	if(TechID==4) return "prism adjust"
	if(TechID==5) return "DT wobbler"
	}

number IFGetEnergyOffset(number TechID)
{
return VMgetValue112("Filter:"+IFGetEnergyOffsetDescriptor(TechID)+":[1]")
}

void IFSetEnergyOffset(number TechID,number energyLoss )
{
string OffsetID = IFGetEnergyOffsetDescriptor(TechID)
VMsetValue112("Filter:"+OffsetID+":[1]",energyLoss)
if(TechID==2)	//HT offset
	{
	number nHT
	if(GetPersistentNumberNote("Microscope Info:Voltage", nHT))
		{
		VMsetValue112("HighTension_V",nHT+energyLoss)
		}
	}

UpdatePanel_112("Filter",OffsetID,energyLoss)
}

number IFSetEnergyOffsetEnabled112(number TechID,number enabled)	//Not Gatan !
{
if(enabled>1) enabled =1
if(enabled<0) enabled =0
string OffsetID = IFGetEnergyOffsetDescriptor(TechID)
VMsetValue112("Filter:"+OffsetID+":[0]",enabled)
if((TechID==2)||(TechID==3)||(TechID==5))	//prism has no "enabled"
	{
	UpdatePanel_112("Filter",OffsetID+" On",enabled)
	return 1
	}
else return 0
}

number IFGetEnergyOffsetLimits(number TechID,number &minLimit,number &maxLimit)
{
minLimit = VMgetValue112("Filter:"+IFGetEnergyOffsetDescriptor(TechID)+":[2]")
maxLimit = VMgetValue112("Filter:"+IFGetEnergyOffsetDescriptor(TechID)+":[3]")
return 1
}

number IFSupportsEnergyOffset(number TechID ) 
	{
	if((TechID==1)||(TechID==2)||(TechID==3)||(TechID==4)||(TechID==5)) return 1
	else return 0
	}
	

number IFCGetDriftTubeOn(void) return VMgetValue112("Filter:drift tube:[0]")		//ND

number GIFGetDriftTubeOn(void) return VMgetValue112("Filter:drift tube:[0]")		//ND

void IFCSetDriftTubeOn(number On) IFSetEnergyOffsetEnabled112(3,On)					//ND

void GIFSetDriftTubeOn(number On) IFSetEnergyOffsetEnabled112(3,On)					//ND

number IFCGetDriftTubeVoltage(void) return VMgetValue112("Filter:drift tube:[1]")	//ND

number GIFGetDriftTubeVoltage(void) return VMgetValue112("Filter:drift tube:[1]")	//ND

void IFCSetDriftTubeVoltage(number eV) IFSetEnergyOffset(3,eV)						//ND

void GIFSetDriftTubeVoltage(number eV) IFSetEnergyOffset(3,eV)						//ND

number IFCGetDriftTubeWobbleOn(void) return VMgetValue112("Filter:DT wobbler:[0]")	//ND

number GIFGetDriftTubeWobbleOn(void) return VMgetValue112("Filter:DT wobbler:[0]")	//ND

number IFCGetDriftTubeWobbleVoltage(void) return VMgetValue112("Filter:DT wobbler:[1]")	//ND

void IFCSetDriftTubeWobbleOn(number On) IFSetEnergyOffsetEnabled112(5,On)			//ND

void GIFSetDriftTubeWobbleOn(number On) IFSetEnergyOffsetEnabled112(5,On)			//ND

void IFCSetDriftTubeWobbleVoltage(number eV) IFSetEnergyOffset(5,eV)				//ND

number IFCGetOffsetOn(void) return VMgetValue112("Filter:HT offset:[0]")			//ND

void IFCSetOffsetOn(number On) IFSetEnergyOffsetEnabled112(2,On)					//ND

number GIFGetSpectrumOffsetOn(void) return VMgetValue112("Filter:HT offset:[0]") 	//ND

void GIFSetSpectrumOffsetOn(number On) IFSetEnergyOffsetEnabled112(2,On)			//ND

number IFCGetSpectrumOffset(void) return VMgetValue112("Filter:HT offset:[1]")		//ND

number GIFGetSpectrumOffset(void)  return VMgetValue112("Filter:HT offset:[1]")		//ND

void IFCSetSpectrumOffset(number Offset) IFSetEnergyOffset(2,Offset)				//ND

void GIFSetSpectrumOffset(number Offset) IFSetEnergyOffset(2,Offset)				//ND

number IFCGetMagneticOffsetOn(void) return VMgetValue112("Filter:prism offset:[0]")	//ND

void IFCSetMagneticOffsetOn(number On) IFSetEnergyOffsetEnabled112(1,On)			//ND

number IFCGetEnergyShift(void) return VMgetValue112("Filter:prism offset:[1]")		//ND

number GIFGetEnergyShift(void) return VMgetValue112("Filter:prism offset:[1]")		//ND

void IFCSetEnergyShift(number Shift) IFSetEnergyOffset(1,Shift)						//ND

void GIFSetEnergyShift(number Shift) IFSetEnergyOffset(1,Shift)						//ND

number IFCGetEnergyAdjust(void) return VMgetValue112("Filter:prism adjust:[1]")		//ND

number GIFGetEnergyAdjust(void) return VMgetValue112("Filter:prism adjust:[1]")		//ND

void IFCsetEnergyAdjust(number Adjust) IFSetEnergyOffset(4,Adjust) 					//ND

void GIFSetEnergyAdjust(number Adjust) IFSetEnergyOffset(4,Adjust)					//ND

void IFCGetSpectrumOffsetLimits(number &min_eV,number &max_eV) 						//ND
{
IFGetEnergyOffsetLimits(2,min_eV,max_eV)
}
	
number IFCsetSpectrumOffsetLimits(number min_eV,number max_eV)						//ND
	{
	VMsetValue112("Filter:HT offset:[2]",min_eV)
	VMsetValue112("Filter:HT offset:[3]",max_eV)
	}
	
number IFGetEnergyLoss(void)
	{
	number EnergyLoss
	if(IFCGetDriftTubeOn()) EnergyLoss += IFGetEnergyOffset(3)
	if(IFCGetOffsetOn()) EnergyLoss += IFGetEnergyOffset(2)
	if(IFCGetMagneticOffsetOn()) EnergyLoss -= IFGetEnergyOffset(1)	//prism is negative at energy-loss
	
	return EnergyLoss
	}
	
void IFSetEnergyLoss(number energy)
	{
	if(IFCGetFilterMode()==0) //EELS
		{
		IFSetEnergyOffsetEnabled112(3,1)
		if(energy<=999) IFSetEnergyOffset(3,energy)
		else 
			{
			IFSetEnergyOffset(3,999)
			IFSetEnergyOffset(1,999-energy)	//energy shift with minus
			}
		}
	else //Imaging
		{
		IFSetEnergyOffsetEnabled112(2,1)
		IFSetEnergyOffset(2,energy)
		}
	}
	
	
//late implementation of the related EM functions

number EMHasHighTensionOffset() return 1		//ND
void EMGetHighTensionOffsetRange(number &min_eV,number &max_eV ) 
	{
	IFGetEnergyOffsetLimits(2,min_eV,max_eV)
	}
	
number EMGetHighTensionOffsetEnabled() return VMgetValue112("Filter:HT offset:[0]")	//ND

void EMSetHighTensionOffsetEnabled(number enabled) 	//ND
	{
	IFSetEnergyOffsetEnabled112(2,enabled)
	}

number EMGetHighTensionOffset()	return VMgetValue112("Filter:HT offset:[1]")	//ND

void EMSetHighTensionOffset(number offset ) 		//ND
	{
	IFsetEnergyOffset(2,offset)	
	}

number LEO_GetEnergyLoss()	return IFGetEnergyLoss()

void LEO_SetEnergyLoss(number energyLoss_eV) IFSetEnergyLoss(energyLoss_eV)

number JFEFGetEnergyLoss() return IFGetEnergyLoss()

void JFEFSetEnergyLoss(number energyLoss_eV) IFSetEnergyLoss(energyLoss_eV)	


//delay

number GIFGetEnergyShiftDelay(void) return VMgetValue112("Filter:EnergyShiftDelay") //ND

number GIFSetEnergyShiftDelay(number Delay) 						//ND
	{
	VMsetValue112("Filter:EnergyShiftDelay",Delay)
	return 1
	}

number IFCGetEnergy(void)	return EMgetHighTension()/1000	//(in kV) ND

number IFCGetPrimaryEnergy(void)return EMgetHighTension()/1000		//ND

number GIFGetPrimaryEnergy(void) return EMgetHighTension()/1000		//ND

void IFCSetEnergy(number energy) VMsetValue112("HighTension_V",energy*1000)	//presumably kV, never tried

number IFCGetMaximumBeamEnergy(void) return  IFCGetEnergy()	//ND

number IFCIsDriftTubeCalibrated() return 1							//ND



/*******************************
EELSpectrum service 112 commands
********************************/	
number eVtoCh112(number eV,number origin,number disp,number pos)
{
return origin*pos + eV/disp 
}

image eVtoCh112(image eV,number origin,number disp,number pos,number w)
{
number h,dummy
eV.getSize(dummy,h)

image Ch:=realimage("",4,w,h)
Ch = origin*pos + eV[0,irow]/disp 

return Ch
}

number GetFEGenergy112(void)
{
number tick0 = 	VMgetValue112("FEG:timeTick") 
number tick = GetOSTickCount()
number energy0 = VMgetValue112("FEG:Energy_eV") 
number drift = 	VMgetValue112("FEG:Energy Drift_eVPh") 
number rippleSigma = VMgetValue112("FEG:Energy Ripple_sigma_eV") 

number dt = CalcOSSecondsBetween(tick0,tick)/60
number energy = energy0 + drift*dt 
VMsetValue112("FEG:timeTick",tick)
VMsetValue112("FEG:Energy_eV",energy)

energy += GaussianRandom()*rippleSigma

return energy
}

number GetAveragedAl112(void)
{
number size = VMgetvalue112("Particle:Size_nm")
number sizeCore = VMgetvalue112("Particle:Size Core_nm")
number Al = VMgetvalue112("Particle:Al")
number Alcore = VMgetvalue112("Particle:Al Core")

return (Al*(size-sizeCore) + Alcore*sizeCore) /size
}

image GenerateZLP112(number w,number disp,number origin,image ZeV,number ZWeV)
{
number h,dummy
ZeV.getSize(dummy,h)

image z = eVtoCh112(ZeV,origin,disp,1,w)				// [wxh] image
number zW = eVtoCh112(ZWeV,origin,disp,0)/2/1.1774		//FWHM -> sigma
image spec := realimage("spectrum",4,w,h)

//ZLP 
spec = exp(-((icol-z)/zW)**2/2)/sqrt(2*3.14151)/zW	//Gauss function 
//ImageSetDimensionCalibration(spec,0,origin,disp,"eV",1)

return spec
}

image GenerateZLP112(number w,number disp,number origin,number ZWeV)
{
image Zsingle:= realimage("",4,1,1)
Zsingle = 0

return GenerateZLP112(w,disp,origin,Zsingle,ZWeV)
}

image GenerateLossSpectrum112(number w,number disp,number origin,number thickness,image Al)
{
//predefined numbers
number AlpEeV = 16
number OpEeV = 29
number AlpWeV = 5
number OpWeV = 22
number OEeV = 532
number AlEeV = 1560
number k = 5 

number h,dummy
Al.getSize(dummy,h)
image spec := realimage("spectrum",4,w,h)

image O = 1-Al
image PEeV = Al*AlpEeV+O*OpEeV 						// [1xh] image
image PWeV = Al*AlpWeV+O*OpWeV 						// [1xh] image
image pE = eVtoCh112(PEeV,origin,disp,1,w) 			// [wxh] image
image pW = eVtoCh112(pWev,origin,disp,0,w)/2/1.1774	// [wxh] image		//FWHM -> sigma	
image thick = Imageclone(Al)						// [1xh] image
thick = tert(Al>0.4,thickness,Al*thickness)
image th = realimage("",4,w,h)						// [wxh] image	
th = thick[0,irow]
												
//plasmon
spec = (exp(th)-1)*exp(-((icol-pE)/pW)**2/2)/pW /sqrt(2*3.14151)

//power low
image pH := realimage("",4,w,h) 				
pH =(exp(th)-1) *2.25*0.3247/sqrt(2*3.14151) *pW  //*zWev*th/pWev[0,irow]	// [wxh] image
image Power := realimage("",4,w,h)
Power = pH	*(1/((icol-pE))**2) 			// [wxh] image
spec = tert(icol>(pE+1.5*pW),Power,spec)

//O K edge										
image Oh =O*thick*k								// [1xh] image
number OE = eVtoCh112(OEeV,origin,disp,1)
number StartO = max(OE,0)
if(StartO<W) spec[0,StartO,h,w] += Oh[0,irow]*(1/((icol+(StartO-origin))*disp)**2)  

//Al K edge
image Alh = Al*thick*k								// [1xh] image
number AlE = eVtoCh112(AlEeV,origin,disp,1)
number StartAl = max(AlE,0)
if(StartAl<W) spec[0,StartAl,h,w] += Alh[0,irow]*(1/((icol+(StartAl-origin))*disp)**2) 

//ImageSetDimensionCalibration(spec,0,origin,disp,"eV",1)

return spec
}

image GenerateLossSpectrum112(number w,number disp,number origin,number th,number Al)
{
image Alsingle:= realimage("",4,1,1)
Alsingle = Al

return GenerateLossSpectrum112(w,disp,origin,th,Alsingle)
}

image AddWobbler(image spec, number wobble,number disp)
{
image wob = spec.imageclone() 
wob = spec[icol-wobble/disp,irow]

spec += wob
spec /= 2

return spec
}

image GenerateSpectrum112(number w,number disp,number origin,number adjust,number wobble,number slit,number ZWeV,number th,image Al)
{
image ZeV = imageclone(Al)
ZeV=0	//No variation of ZLP position

number origin_A = origin + ((GetFEGenergy112())+adjust)/disp
image spec := GenerateZLP112(w,disp,origin_A,ZeV,ZWeV)
spec += GenerateLossSpectrum112(w,disp,origin_A,th,Al)

ImageSetDimensionCalibration(spec,0,origin,disp,"eV",1)

if(Wobble!=0) spec = AddWobbler(spec,wobble,disp)

if(Slit!=0) 
	{
	number dummy,h
	ZeV.getSize(dummy,h)
	number left = origin - Slit/2/disp
	number right = origin + Slit/2/disp
	if(left>0) if(left<w) spec[0,0,h,left]=0 ; else spec =0
	if(right<w) if(right>0) spec[0,right,h,w]=0 ; else spec =0
	}

return spec
}

image GenerateSpectrum112(number w,number disp,number origin,number adjust,number wobble,number slit,number ZWeV,number th,number Al)
{
image Alsingle:= realimage("",4,1,1)
Alsingle = Al

return GenerateSpectrum112(w,disp,origin,adjust,wobble,slit,ZWeV,th,Alsingle)
}

number FilteredInt112(image spec,number disp,number origin,number Eev,number WeV)
{
number w,h
getSize(spec,w,h)

number Eo = eVtoCh112(EeV,origin,disp,1) - eVtoCh112(Wev,origin,disp,0)/2
number Ef = eVtoCh112(EeV,origin,disp,1) + eVtoCh112(Wev,origin,disp,0)/2
if(Eo<0) Eo=0
if(Ef>W) Ef=W
if(Eo>W) return 0
if(Ef<0) return 0
return sum(spec[0,Eo,h,Ef])
}

number ElasticIntensity112(number ZWeV,number Eloss,number SlitWidth)
{
number width= 512
number disp =0.01
width= max(width,4*zWeV/disp)
number origin = width/2-Eloss/disp
image im := GenerateZLP112(width,disp,origin,ZWeV)
return im.FilteredInt112(disp,origin,Eloss,slitWidth)
}

number InElasticIntensity112(number Eloss,number SlitWidth,number Al,number thickness)
{
number width= 512
number disp = 0.1
width= max(width,SlitWidth/disp)
number origin = width/2-Eloss/disp

image im := GenerateLossSpectrum112(width,disp,origin,thickness,Al)
return im.FilteredInt112(disp,origin,Eloss,slitWidth)
}

/*******************************/
result(")")									