/*************************************
Pavel Potapov, virtualTEM, 2013-2014
**************************************/

result("18")

number OFFLine 
GetPersistentNumberNote("_temDM-Scripts"+":OFFLine",OFFLine);
if(OffLine!=1){result("X");throw(-128);}


//panel simulating DigiScan control

class DigiScan112 : UIFrame
{
TagGroup CreateDSsetup(object self,string Name)
	{
	TagGroup DSsetup = DLGCreateDialog("")
	number t,Width,Height,det0,det1,det2
	GetPersistentNumberNote(DigiScanPath112()+":Digiscan 2:Setup:"+Name+":Sample Time",t)
	GetPersistentNumberNote(DigiScanPath112()+":Digiscan 2:Setup:"+Name+":Image Width",Width)
	GetPersistentNumberNote(DigiScanPath112()+":Digiscan 2:Setup:"+Name+":Image Height",Height)
	GetPersistentNumberNote(DigiScanPath112()+":Digiscan 2:Setup:"+Name+":Signal 0:Selected",det0)
	GetPersistentNumberNote(DigiScanPath112()+":Digiscan 2:Setup:"+Name+":Signal 1:Selected",det1)
	GetPersistentNumberNote(DigiScanPath112()+":Digiscan 2:Setup:"+Name+":Signal 2:Selected",det2)
	
	DSsetup.DLGAddElement(DLGCreatePushButton(Name, "Start"+Name).DLGidentifier("start"+Name))
	DSsetup.DLGAddElement(DLGCreateRealField(t,7,2,"Change_time_"+Name))
	DSsetup.DLGAddElement(DLGCreateIntegerField(Width,7,"Change_width_"+Name))
	DSsetup.DLGAddElement(DLGCreateIntegerField(Height,7,"Change_height_"+Name))
	DSsetup.DLGAddElement(DLGCreateCheckbox("det 0",det0,"Change_det0_"+Name))
	DSsetup.DLGAddElement(DLGCreateCheckbox("det 1",det1,"Change_det1_"+Name))
	DSsetup.DLGAddElement(DLGCreateCheckbox("det 2",det2,"Change_det2_"+Name))
	
	return DSsetup
	}
	
TagGroup CreateDSbuttons(object self)
	{
	TagGroup DSButtons = DLGCreateBox("").DLGTableLayout(3,1,0).DLGidentifier("AllButtons")

	DSButtons.DLGAddElement(self.CreateDSsetup("Search"))
	DSButtons.DLGAddElement(self.CreateDSsetup("Preview"))
	DSButtons.DLGAddElement(self.CreateDSsetup("Record"))
	
	return DSButtons
	}
	
TagGroup CreateRotation(object self)
	{
	TagGroup DSrotation = DLGCreateDialog("").DLGTableLayout(2,1,1).DLGidentifier("Rotation")
	DSrotation.DLGAddElement(DLGCreateLabel("rotation (grad)").DLGAnchor("East"))
	DSrotation.DLGAddElement(DLGCreateRealField(DSGetRotation(),8,2,"ChangeRotation"))
	
	return DSrotation
	}

TagGroup CreateDSExtraButtons(object self)
	{
	TagGroup DSrotation = DLGCreateDialog("").DLGTableLayout(3,1,1).DLGidentifier("Rotation")
	DSrotation.DLGAddElement(DLGCreateLabel("         ").DLGAnchor("East"))
	DSrotation.DLGAddElement(DLGCreatePushButton("Restart", "Restart").DLGidentifier("restart").DLGAnchor("East"))
	DSrotation.DLGAddElement(DLGCreatePushButton("Stop", "Stop").DLGidentifier("stop").DLGEnabled(0).DLGAnchor("East"))
	
	return DSrotation
	}
	
TagGroup CreateDigiScan(object self)
	{
	TagGroup DigiScan = DLGCreateDialog("DigiScan")

	DigiScan.DLGAddElement(self.CreateRotation())
	DigiScan.DLGAddElement(self.CreateDSbuttons())
	DigiScan.DLGAddElement(self.CreateDSExtrabuttons())
		
	return DigiScan
	}
	
object init (object self)
	{		
	self.init( self.CreateDigiScan() );
	
	display(self,"Virtual DigiScan");
	
	VMsetValue112("VM_panel_DigiScan ID",self.ScriptObjectGetID())
	
	return self
	}

void EnableButtons(object self,number enabled)
	{
	self.SetElementIsEnabled("startSearch",enabled)
	self.SetElementIsEnabled("startPreview",enabled)	
	self.SetElementIsEnabled("startRecord",enabled)
	self.SetElementIsEnabled("restart",enabled)
	self.SetElementIsEnabled("stop",!enabled)
	}	
	
void RunningScan(object self)
	{
	self.EnableButtons(0)
	DSwaitUntilFinished()
	self.EnableButtons(1)
	}	
	
void EnableAll(object self,number enabled)
	{
	self.SetElementIsEnabled("DigiScanPanel",enabled) 
	self.SetElementIsEnabled("AllButtons",enabled)
	}
	
void StartSearch(object self)
	{
	DSInvokeButton(1,0)
	}

void StartPreview(object self)
	{
	DSInvokeButton(2,0)
	}
	
void StartRecord(object self)
	{
	DSInvokeButton(3,0)
	}

void Restart(object self)
	{
	DSInvokeButton(4,0)
	}
	
void Stop(object self)
	{
	DSInvokeButton(5,0)
	}

void ChangeValue(object self,TagGroup Tg,String ValuePath)
	{
	number Value = tg.DLGGetValue()
	SetPersistentNumberNote(DigiScanPath112()+":"+ValuePath,Value)
	}

void ChangeRotation(object self,TagGroup Tg) self.ChangeValue(Tg,"Rotation")
		
void Change_time_Search(object self,TagGroup Tg) self.ChangeValue(Tg,"Digiscan 2:Setup:Search:Sample Time")	
void Change_width_Search(object self,TagGroup Tg) self.ChangeValue(Tg,"Digiscan 2:Setup:Search:Image Width")
void Change_height_Search(object self,TagGroup Tg) self.ChangeValue(Tg,"Digiscan 2:Setup:Search:Image Height")
void Change_det0_Search(object self,TagGroup Tg) self.ChangeValue(Tg,"Digiscan 2:Setup:Search:Signal 0:Selected")
void Change_det1_Search(object self,TagGroup Tg) self.ChangeValue(Tg,"Digiscan 2:Setup:Search:Signal 1:Selected")
void Change_det2_Search(object self,TagGroup Tg) self.ChangeValue(Tg,"Digiscan 2:Setup:Search:Signal 2:Selected")

void Change_time_Preview(object self,TagGroup Tg) self.ChangeValue(Tg,"Digiscan 2:Setup:Preview:Sample Time")	
void Change_width_Preview(object self,TagGroup Tg) self.ChangeValue(Tg,"Digiscan 2:Setup:Preview:Image Width")
void Change_height_Preview(object self,TagGroup Tg) self.ChangeValue(Tg,"Digiscan 2:Setup:Preview:Image Height")
void Change_det0_Preview(object self,TagGroup Tg) self.ChangeValue(Tg,"Digiscan 2:Setup:Preview:Signal 0:Selected")
void Change_det1_Preview(object self,TagGroup Tg) self.ChangeValue(Tg,"Digiscan 2:Setup:Preview:Signal 1:Selected")
void Change_det2_Preview(object self,TagGroup Tg) self.ChangeValue(Tg,"Digiscan 2:Setup:Preview:Signal 2:Selected")

void Change_time_Record(object self,TagGroup Tg) self.ChangeValue(Tg,"Digiscan 2:Setup:Record:Sample Time")	
void Change_width_Record(object self,TagGroup Tg) self.ChangeValue(Tg,"Digiscan 2:Setup:Record:Image Width")
void Change_height_Record(object self,TagGroup Tg) self.ChangeValue(Tg,"Digiscan 2:Setup:Record:Image Height")
void Change_det0_Record(object self,TagGroup Tg) self.ChangeValue(Tg,"Digiscan 2:Setup:Record:Signal 0:Selected")
void Change_det1_Record(object self,TagGroup Tg) self.ChangeValue(Tg,"Digiscan 2:Setup:Record:Signal 1:Selected")
void Change_det2_Record(object self,TagGroup Tg) self.ChangeValue(Tg,"Digiscan 2:Setup:Record:Signal 2:Selected")

~DigiScan112(object self)
	{
	VMsetValue112("VM_panel_DigiScan ID",0)
	}
	
}

result(")")