/*************************************
Pavel Potapov, virtualTEM, 2013-2014
**************************************/

result("17")

number OFFLine 
GetPersistentNumberNote("_temDM-Scripts"+":OFFLine",OFFLine);
if(OffLine!=1){result("\X");throw(-128);}


//panel simulting GIF control
 
class Filter112 : UIFrame
{
number PrimEnergy,EnergyShift,EnergyAdjust,HToffset,DT,DTwobble
number OffsetOn,DTon,DTwobbleOn,SlitIn
number SlitWidth,AppIndex,dispIndex
number Mode


number GetBinningList(object self,number Binning)
	{
	number BinningTable = Binning
	if(Binning==5) BinningTable = 3
	if(Binning==13) BinningTable = 4
	if(Binning==26) BinningTable = 5
	if(Binning==65) BinningTable = 6
	if(Binning==130) BinningTable = 7
	
	return BinningTable
	}
	
number SetBinningList(object self,number BinningTable)
	{
	number Binning = BinningTable
	if(BinningTable==3) Binning = 5
	if(BinningTable==4) Binning = 13
	if(BinningTable==5) Binning = 26
	if(BinningTable==6) Binning = 65
	if(BinningTable==7) Binning = 130
	
	return Binning
	}
	
number GetModeList(object self,number Mode)
	{
	number ModeIndex
	if(Mode==0) ModeIndex = 2
	if(Mode==1) ModeIndex = 1
	
	return ModeIndex
	}
number SetModeList(object self,number ModeIndex)
	{
	number Mode
	
	if(ModeIndex==2) Mode = 0
	if(ModeIndex==1) Mode = 1
	
	return Mode
	}

number GetDispersionList(object self,number DispIndex)
	{
	number dispList = DispIndex + 1
	
	return dispList
	}
number SetDispersionList(object self,number DispList)
	{
	number dispIndex = DispList -1
	
	return dispIndex
	}

	
TagGroup CreateOffsets(object self)
	{
	TagGroup Offsets = DLGCreateBox("offsets").DLGTableLayout(4,7,0)
	
	Offsets.DLGAddElement(DLGCreateLabel(""))
	Offsets.DLGAddElement(DLGCreateLabel("Primary Energy").DLGAnchor("East"))
	Offsets.DLGAddElement(DLGCreateLabel(""+PrimEnergy))
	Offsets.DLGAddElement(DLGCreateLabel("keV"))

	Offsets.DLGAddElement(DLGCreateLabel(""))
	Offsets.DLGAddElement(DLGCreateLabel("Energy Shift").DLGAnchor("East"))
	Offsets.DLGAddElement(DLGCreateRealField(EnergyShift,6,2,"ChangePrismOffset").DLGIdentifier("prism offset"))
	Offsets.DLGAddElement(DLGCreateLabel("eV"))

	Offsets.DLGAddElement(DLGCreateLabel(""))
	Offsets.DLGAddElement(DLGCreateLabel("Adjust").DLGAnchor("East"))
	Offsets.DLGAddElement(DLGCreateRealField(EnergyAdjust,6,2,"ChangePrismAdjust").DLGIdentifier("prism adjust"))
	Offsets.DLGAddElement(DLGCreateLabel("eV"))

	Offsets.DLGAddElement(DLGCreateCheckbox("",OffsetOn,"ChangeHTon").DLGIdentifier("HT offset On"))
	Offsets.DLGAddElement(DLGCreateLabel("Spectrum Offset").DLGAnchor("East"))
	Offsets.DLGAddElement(DLGCreateRealField(HToffset,6,2,"ChangeHTOffset").DLGIdentifier("HT offset"))
	Offsets.DLGAddElement(DLGCreateLabel("eV"))

	Offsets.DLGAddElement(DLGCreateCheckbox("",DTon,"ChangeDTon").DLGIdentifier("drift tube on"))
	Offsets.DLGAddElement(DLGCreateLabel("Drift Tube").DLGAnchor("East"))
	Offsets.DLGAddElement(DLGCreateRealField(DT,6,2,"ChangeDriftTube").DLGIdentifier("drift tube"))
	Offsets.DLGAddElement(DLGCreateLabel("eV"))

	Offsets.DLGAddElement(DLGCreateCheckbox("",DTwobbleOn,"ChangeWobbleron").DLGIdentifier("DT wobbler On"))
	Offsets.DLGAddElement(DLGCreateLabel("Wobble").DLGAnchor("East"))
	Offsets.DLGAddElement(DLGCreateRealField(DTwobble,6,2,"ChangeDTwobbler").DLGIdentifier("DT wobbler"))
	Offsets.DLGAddElement(DLGCreateLabel("eV"))
	
	Offsets.DLGAddElement(DLGCreateCheckbox("",SlitIn,"ChangeSlitIn").DLGIdentifier("SlitIn"))
	Offsets.DLGAddElement(DLGCreateLabel("slit in        Width").DLGAnchor("East"))
	Offsets.DLGAddElement(DLGCreateRealField(SlitWidth,6,2,"ChangeSlitWidth").DLGIdentifier("SlitWidth").DLGAnchor("West"))
	Offsets.DLGAddElement(DLGCreateLabel("eV"))
	
	return Offsets
	}

TagGroup CreateLeftPart(object self)
	{
	TagGroup LeftPart = DLGCreateDialog("")
	LeftPart.DLGAddElement(self.CreateOffsets())
	
	return LeftPart
	}
	
TagGroup CreateControl(object self)
	{
	TagGroup Control = DLGCreateBox("").DLGTableLayout(2,3,0)
	
	Control.DLGAddElement(DLGCreateLabel("Mode").DLGAnchor("East"))	
	TagGroup ModeItem
	Control.DLGAddElement(DLGCreatePopup(ModeItem,self.getModeList(Mode),"ChangeFilterMode").DLGIdentifier("Mode"))
					ModeItem.DLGAddPopupItemEntry("Imaging")
					ModeItem.DLGAddPopupItemEntry("Spectroscopy")	
	
	Control.DLGAddElement(DLGCreateLabel("Dispersion").DLGAnchor("East"))
	TagGroup DispItem		
	Control.DLGAddElement(DLGCreatePopup(DispItem,self.getDispersionList(dispIndex),"ChangeDispersion").DLGIdentifier("Dispersion").DLGAnchor("West"))
					DispItem.DLGAddPopupItemEntry("1.00 eV/pixel")
					DispItem.DLGAddPopupItemEntry("0.50 eV/pixel")
					DispItem.DLGAddPopupItemEntry("0.30 eV/pixel")
					DispItem.DLGAddPopupItemEntry("0.20 eV/pixel")
					DispItem.DLGAddPopupItemEntry("*0.10 eV/pixel")
					DispItem.DLGAddPopupItemEntry("*0.05 eV/pixel")
					DispItem.DLGAddPopupItemEntry("*0.03 eV/pixel")
					DispItem.DLGAddPopupItemEntry("*0.02 eV/pixel")
					DispItem.DLGAddPopupItemEntry("*0.01 eV/pixel")	
	
	Control.DLGAddElement(DLGCreateLabel("Apperture").DLGAnchor("East"))
	TagGroup AppertItem		
	Control.DLGAddElement(DLGCreatePopup(AppertItem,AppIndex+1,"ChangeApperture").DLGIdentifier("Apperture").DLGAnchor("West"))
					AppertItem.DLGAddPopupItemEntry("Imaging")
					AppertItem.DLGAddPopupItemEntry("5 mm")
					AppertItem.DLGAddPopupItemEntry("2.5 mm")
		
	return control
	}

TagGroup CreateAcquisition(object self,string Type,number exp,number bin)
	{
	TagGroup Acquisition = DLGCreateBox(Type+" spectrum").DLGTableLayout(2,3,0)

	Acquisition.DLGAddElement(DLGCreateLabel("").DLGAnchor("East"))
	Acquisition.DLGAddElement(DLGCreatePushButton(Type, "Fire"+Type))	
	
	Acquisition.DLGAddElement(DLGCreateLabel("exp (s)").DLGAnchor("East"))
	Acquisition.DLGAddElement(DLGCreateRealField(exp,6,2,"Change"+Type).DLGIdentifier("exp"+Type))
	
	Acquisition.DLGAddElement(DLGCreateLabel("binning").DLGAnchor("East"))	
	TagGroup Item
	Acquisition.DLGAddElement(DLGCreatePopup(Item,self.GetBinningList(bin),"Change"+Type).DLGIdentifier("bin"+Type))	
					Item.DLGAddPopupItemEntry("1")	
					Item.DLGAddPopupItemEntry("2")
					Item.DLGAddPopupItemEntry("5")
					Item.DLGAddPopupItemEntry("13")
					Item.DLGAddPopupItemEntry("26")
					Item.DLGAddPopupItemEntry("65")
					Item.DLGAddPopupItemEntry("130")
	
	return Acquisition
	}

TagGroup Create2acquisitions(object self)
	{
	number CameraID = IFgetFilterCameraID()
	number binT,binA,binX
	GetPersistentPointNote(HLS_Path112(CameraID,"View","View")+":Binning",binX,binT)
	GetPersistentPointNote(HLS_Path112(CameraID,"Acquire","Acquire")+":Binning",binX,binA)
	number expT,expA
	GetPersistentNumberNote(HLS_Path112(CameraID,"View","View")+":Exposure (s)",expT)
	GetPersistentNumberNote(HLS_Path112(CameraID,"Acquire","Acquire")+":Exposure (s)",expA)
	
	TagGroup TwoAcquisitions = DLGCreateDialog("").DLGTableLayout(2,1,0)
	
	TwoAcquisitions.DLGAddElement(self.CreateAcquisition("View",expT,binT))
	TwoAcquisitions.DLGAddElement(self.CreateAcquisition("Acquire",expA,binA))
	
	return TwoAcquisitions
	}

TagGroup CreateRightPart(object self)
	{
	TagGroup RightPart = DLGCreateDialog("")
	
	RightPart.DLGAddElement(self.CreateControl())
	RightPart.DLGAddElement(self.Create2acquisitions())
	
	return RightPart
	}
		
TagGroup CreateFilter(object self)
	{
	TagGroup Filter = DLGCreateBox("").DLGTableLayout(2,1,0)

	Filter.DLGAddElement(self.CreateLeftPart() )
	Filter.DLGAddElement(self.CreateRightPart() )

	return Filter
	}

object init (object self)
	{		
	PrimEnergy = IFCGetEnergy()
	EnergyShift = IFGetEnergyOffset(1)
	EnergyAdjust = IFGetEnergyOffset(4)
	HToffset = IFGetEnergyOffset(2)
	DT = IFGetEnergyOffset(3)
	DTwobble = IFGetEnergyOffset(5)

	OffsetOn = VMgetValue112("Filter:HT offset:[0]")
	DTon = VMgetValue112("Filter:drift tube:[0]")
	DTwobbleOn = VMgetValue112("Filter:DT wobbler:[0]")
	SlitIn = IFGetSlitIn()
	SlitWidth = IFGetSlitWidth()
	AppIndex = IFGetActiveApperture()
	dispIndex = IFgetActiveDispersionIndex()
	Mode = VMgetValue112("Filter:FilterMode")
	
	self.init( self.CreateFilter() );

	display(self,"Virtual Filter");
	
	VMsetValue112("VM_panel_Filter ID",self.ScriptObjectGetID())	
	
	return self
	}
		
~Filter112 (object self)
	{
	VMsetValue112("VM_panel_Filter ID",0)	
	}
	
void SetSpectroscopyBinningExposure(object self,string Type,number binning,number exp)
	{
	number CameraID = IFgetFilterCameraID()
	number binX = 1,binY = binning
	SetPersistentPointNote(HLS_Path112(CameraID,Type,Type)+":Binning",binX,binY)
	SetPersistentNumberNote(HLS_Path112(CameraID,Type,Type)+":Exposure (s)",exp)
	}

//Changed Methods
void ChangePrismOffset(object self,TagGroup tg) 
{
tg = self.LookUpElement("prism offset")
IFSetEnergyOffset(1,tg.DLGGetValue());
}

void ChangePrismAdjust(object self,TagGroup tg) 
{
tg = self.LookUpElement("prism adjust")
IFSetEnergyOffset(4,tg.DLGGetValue());
}

void ChangeHTOffset(object self,TagGroup tg) 
{
tg = self.LookUpElement("HT offset")
IFSetEnergyOffset(2,tg.DLGGetValue());
}

void ChangeDriftTube(object self,TagGroup tg) 
{
tg = self.LookUpElement("drift tube")
IFSetEnergyOffset(3,tg.DLGGetValue());
}

void ChangeDTwobbler(object self,TagGroup tg) 
{
tg = self.LookUpElement("DT wobbler")
IFSetEnergyOffset(5,tg.DLGGetValue());
}	

void ChangeHTon(object self,TagGroup tg) 
{
tg = self.LookUpElement("HT offset On")
VMsetValue112("Filter:HT offset:[0]",tg.DLGGetValue());
}	

void ChangeDTon(object self,TagGroup tg) 
{
tg = self.LookUpElement("drift tube on")
VMsetValue112("Filter:HT offset:[0]",tg.DLGGetValue());
}	

void ChangeWobbleron(object self,TagGroup tg) 
{
tg = self.LookUpElement("DT wobbler On")
VMsetValue112("Filter:DT wobbler:[0]",tg.DLGGetValue())
}	

void ChangeSlitIn(object self,TagGroup tg) 
{
tg = self.LookUpElement("SlitIn")
IFSetSlitIn(tg.DLGGetValue());
}

void ChangeSlitWidth(object self,TagGroup tg) 
{
tg = self.LookUpElement("SlitWidth")
IFSetSlitWidth(tg.DLGGetValue())
}

void ChangeFilterMode(object self,TagGroup tg) 
{
tg = self.LookUpElement("Mode")
VMsetValue112("Filter:FilterMode",self.SetModeList(tg.DLGGetValue()))
}

void ChangeDispersion(object self,TagGroup tg) 
{
tg = self.LookUpElement("Dispersion")
VMsetValue112("Filter:Dispersion_index",tg.DLGGetValue())
}

void ChangeApperture(object self,TagGroup tg) 
{
tg = self.LookUpElement("Dispersion")
VMsetValue112("Filter:Apperture_index",tg.DLGGetValue()-1)
}

void ChangeView(object self,TagGroup tg) 
{
tg = self.LookUpElement("expView")
number expT = self.LookUpElement("expView").DLGgetValue()
number binT = self.LookUpElement("binView").DLGgetValue()
self.SetSpectroscopyBinningExposure("View",binT,expT)

number TurboSimullatorID = VMgetValue112("Running ContiniousSimulator")
object TurboSimullator = GetScriptObjectFromID(TurboSimullatorID)
if (TurboSimullator.ScriptObjectIsValid()) TurboSimullator.SetExposure(expT)
}

void ChangeAcquire(object self,TagGroup tg) 
{
tg = self.LookUpElement("expAcquire(")
number expA = self.LookUpElement("ExpChangeAcquire(").DLGgetValue()
number binA = self.LookUpElement("BinChangeAcquire(").DLGgetValue()
self.SetSpectroscopyBinningExposure("ChangeAcquire(",binA,expA)
}
//End Changed Methods

void SetAll(object self )
	{
	IFSetEnergyOffset(1,self.LookUpElement("prism offset").DLGGetValue())
	IFSetEnergyOffset(4,self.LookUpElement("prism adjust").DLGGetValue())
	IFSetEnergyOffset(2,self.LookUpElement("HT offset").DLGGetValue())
	IFSetEnergyOffset(3,self.LookUpElement("drift tube").DLGGetValue())
	IFSetEnergyOffset(5,self.LookUpElement("DT wobbler").DLGGetValue())

	VMsetValue112("Filter:HT offset:[0]",self.LookUpElement("HT offset On").DLGGetValue())
	VMsetValue112("Filter:drift tube:[0]",self.LookUpElement("drift tube on").DLGGetValue())
	VMsetValue112("Filter:DT wobbler:[0]",self.LookUpElement("DT wobbler On").DLGGetValue())
	IFSetSlitIn(self.LookUpElement("SlitIn").DLGGetValue())
	IFSetSlitWidth(self.LookUpElement("SlitWidth").DLGGetValue())
	
	VMsetValue112("Filter:FilterMode",self.setModeList(self.LookUpElement("Mode").DLGGetValue()))
	VMsetValue112("Filter:Dispersion_index",self.SetDispersionList(self.LookUpElement("Dispersion").DLGGetValue()))
	VMsetValue112("Filter:Apperture_index",self.LookUpElement("Apperture").DLGGetValue()-1)
	}
	
void FireAcquire(object self )
	{
	if(IFCgetFilterMode()!=0) 
		{
		if(OKCancelDialog("Switch to Spectroscopy ?")) IFSetSpectroscopyMode()
		else exit(0)
		}
	number exp = self.LookUpElement("expAcquire").DLGGetValue()
	number bin = self.LookUpElement("binAcquire").DLGGetValue()
	number Processing = CameraGetGainNormalizedEnum()
//result("\nexp "+exp+" bin "+bin)
	image im := AcquireSpectrum112(exp,bin,Processing)
	im.showimage()	
	im.RenderSpectrum112().showimage()
	}
void FireView(object self )
	{
	if(IFCgetFilterMode()!=0) 
		{
		if(OKCancelDialog("Switch to Spectroscopy ?")) IFSetSpectroscopyMode()
		else exit(0)
		}
	number TurboSimullatorID = VMgetValue112("Running ContiniousSimulator")
	object TurboSimullator = GetScriptObjectFromID(TurboSimullatorID)
	if (TurboSimullator.ScriptObjectIsValid()) {TurboSimullator.GetImDoc().ImageDocumentClose(0);}	
	TurboSimullator =  alloc(SimulateTurboView112)
	
	number exp = self.LookUpElement("expView").DLGGetValue()
	number bin = self.SetBinningList(self.LookUpElement("binView").DLGGetValue() )
result("\nexp "+exp+" bin "+bin)	
	TurboSimullator.init(exp,bin).StartThread()
	}	
}

result(")")
