/*************************************
Pavel Potapov, virtualTEM, 2013-2014
**************************************/

result("14")

number OFFLine 
GetPersistentNumberNote("_temDM-Scripts"+":OFFLine",OFFLine);
if(OffLine!=1){result("X");throw(-128);}


//panel controling Mag, focus, Obj. stig. and stage X,Y
 
class MicroscopePanel_I: PanelVirtualTEM112
{
number Mag,MagS,Focus,FocusS,AstX,AstY,AstS,X,Y,xyS
TagGroup TMag,TMagS,Tfocus,TfocusS,TAstX,TAstY,TAstS,TX,TY,TxyS
	
TagGroup CreatePanel(object self)
	{
	TagGroup Panel = DLGCreateDialog("").DLGTableLayout(6,1,0).DLGAnchor("West")

	TMag = DLGCreateRealField(Mag,6,3).DLGIdentifier("Magnification")
	TMagS = DLGCreateIntegerField(MagS,5)
	Panel.DLGAddElement(self.CreateCoupleInPanel("Mag/camL","Magnification",Tmag,TMagS,"F"))
	
	TAstX = DLGCreateRealField(AstX,5,3).DLGIdentifier("Obj_Stig_X")
	TAstY = DLGCreateRealField(AstY,5,3).DLGIdentifier("Obj_Stig_Y")
	TAstS = DLGCreateRealField(AstS,5,3)
	Panel.DLGAddElement(self.CreateQuatreInPanel("Obj. Stigmator","Obj_Stig",TAstX,TAstY,TAstS,"U"))	
	
	TFocus = DLGCreateIntegerField(Focus,6).DLGIdentifier("Defocus_nm")
	TFocusS = DLGCreateIntegerField(FocusS,5)
	Panel.DLGAddElement(self.CreateCoupleInPanel("focus","Defocus_nm",Tfocus,TFocusS,"U"))
	
	TX = DLGCreateRealField(X,6,2).DLGIdentifier("Stage_nm_X")
	TY = DLGCreateRealField(Y,6,2).DLGIdentifier("Stage_nm_Y")
	TxyS = DLGCreateRealField(xyS,5,3)
	Panel.DLGAddElement(self.CreateQuatreInPanel(" X        Y ","Stage_nm",TX,TY,TxyS,"U"))	
	
	return Panel
	}
	
object init(object self)
	{
	//Read from Virtual microscope Tags
	Focus = VMgetvalue112("Defocus_nm")
	VMgetcouple112("Obj_Stig",AstX,AstY)
	VMgetcouple112("Stage_nm",X,Y)
	
	if(EMIsImagingMode("IMAGING")) Mag = EMGetMagnification()/1000000
	if(EMIsDiffractionMode("DIFFRACTION")) Mag = EMGetCameraLength()/1000 

	//step are predefined
	focusS=20
	AstS =0.1
	xyS=1
	
	string Name="Virtual Microscope I"
	self.init( self.CreatePanel() );
	display(self,Name);

	//SetPersistentNumberNote(Name112()+":VirtualTEM:VM_panel_I ID",self.ScriptObjectGetID())
	VMsetValue112("VM_panel_I ID",self.ScriptObjectGetID())	
	
	return self
	}

~MicroscopePanel_I (object self)
	{
	VMsetValue112("VM_panel_I ID",0)	
	}
	
void Defocus_nmPlus(object self) self.ChangeValue(1,Tfocus,TfocusS,"Defocus_nm",10000)
void Defocus_nmMinus(object self) self.ChangeValue(-1,Tfocus,TfocusS,"Defocus_nm",-10000)

void MagnificationChange(object self,number Direction,TagGroup Tmag)
	{
	string Type	
	if(EMGetImagingOpticsMode()=="IMAGING") Type = "Mag"	
	if(EMGetImagingOpticsMode()=="DIFFRACTION") Type = "Length"
			number Index = VMgetValue112(Type+" index")	
			number maxIndex = VMgetValue112("max "+Type+"_index")	
			
			if((Direction==1)&&(Index<MaxIndex)) Index += 1
			if((Direction==(-1))&&(Index>0)) Index -= 1
			
	if(Type=="Mag") EMsetMagIndex(Index)	
	if(Type=="Length") EMsetLengthIndex112(Index)
	}
	
void MagnificationPlus(object self) self.MagnificationChange(1,TMag)
void MagnificationMinus(object self) self.MagnificationChange(-1,TMag)

void Obj_Stig_XPlus(object self) self.ChangeValue(1,TAstX,TAstS,"Obj_Stig_X",2)
void Obj_Stig_XMinus(object self) self.ChangeValue(-1,TAstX,TAstS,"Obj_Stig_X",-2)
void Obj_Stig_YPlus(object self) self.ChangeValue(1,TAstY,TAstS,"Obj_Stig_Y",2)
void Obj_Stig_YMinus(object self) self.ChangeValue(-1,TAstY,TAstS,"Obj_Stig_Y",-2)

void Stage_nm_XPlus(object self) self.ChangeValue(1,TX,TxyS,"Stage_nm_X",990)
void Stage_nm_XMinus(object self) self.ChangeValue(-1,TX,TxyS,"Stage_nm_X",-990)
void Stage_nm_YPlus(object self) self.ChangeValue(1,TY,TxyS,"Stage_nm_Y",990)
void Stage_nm_YMinus(object self) self.ChangeValue(-1,TY,TxyS,"Stage_nm_Y",-990)

}

result(")")
