/*************************************
Pavel Potapov, virtualTEM, 2013-2014
**************************************/

result("15")

number OFFLine 
GetPersistentNumberNote("_temDM-Scripts"+":OFFLine",OFFLine);
if(OffLine!=1) {result("X");throw(-128);}


//panel controlling Diffraction/imaging, image shift, stage alpha,beta,Z
 
class MicroscopePanel_II: PanelVirtualTEM112
{

/**************GRAPHICS*************************************/
image diff(object self)	
	{
	image im:=integerImage("",1,0,30,30)
	number Bcgrd=210
	im = Bcgrd
	im[0,0,30,26] = tert((iradius>8)&&(iradius<12),0,im[0,0,30,26])
	im[4,0,26,10] = Bcgrd
	im[4,6,27,10] =0
	
	return im
	}
	
image IMG(object self)	
	{
	image im:=integerImage("",1,0,30,30)
	number Bcgrd=210
	im = Bcgrd
	im[8,13,23,17] =0
	im[4,9,8,21] =0
	im[23,9,27,21] =0
	
	return im
	}
	
number Z,zS,isX,isY,isS,alpha,betha,abS
TagGroup TZ,TzS,TisX,TisY,TisS,Talpha,Tbetha,TabS,Tmode
	
TagGroup CreatePanel(object self)
	{
	TagGroup Panel = DLGCreateDialog("").DLGTableLayout(5,1,0).DLGAnchor("West")

	TisX = DLGCreateRealField(isX,5,3).DLGIdentifier("ImageShift_nm_X")
	TisY = DLGCreateRealField(isY,5,3).DLGIdentifier("ImageShift_nm_Y")
	TisS = DLGCreateRealField(isS,5,3)
	Panel.DLGAddElement(self.CreateQuatreInPanel("image shift","ImageShift_nm",TisX,TisY,TisS,"U"))	
	
	TZ = DLGCreateRealField(Z,6,2).DLGIdentifier("Stage_nm_Z")
	TZS = DLGCreateIntegerField(ZS,5)
	Panel.DLGAddElement(self.CreateCoupleInPanel("  Z  ","Stage_nm_Z",TZ,TZS,"U"))
	
	Talpha = DLGCreateRealField(alpha,6,2).DLGIdentifier("StageTilt_grad_X")
	Tbetha = DLGCreateRealField(betha,6,2).DLGIdentifier("StageTilt_grad_Y")
	TabS = DLGCreateRealField(abS,5,3)
	Panel.DLGAddElement(self.CreateQuatreInPanel("alpha beta","StageTilt_grad",Talpha,Tbetha,TabS,"U"))	

	Tmode = DLGCreateDualStateBevelButton("OperationMode",img(self).DLGMakeRaised(),diff(self).DLGMakeraised(), "toggleMode")
	TagGroup DifCol = DLGCreateBox("").DLGTableLayout(1,7,0)
	DifCol.DLGAddElement(Tmode)
	DifCol.DLGAddElement(DLGCreateGraphic(30,30))
	DifCol.DLGAddElement(DLGCreateGraphic(30,30))
	Panel.DLGAddElement(DifCol)
	
	return Panel
	}
	
object init(object self)
	{
	//Read from Virtual microscope Tags
	Z = VMgetValue112("Stage_nm_Z")
	VMgetcouple112("ImageShift_nm",isX,isY)
	VMgetcouple112("StageTilt_grad",alpha,betha)
	
	//step are predefined
	abS = 0.5
	isS = 1
	zS = 20
	
	string Name="Virtual Microscope II"
	self.init( self.CreatePanel() );
	display(self,Name);

	if(EMgetImagingOpticsMode()=="DIFFRACTION") 	self.LookUpElement("OperationMode").DLGValue(1)	
	
	VMsetvalue112("VM_panel_II ID",self.ScriptObjectGetID())
	
	return self
	}

~MicroscopePanel_II (object self)
	{
	VMsetvalue112("VM_panel_II ID",0)
	}

void toggleMode(object self)
	{
	if(self.LookUpElement("OperationMode").DLGGetStringValue()=="true") EMSetImagingOpticsMode("DIFFRACTION")
	if(self.LookUpElement("OperationMode").DLGGetStringValue()=="false") EMSetImagingOpticsMode("IMAGING")
	}
	
void Stage_nm_ZPlus(object self) self.ChangeValue(1,TZ,TZS,"Stage_nm_Z",10000)
void Stage_nm_ZMinus(object self) self.ChangeValue(-1,TZ,TZS,"Stage_nm_Z",-10000)

	 
void ImageShift_nm_XPlus(object self) self.ChangeValue(1,TisX,TisS,"ImageShift_nm_X",990)
void ImageShift_nm_XMinus(object self) self.ChangeValue(-1,TisX,TisS,"ImageShift_nm_X",-990)
void ImageShift_nm_YPlus(object self) self.ChangeValue(1,TisY,TisS,"ImageShift_nm_Y",990)
void ImageShift_nm_YMinus(object self) self.ChangeValue(-1,TisY,TisS,"ImageShift_nm_Y",-990)

void StageTilt_grad_XPlus(object self) self.ChangeValue(1,Talpha,TabS,"StageTilt_grad_X",45)
void StageTilt_grad_XMinus(object self) self.ChangeValue(-1,Talpha,TabS,"StageTilt_grad_X",-45)
void StageTilt_grad_YPlus(object self) self.ChangeValue(1,Tbetha,TabS,"StageTilt_grad_Y",30)
void StageTilt_grad_YMinus(object self) self.ChangeValue(-1,Tbetha,TabS,"StageTilt_grad_Y",-30)
}

result(")")