/*************************************
Pavel Potapov, virtualTEM, 2013-2014
**************************************/

result("16")

number OFFLine 
GetPersistentNumberNote("_temDM-Scripts"+":OFFLine",OFFLine);
if(OffLine!=1){result("X");throw(-128);}
 
 
//panel controlling C2, beam shift, spotsize, beam tilt, condensor stigmator

class MicroscopePanel_III: PanelVirtualTEM112
{
number spot,spotS,C2,C2S,bsX,bsY,bsS,btX,btY,btS,astCX,astCY,astCs
TagGroup Tspot,TspotS,TC2,TC2S,TbsX,TbsY,TbsS,TbtX,TbtY,TbtS,TastCX,TastCY,TastCs

	
TagGroup CreatePanel(object self)
	{
	TagGroup Panel = DLGCreateDialog("").DLGTableLayout(6,1,0).DLGAnchor("West")
	
	TC2 = DLGCreateIntegerField(C2,4).DLGIdentifier("C2")
	TC2S = DLGCreateIntegerField(C2S,4)
	Panel.DLGAddElement(self.CreateCoupleInPanel(" C2 ","C2",TC2,TC2S,"U"))
	
	TbsX = DLGCreateRealField(bsX,5,3).DLGIdentifier("BeamShift_X")
	TbsY = DLGCreateRealField(bsY,5,3).DLGIdentifier("BeamShift_Y")
	TbsS = DLGCreateRealField(bsS,5,3)
	Panel.DLGAddElement(self.CreateQuatreInPanel("Beam Shift","BeamShift",TbsX,TbsY,TbsS,"U"))	

	TSpot = DLGCreateIntegerField(Spot,2).DLGIdentifier("SpotSize")
	TSpotS = DLGCreateIntegerField(SpotS,2)
	Panel.DLGAddElement(self.CreateCoupleInPanel("SpotSize","SpotSize",Tspot,TspotS,"F"))

	TbtX = DLGCreateRealField(btX,5,3).DLGIdentifier("BeamTilt_X")
	TbtY = DLGCreateRealField(btY,5,3).DLGIdentifier("BeamTilt_Y")
	TbtS = DLGCreateRealField(btS,5,3)
	Panel.DLGAddElement(self.CreateQuatreInPanel("Beam Tilt","BeamTilt",TbtX,TbtY,TbtS,"U"))	
	
	TastCX = DLGCreateRealField(astCX,6,2).DLGIdentifier("Condensor_Stig_X")
	TastCY= DLGCreateRealField(astCY,6,2).DLGIdentifier("Condensor_Stig_Y")
	TastCS = DLGCreateRealField(astCS,5,3)
	Panel.DLGAddElement(self.CreateQuatreInPanel("Cond. Stigmator ","Condensor_Stig",TastCX,TastCY,TastCS,"U"))	
	
	
	return Panel
	}
	
object init(object self)
	{
	//Read from Virtual microscope Tags
	Spot = VMgetvalue112("SpotSize")
	C2 = VMgetvalue112("C2")
	VMgetcouple112("BeamShift",bsX,bsY)
	VMgetcouple112("BeamTilt",btX,btY)
	VMgetcouple112("Condensor_Stig",astCX,astCY)
	
	//step are predefined
	C2S = 10
	spotS=1
	bsS = 1
	btS = 0.2
	astCS=0.1
	string Name="Virtual Microscope III"
	self.init( self.CreatePanel() );
	display(self,Name);

	VMsetvalue112("VM_panel_III ID",self.ScriptObjectGetID())
	return self
	}

~MicroscopePanel_III (object self)
	{
	VMsetvalue112("VM_panel_III ID",0)
	}

void C2Plus(object self) self.ChangeValue(1,TC2,TC2S,"C2",500)
void C2Minus(object self) self.ChangeValue(-1,TC2,TC2S,"C2",5)

void SpotSizePlus(object self) self.ChangeValue(1,TSpot,TSpotS,"SpotSize",10)
void SpotSizeMinus(object self) self.ChangeValue(-1,TSpot,TSpotS,"SpotSize",1)

void BeamShift_XPlus(object self) self.ChangeValue(1,TbsX,TbsS,"BeamShift_X",990)
void BeamShift_XMinus(object self) self.ChangeValue(-1,TbsX,TbsS,"BeamShift_X",-990)
void BeamShift_YPlus(object self) self.ChangeValue(1,TbsY,TbsS,"BeamShift_Y",990)
void BeamShift_YMinus(object self) self.ChangeValue(-1,TbsY,TbsS,"BeamShift_Y",-990)

void BeamTilt_XPlus(object self) self.ChangeValue(1,TbtX,TbtS,"BeamTilt_X",45)
void BeamTilt_XMinus(object self) self.ChangeValue(-1,TbtX,TbtS,"BeamTilt_X",-45)
void BeamTilt_YPlus(object self) self.ChangeValue(1,TbtY,TbtS,"BeamTilt_Y",45)
void BeamTilt_YMinus(object self) self.ChangeValue(-1,TbtY,TbtS,"BeamTilt_Y",-45)

void Condensor_Stig_XPlus(object self) self.ChangeValue(1,TAstCX,TAstCS,"Condensor_Stig_X",2)
void Condensor_Stig_XMinus(object self) self.ChangeValue(-1,TAstCX,TAstCS,"Condensor_Stig_X",-2)
void Condensor_Stig_YPlus(object self) self.ChangeValue(1,TAstCY,TAstCS,"Condensor_Stig_Y",2);
void Condensor_Stig_YMinus(object self) self.ChangeValue(-1,TAstCY,TAstCS,"Condensor_Stig_Y",-2)

}

result(")")