/*************************************
Pavel Potapov, virtualTEM, 2013-2014
**************************************/

result("7")

interface STEMinterface
{
void Stop(object STEMsimulator);
void EnableButtons(object DSpanel,number enabled);
void ResetContinuous(object STEMsimulator);
}


//early introduction of some native DS commands

number DSIsAcquisitionActive( )
{
if(VMgetValue112("Running STEMsimulator")!=0) return 1
else return 0
}

number DSIsValidDSImage(image im)
{
string source
GetStringNote(im,"Source",source)
if(source=="DigiScan") return 1
else return 0
}

void DSwaitUntilFinished()
{
while(DSIsAcquisitionActive()!=0) sleep(0.2) // rewrite with semaphore ??
}

void DSStopAcquisition(number paramID) //stop immidiately
{
number runningPar = VMgetValue112("Running STEMsimulator ParameterID")
if((runningPar==paramID)||(paramID==(-1)))
	{
	VMgetValue112("Running STEMsimulator").GetScriptObjectFromID().Stop()
	}
VMgetValue112("VM_panel_DigiScan ID").GetScriptObjectFromID().EnableButtons(1)
}

void DSFinishAcquisition()
{
VMgetValue112("Running STEMsimulator").GetScriptObjectFromID().ResetContinuous()
}

String DSGetDeviceLocation() 
{
string Location
//same for all STEM detectors
GetPersistentStringNote(lab112()+":VirtualTEM:DigiScan:Detectors:[0]:Location",Location)
return Location
}

number EMGetCalibratedFieldOfView(string deviceLocation,TagGroup stateInfo,number &calFOV,number matchOptions)
{
if(deviceLocation=="wide_angle")
	{
	number Cam_mm = VMgetValue112("DigiScan:Effective size")
	number Magnification = EMGetMagnification()
	Magnification /= 1000000
	calFOV = Cam_mm/Magnification
	}
else throw("calibrated STEM FOV not found !!")
return calFOV
}

number DSGetFlyBackTime()
{
number Flyback
GetPersistentNumberNote(DigiScanPath112()+":Flyback Time",Flyback)
return Flyback
}

void DSSetFlybackTime(number Flyback)
{
SetPersistentNumberNote(DigiScanPath112()+":Flyback Time",Flyback)
}

string DSGetSignalName(number index)
{
string Name
GetPersistentStringNote(lab112()+":VirtualTEM:DigiScan:Detectors:["+index+"]:Name",Name)

return Name	
}

number DSGetLastAcquiredImageID(number index)
{
return VMgetValue112("DigiScan:Detectors:["+index+"]:Last Image")
}

image DSGetLastAcquiredImage(number index)
{
return index.DSGetLastAcquiredImageID().FindImagebyID()
}

number DSGetPixelTime( )
{
return VMgetValue112("DigiScan:Last Pixel Time")
}

number DSGetRotation()
{
number Rot
GetPersistentNumberNote(DigiScanPath112()+":Rotation",Rot)

return Rot
}						
						
number DSGetRotationOffset( )
{
number offset
GetPersistentNumberNote(DigiScanPath112()+":Rotation Offset",offset)
return offset
}						

number DSGetLineFrequency( )	
{
number LineFreq
GetPersistentNumberNote(DigiScanPath112()+":Line Sync Frequency",LineFreq)
return LineFreq
}					

number DSGetDoFlip(  )	
{
number Flip
GetPersistentNumberNote(DigiScanPath112()+":Do Flip",Flip)
return Flip
}

number DSGetMaxSignal(number card,number depth,number dwellTime)
{
//dependence on the dwell time and card performance is NOT modelled 
return (2**8)**Depth
}


//service DS coordinates calculation commands

string STEMinfoLabel_112() return "Digiscan"

void SinCos112(number rot,number &ccos,number &ssin)
{
ccos = cos(rot/57.2958)
ssin = sin(rot/57.2958)
}

void DSgetDScoordCalcParams112(number scale,number rot,number centX,number centY,number &a0,number &b0,number &c0,number &a1,number &b1,number &c1)
{
SinCos112(rot,a0,b0)		//Im -> DigiScan: rotation clockwise
a0 *= scale					//Dx = ( cosA*Ix + sinA*Iy)*scale
b0 *= scale					//Dy = (-sinA*Ix + cosA*Iy)*scale
a1=-b0
b1=a0
c0 = -(CentX*a0 + CentY*b0)	//Dx = 0 at Ix = CentX	(Digiscan coordinates are counted  from center of FOV)
c1 = -(CentY*a1 + CentY*b1)	//Dy = 0 at Iy = CentY	(Digiscan coordinates are counted  from center of FOV)
}

void DSgetImageCoordCalcParams112(number scale,number rot,number centX,number centY,number &a0,number &b0,number &c0,number &a1,number &b1,number &c1)
{
SinCos112(rot,a0,a1)		//DigiScan -> Im: rotation count-clockwise
a0 /= scale					//Ix = (cosA*Ix - sinA*Iy)/scale
a1 /= scale					//Iy = (sinA*Ix + cosA*Iy)/scale
b0=-a1
b1=a0
c0 = CentX					//Ix = CentX at Dx = 0 (if Image is centered around FOV, centX = Width/2)
c1 = CentY					//Iy = CentY at Dy = 0 (if Image is centered around FOV, centY = Height/2)
	//if image is not centered (CentX,CentY) denotes the center of FOV in image coordinates (can be negative)
}

void DSCalcDSCoordFromImage112(number scale,number rot,number centX,number centY,number Ix,number Iy,number &Dx,number &Dy)
{
number a0,b0,c0,a1,b1,c1
DSgetDScoordCalcParams112(scale,rot,centX,centY,a0,b0,c0,a1,b1,c1)
Dx = round(a0*Ix + b0*Iy +c0)
Dy = round(a1*Ix + b1*Iy +c1)
}

void DSCalcImageCoordFromDS112(number scale,number rot,number centX,number centY,number Dx,number Dy,number &Ix,number &Iy)
{
number a0,b0,c0,a1,b1,c1
DSgetImageCoordCalcParams112(scale,rot,centX,centY,a0,b0,c0,a1,b1,c1)
Ix = round(a0*Dx + b0*Dy +c0)
Iy = round(a1*Dx + b1*Dy +c1)
}


void GetParametersFromImage112(image im,number &scale,number &rot,number &centX,number &centY)
{
if(DSIsValidDSImage(im))
	{
	SetNumberNote(im,STEMinfoLabel_112()+":Horizontal Image Center",centX)
	SetNumberNote(im,STEMinfoLabel_112()+":Vertical Image Center",centY)
	GetNumberNote(im,STEMinfoLabel_112()+":Rotation",Rot)
	GetNumberNote(im,STEMinfoLabel_112()+":Horizontal Spacing",scale)
	}
else throw("Image is not from DigiScan !!")
}


//native DS coordinates calculation commands

void DSgetDScoordCalcParams(image im,number &a0,number &b0,number &c0,number &a1,number &b1,number &c1)
{
number scale,rot,centX,centY
GetParametersFromImage112(im,scale,rot,centX,centY)
DSgetDScoordCalcParams112(scale,rot,centX,centY,a0,b0,c0,a1,b1,c1)
a0 = round(a0)
b0 = round(b0)
c0 = round(c0)
a1 = round(a1)
b1 = round(b1)
c1 = round(c1)
}

void DSgetImageCoordCalcParams(image im,number &a0,number &b0,number &c0,number &a1,number &b1,number &c1)
{
number scale,rot,centX,centY
GetParametersFromImage112(im,scale,rot,centX,centY)
DSgetImageCoordCalcParams112(scale,rot,centX,centY,a0,b0,c0,a1,b1,c1)
}

void DSCalcDSCoordFromImage(image im,number Ix,number Iy,number &Dx,number &Dy)
{
number a0,b0,c0,a1,b1,c1
DSgetDScoordCalcParams(im,a0,b0,c0,a1,b1,c1)

Dx = a0*Ix + b0*Iy +c0
Dy = a1*Ix + b1*Iy +c1
}

void DSCalcDSCoordFromImage(image im,image img_x,image img_y,image ds_x,image ds_y)
{
number a0,b0,c0,a1,b1,c1
DSgetDScoordCalcParams(im,a0,b0,c0,a1,b1,c1)

ds_x = a0*img_x + b0*img_y +c0
ds_y = a1*img_x + b1*img_y +c1
}

void DSCalcImageCoordFromDS(image im,number Dx,number Dy,number &Ix,number &Iy)
{
number a0,b0,c0,a1,b1,c1
DSgetImageCoordCalcParams(im,a0,b0,c0,a1,b1,c1)

Ix = round(a0*Dx + b0*Dy +c0)
Iy = round(a1*Dx + b1*Dy +c1)
}

void DSCalcImageCoordFromDS(image im,image img_x,image img_y,image ds_x,image ds_y)
{
number a0,b0,c0,a1,b1,c1
DSgetImageCoordCalcParams(im,a0,b0,c0,a1,b1,c1)

img_x = a0*ds_x + b0*ds_y +c0
img_y = a1*ds_x + b1*ds_y +c1
}


//service 112 commands
number Zdependence112(number Alcontent,number Rad)
{
//Rad = Rad0/L; 0.1 at R0=1, L=0.1

number zAl = 13	//Al atomic number
number zO = 8	//O atomic number
number meanZ = (Alcontent*zAl+(1-Alcontent)*zO)/zAl //in fraction of zAl

number reduced 
rad*=10
if(rad<1) reduced = meanZ**(sqrt(Rad))
else reduced = meanZ	//saturation at L=0.1, Rad0=1.0

return reduced
}

image getSTEMfeature112(number Illum,number minAngle,number PixelSize,number Smear,number AstCX,number AstCY)
{
number AngInt = 1/(1+(minAngle-1)**2)	//normalized Lorential

	//make particle 
	number Al = VMgetvalue112("Particle:Al")
	number AlCore = VMgetvalue112("Particle:Al Core")
	number Thickness = VMgetvalue112("Particle:Thickness")
	number Transparancy = VMgetvalue112("Particle:Transparancy")
	number size = VMgetvalue112("Particle:Size_nm")
	number sizeCore = VMgetvalue112("Particle:Size Core_nm")
	number minGalo = VMgetvalue112("Particle:Galo_nm")
	number Size_pix,SizeCore_pix,MinGalo_pix
	Size_pix = size/pixelSize
	SizeCore_pix = sizeCore/pixelSize
	MinGalo_pix = MinGalo/pixelSize

number IntBF 	= Illum*Transparancy	
number Int 		= Illum*Thickness*Zdependence112(Al,minAngle)*AngInt
number IntCore 	= Illum*Thickness*Zdependence112(Alcore,minAngle)*AngInt
//result("\nIntBF "+IntBF+" minAngle "+minAngle)
image feature
if(minAngle<=1)feature = -Particle112(Size_pix,MinGalo_pix,Smear,AstCX,AstCY,IntBF)	
if(minAngle>1)feature = Profile112(Size_pix,SizeCore_pix,MinGalo_pix,Smear,0,AstCX,AstCY,int,intCore)

return feature 
}

void SetSTEMImageInfo112(image &im,number index,number PixelSize,number Rot,number pTime\
,number flip,number zoom,number centerX,number centerY,number R0,number FlyB,number Cont)
{
number width,height
im.getSize(width,height)
string units ="nm"
ImageSetDimensionCalibration(im,0,0,PixelSize,units,1)
if(height>1) ImageSetDimensionCalibration(im,1,0,PixelSize,units,1)

SetStringNote(im,"DataBar:Acquisition Date",GetDate(0))
SetStringNote(im,"DataBar:Acquisition Time",GetTime(1))

SetStringNote(im,"Microscope Info:Name","Virtual TEM")
SetNumberNote(im,"Microscope Info:Indicated Magnification",EMGetMagnification()) 
SetNumberNote(im,"Microscope Info:Voltage",EMgetHighTension())

SetNumberNote(im,STEMinfoLabel_112()+":Sample Time",pTime)
SetNumberNote(im,STEMinfoLabel_112()+":Flip",flip)
SetNumberNote(im,STEMinfoLabel_112()+":Zoom factor",zoom)
SetNumberNote(im,STEMinfoLabel_112()+":Signal Index",Index)
SetNumberNote(im,STEMinfoLabel_112()+":Horizontal Image Center",centerX)
SetNumberNote(im,STEMinfoLabel_112()+":Vertical Image Center",centerY)
SetNumberNote(im,STEMinfoLabel_112()+":Rotation Offset",R0)
SetNumberNote(im,STEMinfoLabel_112()+":Flyback",FlyB)
SetNumberNote(im,STEMinfoLabel_112()+":Scan Mode",Cont)

number Range = 22938	//max number of pixels when scanning along FOV
number scale = round(Range/max(width,height)/zoom*10)/10

number ccos,ssin,a0,a1,b0,b1
SinCos112(rot,ccos,ssin)
a0 = round(scale*ccos)
b0 = round(scale*ssin)
a1 = -round(scale*ssin)
b1 = round(scale*ccos)

SetNumberNote(im,STEMinfoLabel_112()+":Rotation",Rot)
SetNumberNote(im,STEMinfoLabel_112()+":Horizontal Spacing",scale)
SetNumberNote(im,STEMinfoLabel_112()+":Horizontal Pixel Step",a0)
SetNumberNote(im,STEMinfoLabel_112()+":Horizontal Perpendicular Pixel Step",b0)
SetNumberNote(im,STEMinfoLabel_112()+":Vertical Spacing",scale)
SetNumberNote(im,STEMinfoLabel_112()+":Vertical Pixel Step",b1)
SetNumberNote(im,STEMinfoLabel_112()+":Vertical Perpendicular Pixel Step",a1)
SetStringNote(im,"Source","DigiScan")

}


/****** BASIC STEM ACQUISITION THREAD *******/

class SimulateSTEMacqusition112: thread
{  
object Running,StopRun
number pTime,rTime,FlyBack
number Width,Height
number Rot,Rot0
number Cont,Flip
image Detectors
number zoom,offsetCenterX,offsetCenterY

object init(object self,number widthP,number heightP,image DetectorsP,number RotP,number pTimeP,number ContP,number zoomP,number OffsetX,number OffsetY)
	{
	if(DSIsAcquisitionActive()) throw("Digiscan is busy !!")
	
	pTime = pTimeP
	Width = widthP
	Height = heightP
	Rot0 = DSGetRotationOffset()
	Cont = ContP
	Rot = RotP 
	if(Cont==1)SetPersistentNumberNote(DigiScanPath112()+":Rotation",Rot)
	Flip = DSGetDoFlip()
	rTime = pTime*Width/1000000
	FlyBack = DSGetFlyBackTime()	
	Zoom = ZoomP
	//Zoom = maxSizeOfImage / MaxScannableSize
	offsetCenterX = offsetX + Width/2
	offsetCenterY = offsetY + Height/2
	//offsetX Offsets between image CenterX and the CenterX of FOV
	//offsetY Offsets between image CenterY and the CenterY of FOV
	//offsetCenterX : CenterX of FOV in image coordinates
	//offsetCenterX : CenterY of FOV in image coordinates
	
	Detectors =DetectorsP
	//this is basic information on the acquired signals
	// i - column,j - row:
	//j - index of signal
	//i=0	selected (0 or 1)
	//i=1	image ID 
	//i=2	data size (1,2,4)
	//i=3	window listener ID
	
	Running = NewSignal(1)
	StopRun = NewSignal(0)
	
	if(EMGetIlluminationMode()!="STEM")
		{
		if(OKCancelDialog("Switch to STEM ?")) EMSetIlluminationMode("STEM")
		else exit(0)
		}
	 
	VMsetValue112("Running STEMsimulator",self.ScriptObjectGetID())
	
	return self
	}

void CleanAllWindowsListeners(object self)
	{
	for(number j=0;j<3;j++)
		{
		image im := Detectors.getPixel(1,j).FindImagebyID()
		if(im.ImageIsValid())
			{
			number listID = Detectors.getPixel(3,j)
			imagedocument imdoc = im.ImageGetOrCreateImageDocument()
			imdoc.ImageDocumentGetWindow().WindowRemoveWindowListener(listID)
			}
		}
	}
		
image PrepareSTEMimage(object self,number j,image &line,number &maxSignal)
{
realimage im
number Depth = Detectors.getPixel(2,j)
//result("\ndepth "+depth)
if((Depth!=1)&&(Depth!=2)&&(Depth!=4)) throw("only 1, 2 or 4 bit data are supported")
number ImID = Detectors.getPixel(1,j)
if(ImID==0)
	{
	im:= IntegerImage(DSGetSignalName(j),Depth,0,Width,Height)
	line := IntegerImage(""+j,Depth,0,Width,1)

	im.showimage()
	imID = im.ImageGetID()
	Detectors.setPixel(1,j,imID)
	}		
else
	{
	im:= FindImagebyID(ImID)
	if(im.ImageIsValid())
		{
		number w,h
		im.getSize(w,h)
		if((w!=Width)||(h!=Height)) throw("image size does not fit the specified width and height !!")
		if((im.ImageGetDataElementBitSize()/8)!=Depth)  throw("image does not fit the specified bit size !!")
		}
	else throw("image with ID " +ImID+" not found!!")
	}

number listID = im.ImageGetOrCreateImageDocument().ImageDocumentGetWindow()\
.WindowAddWindowListener(self,"window_closed:ViewWindowClosed;")				
Detectors.setPixel(3,j,listID)

maxSignal = DSGetMaxSignal(0,depth,0)
	
VMsetValue112("DigiScan:Detectors:["+j+"]:Last Image",imID)
	
return im
}

void Stop(object self)
	{
	Running.resetSignal()
	StopRun.setSignal()
	VMsetValue112("DigiScan:Last Pixel Time",pTime)
	self.CleanAllWindowsListeners()
	}
	
void ResetContinuous(object self)
	{
	Cont = 0
	}
	
void RunThread(object self)
{ 	
image im0,im1,im2,line0,line1,line2,feature0,feature1,feature2
number Det0,Det1,Det2
Det0=Detectors.getPixel(0,0)
Det1=Detectors.getPixel(0,1)
Det2=Detectors.getPixel(0,2)
if(Det0>0) im0 := self.PrepareSTEMimage(0,line0,Det0)//Det0 <- maxSignal for given detector
if(Det1>0) im1 := self.PrepareSTEMimage(1,line1,Det1)//Det1 <- maxSignal for given detector
if(Det2>0) im2 := self.PrepareSTEMimage(2,line2,Det2)//Det2 <- maxSignal for given detector

number FlyB = FlyBack/1000000
string deviceLocation = DSGetDeviceLocation()
TagGroup stateInfo = NewTagGroup() //dummy
number t0,dt
number Li,Ri,Lf,Rf,topFeature
number toScan = 1

while(toScan==1)
	{	
	//reading microscope paramenters
	number driftX,driftY
	number X,Y,Z,alpha,betha,AstCX,AstCY
	EMGetStageXY(X,Y)
	alpha= EMGetStageAlpha()
	betha = EMGetStageBeta()
	VMgetcouple112("StageDrift_nm",driftX,driftY)
		number driftRedX=1,driftRedY=1
	if(width<height) driftRedX = width/height
	if(height<width) driftRedX = height/width
	DriftX *= driftRedX
	DriftY *= driftRedY
	EMGetCondensorStigmation(AstCX,AstCY)
	number nHT
	GetPersistentNumberNote("Microscope Info:Voltage",nHT)
	number HT = VMgetvalue112("HighTension_V")
	number Magnification = EMGetMagnification()
		Magnification /= 1000000
	number CameraLength = EMGetCameraLength() 
		CameraLength/=1000
	number Defocus = EMGetFocus()
	number Spot = EMGetSpotSize()
	number maxSide = max(Width,Height)
	number FOV = EMGetCalibratedFieldOfView(deviceLocation,stateInfo,FOV,0)
	number PixelSize = FOV/maxSide*Zoom
	number Smear,CenterX,CenterY
		number eVvsNM = 2
	Smear = Defocus+Z+(HT-nHT)*eVvsNM	
	if(Cont==1) Rot = DSgetRotation()
	
	number Illum =pTime*(1.3**(10-spot))/100 
	// BF detector OVERSATURATE at: thick = 0.5 spot 5 dwell 54us
	// 								thick = 0.5 spot 1 dwell 19us
//result("\nptime "+ptime+" spot "+spot+" Illum " +Illum)

	//prepare feature and set info tags
	number w,h
	number DetRad
	if(Det0>0) 
		{
		DetRad = VMgetValue112("DigiScan:Detectors:[0]:Radius")
		feature0 := getSTEMfeature112(Illum*Det0/2,detRad/CameraLength,PixelSize,Smear,AstCX,AstCY).rotate(rot/57.2958)
		feature0.getSize(w,h)
		SetSTEMImageInfo112(im0,0,PixelSize,Rot,pTime,flip,zoom,offsetCenterX,offsetCenterY,Rot0,FlyB,Cont)
		}
	if(Det1>0) 
		{
		DetRad = VMgetValue112("DigiScan:Detectors:[1]:Radius")
		feature1 := getSTEMfeature112(Illum*Det1/2,detRad/CameraLength,PixelSize,Smear,AstCX,AstCY).rotate(rot/57.2958)
		feature1.getSize(w,h)
		SetSTEMImageInfo112(im1,1,PixelSize,Rot,pTime,flip,zoom,offsetCenterX,offsetCenterY,Rot0,FlyB,Cont)
		}
	if(Det2>0) 
		{
		DetRad = VMgetValue112("DigiScan:Detectors:[2]:Radius")
		feature2 := getSTEMfeature112(Illum*Det2/2,detRad/CameraLength,PixelSize,Smear,AstCX,AstCY).rotate(rot/57.2958)
		feature2.getSize(w,h)
		SetSTEMImageInfo112(im2,2,PixelSize,Rot,pTime,flip,zoom,offsetCenterX,offsetCenterY,Rot0,FlyB,Cont)
		}


	//scanning	

	for(number j=0;j<Height;j++)
		{
		try {Running.waitonSignal(0.01,StopRun);} // wait 0.01sec till Running is signed,
		catch // StopRun is signed
			{
			exit(0)
			}
		
		t0 = GetHighResTickCount()
		
		CenterX = DriftFeatureWithTime112(Width,driftX,X,Z,Alpha,0,PixelSize/zoom)	
		CenterY = DriftFeatureWithTime112(Height,-driftY,-Y,-Z,betha,0,PixelSize/zoom)	
		CenterX -= Width/2 			//DS coordinates rescaled such as Width is a DS full range
		CenterY -= Height/2			//DS coordinates rescaled such as Height is a DS full range	
		number CenterXI,CenterYI	// in Image coordinates	
		DSCalcImageCoordFromDS112(zoom,rot,offsetCenterX,offsetCenterY,CenterX,CenterY,CenterXI,CenterYI)
			
		if(Det0>0) im0[j,0,j+1,Width] = Det0/2
		if(Det1>0) im1[j,0,j+1,Width] = Det1/2
		if(Det2>0) im2[j,0,j+1,Width] = Det2/2
		
		topFeature = round(centerYI-h/2)
		if((j>=topFeature)&&(j<(topFeature+h))) 
			{
			Li=round(CenterXI-w/2)
			Ri=Li+w
			Lf=0
			Rf=Ri-Li
			if(Li<0){Lf-=Li;Li=0;}
			if(Ri>width){Rf -= (Ri-width);Ri=width;}
			if(Det0>0) 
				{
				im0[j,Li,j+1,Ri] += feature0[j-topFeature,Lf,j-topFeature+1,Rf]
				if(flip==1) 
					{
					line0[Width-icol,0] = im0[j,0,j+1,Width]
					im0[j,0,j+1,Width] = line0
					}
				}				
			if(Det1>0) 
				{
				im1[j,Li,j+1,Ri] += feature1[j-topFeature,Lf,j-topFeature+1,Rf]
				if(flip==1)
					{
					line1[Width-icol,0] = im1[j,0,j+1,Width]
					im1[j,0,j+1,Width] = line1
					}
				}								
			if(Det2>0) 
				{
				im2[j,Li,j+1,Ri] += feature2[j-topFeature,Lf,j-topFeature+1,Rf]
				if(flip==1) 
					{
					line2[Width-icol,0] = im2[j,0,j+1,Width]
					im2[j,0,j+1,Width] = line2
					}
				}				
			}
		sleep(FlyB)		
		dt = CalcHighResSecondsBetween(t0,GetHighResTickCount())
		if(dt<rTime) sleep(rTime-dt)
		}
	if(Cont!=1) ToScan=0
	}
self.Stop()
}
	
void ViewWindowClosed(object self, number e_fl, DocumentWindow Win)
	{
	self.Stop()
	}
	
~SimulateSTEMAcqusition112(object self) 
	{
	VMsetValue112("Running STEMsimulator",0)
	VMsetValue112("Running STEMsimulator ParameterID",0)
	result("\nSTEMsimulator destroyed")
	}
	
number ReportWhenFinished(object self)
	{
	try Running.waitonSignal(0.01,StopRun)
	catch return 1
	
	return 0
	}	
}


//Same for line profile

void SimulateSTEMprofile112(image Profile,number SignalIndex,number Rot,number pTime,number zoom,number OffsetX,number OffsetY)
{
	//Zoom = SizeOfLineScan / MaxScannableSize
	//offsetX: Offsets between lineScanCenterX and the CenterX of FOV
	//offsetY: Offsets between lineScanCenterY and the CenterY of FOV

if(DSIsAcquisitionActive()) throw("Digiscan is busy !!")

number Width0 = 512		//can be any
number Width,Height
Profile.getSize(Width,Height)
if(Height>1) throw("invalid destination image !!")
OffsetX += Width/2	
	//offsetX : Offset in image coordinates

number Rot0 = DSGetRotationOffset()
Rot = Rot + Rot0	

if(EMGetIlluminationMode()!="STEM")
	{
	if(OKCancelDialog("Switch to STEM ?")) EMSetIlluminationMode("STEM")
	else exit(0)
	}
			
number Depth = Profile.ImageGetDataElementBitSize()/8
number maxSignal = DSGetMaxSignal(0,depth,0)
	
	//reading microscope paramenters
	number driftX,driftY
	number X,Y,Z,alpha,betha,AstCX,AstCY
	EMGetStageXY(X,Y)
	alpha= EMGetStageAlpha()
	betha = EMGetStageBeta()
	VMgetcouple112("StageDrift_nm",driftX,driftY)
	EMGetCondensorStigmation(AstCX,AstCY)
	number nHT
	GetPersistentNumberNote("Microscope Info:Voltage",nHT)
	number HT = VMgetvalue112("HighTension_V")
	number Magnification = EMGetMagnification()
		Magnification /= 1000000
	number CameraLength = EMGetCameraLength() 
		CameraLength/=1000
	number Defocus = EMGetFocus()
	number Spot = EMGetSpotSize()
	
	string deviceLocation = DSGetDeviceLocation()
	TagGroup stateInfo = NewTagGroup() //dummy
	number FOV 
	FOV = EMGetCalibratedFieldOfView(deviceLocation,stateInfo,FOV,0)
	number PixelSize = FOV/Width*Zoom
//result("\nPixelSize "+PixelSize)
//result("\n"+size+" "+sizeCore+" "+minGalo+" "+Thickness+" "+Transparancy)
	number Smear,CenterX,CenterY
		number eVvsNM = 2
	Smear = Defocus+Z+(HT-nHT)*eVvsNM
	
	number Illum =pTime*(1.3**(10-spot))/100 
	// BF OVERSATURATE thick = 0.5 spot 5 dwell 54us
	// BF OVERSATURATE thick = 0.5 spot 1 dwell 19us
//result("\nptime "+ptime+" spot "+spot+" Illum " +Illum)

//prepare feature 
number DetRad = VMgetValue112("DigiScan:Detectors:["+SignalIndex+"]:Radius")	
image feature = getSTEMfeature112(Illum*maxSignal/2,detRad/CameraLength,PixelSize,Smear,AstCX,AstCY).rotate(rot/57.2958)
number w,h
feature.getSize(w,h)
	
//scanning	
CenterX = DriftFeatureWithTime112(Width0,driftX,X,Z,Alpha,0,PixelSize/zoom)	
CenterY = DriftFeatureWithTime112(Width0,-driftY,-Y,-Z,betha,0,PixelSize/zoom)	
CenterX -= Width0/2 	// in DS coordinates
CenterY -= Width0/2		// in DS coordinates

number CenterXI,CenterYI	// in Image coordinates	
DSCalcImageCoordFromDS112(zoom,rot,offsetX,offsetY,CenterX,CenterY,CenterXI,CenterYI)

Profile = maxSignal/2

number Li,Ri,Lf,Rf
number sect = round(h/2-CenterYI)
if((sect>=0)&&(sect<h)) 
	{
	Li=round(CenterXI-w/2)
	Ri=Li+w
	Lf=0 
	Rf=Ri-Li
	if(Li<0){Lf-=Li;Li=0;}
	if(Ri>width){Rf -= (Ri-width);Ri=width;}
	
	Profile[0,Li,1,Ri] += feature[sect,Lf,sect+1,Rf]
	}	
SetSTEMImageInfo112(Profile,SignalIndex,PixelSize,Rot,pTime,0,zoom,offsetX,offsetY,Rot0,0,0)		
}

result(")")