/*************************************
Pavel Potapov, virtualTEM, 2013-2014
**************************************/

result("6")

number OFFLine 
GetPersistentNumberNote("_temDM-Scripts"+":OFFLine",OFFLine);
if(OffLine!=1){result("X");throw(-128);}
 
class SimulateTurboView112: thread
{  
object Running,StopRun
imageDocument imdoc
image im
ImageDisplay imDisp

number exp									//insitu changeble
number binY,pixelSizeX,pixelSizeY,EELScorrection	//not changeble
number Width,Zchannel,FEGfwhm,th,Al,Saturation	//not changeble

number ImdocID,ViewCloseID
number secstay

void FindPixelSize(object self,number CameraID,number binY,number &pixelSizeX,number &pixelSizeY,number &EELScorrection)
	{
	number binX = 1 //spectroscopy never horisontal binning
	
	number Cam_mm = VMgetValue112("Camera:["+CameraID+"]:Size_mm")
	number CameraWidth,CameraHeight
	CameraGetSize(CameraID,CameraWidth,CameraHeight)
	number EELSreduction = VMgetValue112("Filter:EELS reduction")
	string IllMode = EMGetImagingOpticsMode()
	number Magnification
	if(IllMode == "IMAGING")
		{
		Magnification = EMGetMagnification()
		PixelSizeX = (Cam_mm/Magnification*1000000)/CameraWidth*BinX	//in nm
		PixelSizeY = (Cam_mm/Magnification*1000000)/CameraHeight*BinY	//in nm
		EELScorrection =  CameraWidth/binX*EELSreduction
		}
	if(IllMode == "DIFFRACTION")
		{
		Magnification = EMGetCameraLength() 
		PixelSizeX = (Cam_mm/Magnification*1000)/CameraWidth*BinX	//in 1/nm
		PixelSizeY = (Cam_mm/Magnification*1000)/CameraHeight*BinY	//in 1/nm
		number C2 = EMGetC2()
		number Size0_pix = 5*(C2/100)/pixelSizeX/EELSreduction
		EELScorrection =  Size0_pix*EELSreduction
		}
	}
	
object init(object self,number expP,number binYP)
	{
	exp=expP
	binY =binYP
	
//in-situ NOT changeble parameters	
	Zchannel = IFGetSpectroscopyZoomChannel()
	th = VMgetvalue112("Particle:Thickness")
	Al = GetAveragedAl112()	
	FEGfwhm = VMgetValue112("FEG:FWHM")
//result("\nZchannel "+Zchannel)
	number CamID = IFGetFilterCameraID()
	Saturation = VMgetvalue112("Camera:["+CamID+"]:Saturation")

	number topS,leftS,bottomS,rightS	//here local borders for spectroscopy only
	getReadArea112(CamID,"Spectroscopy","Acquire","Acquire",topS,leftS,bottomS,rightS) //no frame transfer accounted
	Width = rightS - leftS

	self.FindPixelSize(CamID,binY,pixelSizeX,pixelSizeY,EELScorrection)
	
	Running = NewSignal(1)
	StopRun = NewSignal(0)
	
	imdoc = ImDocID.GetImageDocumentByID()
	
	if(!Imdoc.ImageDocumentIsValid()) 
		{ 		
		im:= RealImage("TurboView",4,width,1)
		showImage(im)
		imDoc = ImageGetOrCreateImageDocument(im)
		ImDocID = imDoc.ImageDocumentGetID()
		ViewCloseID = imdoc.ImageDocumentGetWindow().WindowAddWindowListener(self,"window_closed:ViewWindowClosed;")			
		}
	
 	VMsetValue112("Running ContiniousSimulator",self.ScriptObjectGetID())
 	
	imdisp = im.ImageGetImageDisplay(0)	
	imDisp.ImageDisplayAddKeyListener("KeyListener","HandleKey112( key )")	
	
	secstay =0.01
	
	return self
	}
	 
void RunThread(object self)
	{
	number t0,t
	while(1)
		{	
//pausing/stopping a thread
number canceled
try {Running.waitonSignal(secstay,StopRun);} // wait secstay till Running is signed,
catch // StopRun is signed
	{
	canceled=1;              	
	if(ImageDocumentDoesImageWithIDExist(imdoc,0))   		{
		imdoc.ImageDocumentGetWindow().WindowRemoveWindowListener(ViewCloseID)
		}
	break;
	} 	
if(canceled==1) {exit(0);} 

	number t0=GetOSTickCount()

	//in situ changeble parameters
	number disp = IFGetActiveDispersion()
	number Energy = IFGetEnergyLoss()
	number origin = Zchannel - Energy/disp
	number Adjust = IFGetEnergyOffset(4)
	
	number Illum = GetIllumination112(exp,PixelSizeX,PixelSizeY,EELScorrection)
//result("\n illum "+Illum)
	number wobble
	if(IFCGetDriftTubeWobbleOn() ) wobble = IFCGetDriftTubeWobbleVoltage()
//result("\n"+" "+Energy+" "+origin)
	number slit
	if(IFGetSlitIn()) slit = IFGetSlitWidth()
	
	//simulate spectra
	im = Illum*GenerateSpectrum112(width,disp,origin,Adjust,wobble,slit,FEGfwhm,th,Al)
	CameraSetSpectrumInfo112(im,exp,binY,origin,disp)
	
	//saturation check
	number mCount = max(im)
	if(mCount<Saturation*0.8)imdisp.LinePlotImageDisplaySetSliceComponentColor(0,1,0.36,0.75,0.75)
	if(mCount>Saturation*0.8)imdisp.LinePlotImageDisplaySetSliceComponentColor(0,1,1,1,0)
	if(mCount>Saturation)imdisp.LinePlotImageDisplaySetSliceComponentColor(0,1,1,0,0)
	im = tert(im<Saturation,im,Saturation) 
//result("\nSaturation "+Saturation+" "+max(im))
	updateimage(im)		
	
		number dt = CalcOSSecondsBetween(t0,GetOSTickCount())
		if(secstay!=999999)	//if not paused during sscXY
			{
			if(exp>dt) secstay = exp-dt //during this execution cannot be  paused
			else secstay = 0.01
			}
	
		Running.resetSignal() //activate secstay
		//result ("\n"+secstay)
		}
	} 	
	
void Stop(object self)
	{
	Running.resetSignal()
	StopRun.setSignal()
	}
	
void Pause(object self)
	{
	secstay =999999
	Running.resetSignal()
	}
	
void Release(object self)
	{
	secstay =0.01
	Running.setSignal()
	}

imagedocument GetImDoc(object self) return imdoc	
void SetExposure(object self,number expP) exp=expP
void IncreaseExposure(object self) {exp*=2;UpdatePanel_112("Filter","expView",exp);}
void DecreaseExposure(object self) {exp/=2;UpdatePanel_112("Filter","expView",exp);}

void ViewWindowClosed(object self, number e_fl, DocumentWindow Win)
	{	
	imDisp.ImageDisplayRemoveKeyListener( "KeyListener" ) 

	Running.resetSignal()
	secstay=0.01
	StopRun.setSignal()
	}

~SimulateTurboView112(object self) 
	{
	VMsetValue112("Running ContiniousSimulator",0)
	result("\nSimulateTurboView destroyed")
	}
} 

result(")")

