/*************************************
Pavel Potapov, virtualTEM, 2013-2014
**************************************/


/*****************************
Definitions
******************************/	
//Path definition

string lab112() return "_temDM-Scripts"

string CM_Path112() return "CameraManager"
string CCL_Path112() return CM_Path112()+":CameraConfigurationList"
string APS_Path112(number CameraID)
{
string path = CCL_Path112()
Path += (":["+CameraID+"]")
Path += ":Acquisition Parameter Sets"
return path 
}
string HLP_Path112(number CameraID,string Mode,string SubMode)
{
string Path = APS_Path112(CameraID)
Path += ":Imaging"
Path += (":"+Mode)
Path += (":"+SubMode)
Path += ":High Level"
return Path
}
string HLS_Path112(number CameraID,string Mode,string SubMode)
{
string Path = CCL_Path112()
Path += (":["+CameraID+"]")
Path += ":Acquisition Parameter Sets"
Path += ":Spectroscopy"
Path += (":"+Mode)
Path += (":"+SubMode)
Path += ":High Level"
return Path
}

string DigiScanPath112(void) return "DigiScan"


//basic functions

number VMgetValue112(string Name)
	{
	number value
	GetPersistentNumberNote(lab112()+":VirtualTEM:"+Name,Value)	
	return value
	}

void VMsetValue112(string Name,number value)
	{
	SetPersistentNumberNote(lab112()+":VirtualTEM:"+Name,Value)
	}

void VMChangeValue112(string Name,number delta,number &Value)
	{
	Value = VMgetValue112(Name)+Delta
	VMsetValue112(Name,Value)
	}

void VMGetCouple112(string Name,number &X,number &Y)
	{
	X = VMgetValue112(Name+"_X")
	Y = VMgetValue112(Name+"_Y")
	}

void VMsetCouple112(string Name,number X,number Y)
	{
	VMsetValue112(Name+"_X",X)
	VMsetValue112(Name+"_Y",Y)
	}

void VMchangeCouple112(string Name,number deltaX,number deltaY,number &valueX,number &valueY)
	{
	number X,Y
	VMGetCouple112(Name,X,Y)
	X += deltaX
	Y += deltaY
	VMsetCouple112(Name,X,Y)
	}	

string VMgetAxisName(number axis)
	{
	string AxisName 
	if(axis==0) AxisName ="_X"
	if(axis==1) AxisName ="_Y"
	return AxisName
	}
	
number VMGetOneInCouple112(string Name,number axis)
	{
	return VMgetValue112(Name+VMgetAxisName(axis))
	}

void VMsetOneInCouple112(string Name,number Value,number axis)
	{
	VMsetValue112(Name+VMgetAxisName(axis),Value)
	}

void UpdatePanel_112(string PanelName, string Identifier, number value)
	{
	object Panel
	number PanelID = VMgetvalue112("VM_panel_"+PanelName+" ID")
	if(!PanelID==0) 
		{
		Panel = PanelID.GetScriptObjectFromID()
		if(Panel.ScriptObjectIsValid()) Panel.LookUpElement(Identifier).DLGValue(Value)
		}
	}


//set ini time tick

number tick0 = GetOSTickCount()
VMsetValue112("InitialTimeTick",tick0)
VMsetValue112("FEG:timeTick",tick0)

/*****************************
Off-Line CHECK
******************************/	
void OFFlineCHECK112()
	{
	String InLineCaution = " already exists. This is probably In-Line Digital Micrograph version.\nInstallation of virtualTEM is forbidden " 
	string CheckCommand1 = "sscgetsize"
	string CheckCommand2 = "EMImageShift"
	string CheckCommand3 = "cm_ccd_getsize"
	number OFFLine = 0
	SetPersistentNumberNote(lab112()+":OFFLine",OFFLine)

	if(doesfunctionexist(CheckCommand1)) {result("\n"+CheckCommand1+InLineCaution);throw(-128);} 
	if(doesfunctionexist(CheckCommand2))  {result("\n"+CheckCommand2+InLineCaution);throw(-128);}
	if(doesfunctionexist(CheckCommand3))  {result("\n"+CheckCommand3+InLineCaution);throw(-128);}
	OFFLine = 1
	SetPersistentNumberNote(lab112()+":OFFLine",OFFLine)
	}


/*******************************************
Loading virtualTEM parameters if not exist
********************************************/	

//CAMERAMANAGER settings SHOULD NOT BE OVERWRITTEN IN INLINE DM!! 

void MakeCameraInCameraManager112(number CameraID,String CamName,string Location)
	{
	SetPersistentNumberNote(HLP_Path112(CameraID,"Acquire","Record")+":Exposure (s)",0.4)
	SetPersistentPointNote(HLP_Path112(CameraID,"Acquire","Record")+":Binning",2,2)
	SetPersistentStringNote(HLP_Path112(CameraID,"Acquire","Record")+":Processing","Gain Normalized")
	SetPersistentRectNote(HLP_Path112(CameraID,"Acquire","Record")+":CCD Read Area",0,0,2048,2048)
	
	SetPersistentNumberNote(HLP_Path112(CameraID,"View","Search")+":Exposure (s)",0.1)
	SetPersistentPointNote(HLP_Path112(CameraID,"View","Search")+":Binning",4,4)
	SetPersistentStringNote(HLP_Path112(CameraID,"View","Search")+":Processing","Gain Normalized")
	SetPersistentRectNote(HLP_Path112(CameraID,"View","Search")+":CCD Read Area",0,0,2048,2048)
	
	SetPersistentPointNote(CCL_Path112()+":["+CameraID+"]:CCD:Active Size (pixels)",2048,2048)	
	SetPersistentStringNote(CCL_Path112()+":["+CameraID+"]:Name",CamName)	

	SetPersistentStringNote(CCL_Path112()+"["+CameraID+"]:Location",Location)
	}

void AddFilterInCameraManager112(number CameraID)
	{
	SetPersistentNumberNote(HLS_Path112(CameraID,"Acquire","Acquire")+":Exposure (s)",0.01)
	SetPersistentPointNote(HLS_Path112(CameraID,"Acquire","Acquire")+":Binning",1,1)
	SetPersistentStringNote(HLS_Path112(CameraID,"Acquire","Acquire")+":Processing","Gain Normalized")
	SetPersistentRectNote(HLS_Path112(CameraID,"Acquire","Acquire")+":CCD Read Area",382,0,642,2048)
	
	SetPersistentNumberNote(HLS_Path112(CameraID,"View","View")+":Exposure (s)",0.001)
	SetPersistentPointNote(HLS_Path112(CameraID,"View","View")+":Binning",1,5)
	SetPersistentStringNote(HLS_Path112(CameraID,"View","View")+":Processing","Gain Normalized")
	SetPersistentRectNote(HLS_Path112(CameraID,"View","View")+":CCD Read Area",382,0,642,2048)
	}
	
void MakeVirtualCameraManager112(number version)
	{
	number CurrentCamera
	if(!GetPersistentNumberNote("CameraManager:Current Camera",CurrentCamera)||(version<2))  
		//if completely fresh installation or version < 2.0
		{
		result("\nmaking CameraManagerTags")
		//LoadPersistentNotes("",GetApplicationDirectory(1008,0)+"VirtualCameraManager")
	
		//making two cameras
		TagGroup Ptg = GetPersistentTagGroup()
		TagGroup CamMan = NewTagGroup()
		Ptg.TagGroupSetTagAsTagGroup("CameraManager",CamMan)
		
		CamMan.TagGroupSetTagAsShort("Current Camera",1)
		
		TagGroup sub = CamMan.TagGroupCreateNewLabeledList("CameraConfigurationList")
		taggroup cam0 = sub.TagGroupCreateGroupTagAtEnd()
		taggroup cam1 = sub.TagGroupCreateGroupTagAtEnd()	//2 default cameras
				
		MakeCameraInCameraManager112(0,"upper Camera","high_resolution")
		MakeCameraInCameraManager112(1,"filter Camera","filter")
		
		AddFilterInCameraManager112(1)	//only lower camera equipped with filter
		}	
	}

void LoadPrameterInCameraInfo112(number CameraID,string Name,number Value)
{
VMsetValue112("Camera:["+CameraID+"]:"+Name,Value)
}
	
void LoadCameraInfo112(number CameraID,number &Xdef,number Ydef,number sizeDef,number DefectedPixels,number Saturation,number temperature,number Cam_mm)
{
LoadPrameterInCameraInfo112(CameraID,"DefectCoordinates_X",Xdef)
LoadPrameterInCameraInfo112(CameraID,"DefectCoordinates_Y",Ydef)
LoadPrameterInCameraInfo112(CameraID,"DefectedPixels",DefectedPixels)
LoadPrameterInCameraInfo112(CameraID,"DefectSize",sizeDef)
LoadPrameterInCameraInfo112(CameraID,"Saturation",Saturation)
LoadPrameterInCameraInfo112(CameraID,"Size_mm",Cam_mm)
LoadPrameterInCameraInfo112(CameraID,"Temperature",temperature)
LoadPrameterInCameraInfo112(CameraID,"Temperature min",-30)
LoadPrameterInCameraInfo112(CameraID,"Temperature max",50)
LoadPrameterInCameraInfo112(CameraID,"Temperature resolution",1)
LoadPrameterInCameraInfo112(CameraID,"Temperature resolution",1)
}

number ReadParameterInCmeraInfo112(number CameraID,string Name)
{
return VMgetvalue112("Camera:["+CameraID+"]:"+Name)
}

void ReadCameraInfo112(number CameraID,number &Xdef,number &Ydef,number &sizeDef,number &DefectedPixels,number &Saturation,number &temperature,number &Cam_mm)
	{
	Xdef = ReadParameterInCmeraInfo112(CameraID,"DefectCoordinates_X")
	
	Xdef = ReadParameterInCmeraInfo112(CameraID,"DefectCoordinates_X")
	Ydef = ReadParameterInCmeraInfo112(CameraID,"DefectCoordinates_Y")
	DefectedPixels = ReadParameterInCmeraInfo112(CameraID,"DefectedPixels")
	sizeDef = ReadParameterInCmeraInfo112(CameraID,"DefectSize")
	Saturation = ReadParameterInCmeraInfo112(CameraID,"Saturation")
	temperature = ReadParameterInCmeraInfo112(CameraID,"Temperature")
	Cam_mm = ReadParameterInCmeraInfo112(CameraID,"Size_mm")
	} 
	
//Setting cameras info in Virtual TEM tags if not exist 
void MakeVirtualCameras112(number version)
	{
	number Saturation
	if(!GetPersistentNumberNote(lab112()+":VirtualTEM:Camera:[0]:Saturation",Saturation)||(version<2))
		{	//if saturation is absent, then camera assumed not existing and will be created
			//if version lower than 2.0 created anyway
result("\nmaking virtual cameras ")
		number Xdef,Ydef,sizeDef,DefectedPixels,temperature,Cam_mm
		Saturation= 60000
		temperature = (-20)
		defectedPixels = 0.95
		Xdef = 0.25
		Ydef = 0.25
		sizeDef = 0.2
		
		//making two virtual cameras
		TagGroup Ptg = GetPersistentTagGroup()
		TagGroup VTEM = NewTagGroup()	
		Ptg.TagGroupSetTagAsTagGroup(lab112()+":VirtualTEM",VTEM)

		TagGroup sub = VTEM.TagGroupCreateNewLabeledList("Camera")
		taggroup cam0 = sub.TagGroupCreateGroupTagAtEnd()	//upper camera
		taggroup cam1 = sub.TagGroupCreateGroupTagAtEnd()	//lower filter camera
		
		//default cameras
		//upper camera
		Cam_mm = 20
		LoadCameraInfo112(0,Xdef,Ydef,sizeDef,DefectedPixels,Saturation,temperature,Cam_mm)
		VMsetValue112("Camera:["+0+"]:Inserted",0)	
		
		//lower filter camera
		Cam_mm = 2
		LoadCameraInfo112(1,Xdef,Ydef,sizeDef,DefectedPixels,Saturation,temperature,Cam_mm)
		VMsetValue112("Camera:["+1+"]:Filter",1)
		VMsetValue112("Camera:["+1+"]:EELS reduction",10)
		VMsetValue112("Camera:["+1+"]:Zoom Channel",200)
		}
	}

//TABLES

number IsTableReasonable112(string FirstElementLabel)
	{
	TagGroup Ptg = GetPersistentTagGroup()

	if(TagGroupDoesTagExist(Ptg,lab112()+":VirtualTEM:"+FirstElementLabel)) //tag exist or not
		{
//result("Table #"+FirstElementLabel+"# exist ")
		if(VMgetValue112(FirstElementLabel)==0) return 0	//tag exists but empty
		else return 1
		}
	else return 0	
	}

void setMaxIndex112(string Label,string units,number MaxAllowed,string maxIndName)
	{
	TagGroup Ptg = GetPersistentTagGroup()
	for(number i=0;i<MaxAllowed;i++)	//maximal 20 dispersion indexes
		{
		if(!TagGroupDoesTagExist(Ptg,lab112()+":VirtualTEM:"+Label+":["+i+"]:"+units)) 
			{
			number maxIndex = i-1
			VMsetvalue112(maxIndName,maxIndex)
			break
			}
		}
	}
	
//setting Magnification Table if not exists
void MakeMagTable112(number version)
	{ 
	TagGroup Ptg = GetPersistentTagGroup()
	
	 if(!IsTableReasonable112("Mag Table:[0]:xM")||(version<2)) 
		{
result("\nmaking MagTable ")
		//default mag table
		number mag0 = 0.03
		number mag1 = 0.05
		number mag2 = 0.07
		number mag3 = 0.1
		number mag4 = 0.14
		number mag5 = 0.2
		number mag6 = 0.3
		number mag7 = 0.45
		number mag8 = 0.68
		number mag9 = 1.0
		
		TagGroup VTEM,sub  
		TagGroupGetTagAsTagGroup(Ptg,lab112()+":VirtualTEM",VTEM) 

		//adding mag list
		sub = VTEM.TagGroupCreateNewLabeledList("Mag Table")
		sub.TagGroupCreateGroupTagAtEnd().TagGroupSetTagAsNumber("xM",mag0)
		sub.TagGroupCreateGroupTagAtEnd().TagGroupSetTagAsNumber("xM",mag1)
		sub.TagGroupCreateGroupTagAtEnd().TagGroupSetTagAsNumber("xM",mag2)
		sub.TagGroupCreateGroupTagAtEnd().TagGroupSetTagAsNumber("xM",mag3)
		sub.TagGroupCreateGroupTagAtEnd().TagGroupSetTagAsNumber("xM",mag4)
		sub.TagGroupCreateGroupTagAtEnd().TagGroupSetTagAsNumber("xM",mag5)
		sub.TagGroupCreateGroupTagAtEnd().TagGroupSetTagAsNumber("xM",mag6)
		sub.TagGroupCreateGroupTagAtEnd().TagGroupSetTagAsNumber("xM",mag7)
		sub.TagGroupCreateGroupTagAtEnd().TagGroupSetTagAsNumber("xM",mag8)
		sub.TagGroupCreateGroupTagAtEnd().TagGroupSetTagAsNumber("xM",mag9)
		
		number magInd = 3	//default initial mag index
		VMsetvalue112("Mag index",magInd)
		}
		
	setMaxIndex112("Mag Table","xM",100,"max Mag_index")	
	}

//setting Camera Length Table if not exists	
void MakeLengthTable112(number version)
	{ 
	TagGroup Ptg = GetPersistentTagGroup()
	
	 if(!IsTableReasonable112("Length Table:[0]:m")||(version<2)) 
		{
result("\nmaking CameraLength Table ")
		//default camera length table
		number Length0 = 0.03
		number Length1 = 0.05
		number Length2 = 0.07
		number Length3 = 0.1
		number Length4 = 0.2
		number Length5 = 0.3

		TagGroup VTEM,sub  
		TagGroupGetTagAsTagGroup(Ptg,lab112()+":VirtualTEM",VTEM) 

		//adding Length list
		sub = VTEM.TagGroupCreateNewLabeledList("Length Table")

		sub.TagGroupCreateGroupTagAtEnd().TagGroupSetTagAsNumber("m",Length0)
		sub.TagGroupCreateGroupTagAtEnd().TagGroupSetTagAsNumber("m",Length1)
		sub.TagGroupCreateGroupTagAtEnd().TagGroupSetTagAsNumber("m",Length2)
		sub.TagGroupCreateGroupTagAtEnd().TagGroupSetTagAsNumber("m",Length3)
		sub.TagGroupCreateGroupTagAtEnd().TagGroupSetTagAsNumber("m",Length4)
		sub.TagGroupCreateGroupTagAtEnd().TagGroupSetTagAsNumber("m",Length5)
		
		number LengthInd = 3	//default initial Length index
		VMsetvalue112("Length index",LengthInd)
		}
		
	setMaxIndex112("Length Table","m",100,"max Length_index")	
	}

//setting Dispersion Table
void MakeDispersionTable112(number version)
	{ 
	TagGroup Ptg = GetPersistentTagGroup()
	
	 if(!IsTableReasonable112("Filter:Dispersion Table:[0]:eV")) 
		{	//if there no dispersion table yet
result("\nmaking Dispersion Table ")
		//default dispersion table
		image Disp := realimage("",4,9,1)
		disp.setPixel(0,0,1)
		disp.setPixel(1,0,0.5)
		disp.setPixel(2,0,0.3)
		disp.setPixel(3,0,0.2)
		disp.setPixel(4,0,0.1)
		disp.setPixel(5,0,0.05)
		disp.setPixel(6,0,0.03)
		disp.setPixel(7,0,0.02)
		disp.setPixel(8,0,0.01)
		
		TagGroup VTEM,sub  
		TagGroupGetTagAsTagGroup(Ptg,lab112()+":VirtualTEM:Filter",VTEM) 

		//adding dispersion list
		sub = VTEM.TagGroupCreateNewLabeledList("Dispersion Table")
		for(number i=0;i<9;i++)
			{
			sub.TagGroupCreateGroupTagAtEnd().TagGroupSetTagAsNumber("eV",disp.getPixel(i,0))
			}
		number DispInd =3	//default initial Length index
		VMsetvalue112("Filter:Dispersion_index",DispInd)
		}
	
	setMaxIndex112("Filter:Dispersion Table","eV",20,"Filter:max Dispersion_index")
	}

//setting Filter apperture Table if not exists	
void MakeFilterAppertureTable112(number version)
	{ 
	TagGroup Ptg = GetPersistentTagGroup()
	
	 if(!TagGroupDoesTagExist(Ptg,lab112()+":VirtualTEM:Filter:Apperture Table:[0]:apperture")) 
		{
result("\nmaking Filter AppertureTable ")
		//default apperture table
		string app0 = "Imaging"
		string app1 = "5 mm"
		string app2 = "2.5 mm"

		TagGroup VTEM,sub  
		TagGroupGetTagAsTagGroup(Ptg,lab112()+":VirtualTEM:Filter",VTEM) 

		//adding Filter apperture list
		sub = VTEM.TagGroupCreateNewLabeledList("Apperture Table")
		sub.TagGroupCreateGroupTagAtEnd().TagGroupSetTagAsString("apperture",app0)
		sub.TagGroupCreateGroupTagAtEnd().TagGroupSetTagAsString("apperture",app1)
		sub.TagGroupCreateGroupTagAtEnd().TagGroupSetTagAsString("apperture",app2)

		number AppInd =0	//default initial Filter apperture
		VMsetvalue112("Filter:Apperture_index",AppInd)
		}
		
	setMaxIndex112("Filter:Apperture Table","apperture",8,"Filter:max Apperture_index")	
	}
	
//Make Microscope Info Tags
void MakeMicroscopeInfo112(number version)
	{ 
	number nHT
	if(!GetPersistentNumberNote("Microscope Info:Voltage", nHT))
		{	// if there no microscope info tags
		TagGroup Ptg = GetPersistentTagGroup()
		TagGroup MInfo = NewTagGroup()
		Ptg.TagGroupSetTagAsTagGroup("Microscope Info",MInfo)

		//default HT
		MInfo.TagGroupSetTagAsLong("Voltage",200000)
		
		number MagIndex = VMgetvalue112("Mag index")
		number Mag = VMgetvalue112("Mag Table:["+MagIndex+"]:xM")
		MInfo.TagGroupSetTagAsLong("Indicated Magnification",Mag*1000000)

		number BtoC2=5000
		VMsetvalue112("BrightnessToC2 scale",BtoC2)			
		
		number HT	//forgotten in previous versions
		GetPersistentNumberNote("Microscope Info:Voltage",HT)
result("\nMicroscope Info loaded ")
		}
	}

//make virtual TEM tags
void MakeVirtualTEM(number version)	
	{
	if(version<2)
		{
		//All parameters that are not zero
		number HT = 200000
		VMsetValue112("HighTension_V",HT)
		VMsetValue112("C2",50)
		VMsetValue112("SpotSize",5)
		SetPersistentStringNote(lab112()+":VirtualTEM:Operation Mode","IMAGING")
		
	//Filter
		//general setting
		TagGroup tech = NewTagList()
		Tech.TagGroupInsertTagAsShort(1,1) 	//ON
		Tech.TagGroupInsertTagAsLong(2,0)	//Value (eV)
		Tech.TagGroupInsertTagAsLong(3,-50)	//min (eV)
		Tech.TagGroupInsertTagAsLong(4,1000)//max (eV)
		
		TagGroup Ptg = GetPersistentTagGroup()
		Ptg.TagGroupSetTagAsTagGroup(lab112()+":VirtualTEM:Filter:prism offset",tech.TagGroupClone())
		Ptg.TagGroupSetTagAsTagGroup(lab112()+":VirtualTEM:Filter:HT offset",tech.TagGroupClone())
		Ptg.TagGroupSetTagAsTagGroup(lab112()+":VirtualTEM:Filter:prism adjust",tech.TagGroupClone())
		Ptg.TagGroupSetTagAsTagGroup(lab112()+":VirtualTEM:Filter:drift tube",tech.TagGroupClone())				
		Ptg.TagGroupSetTagAsTagGroup(lab112()+":VirtualTEM:Filter:DT wobbler",tech.TagGroupClone())				

		//specific adjustment
		Ptg.TagGroupSetTagAsLong(lab112()+":VirtualTEM:Filter:HT offset:[3]",3000)
		Ptg.TagGroupSetTagAsLong(lab112()+":VirtualTEM:Filter:prism offset:[2]",-3000)
		Ptg.TagGroupSetTagAsLong(lab112()+":VirtualTEM:Filter:prism offset:[3]",3000)
		Ptg.TagGroupSetTagAsLong(lab112()+":VirtualTEM:Filter:prism adjust:[3]",50)
		Ptg.TagGroupSetTagAsLong(lab112()+":VirtualTEM:Filter:DT wobbler:[0]",0)
		Ptg.TagGroupSetTagAsLong(lab112()+":VirtualTEM:Filter:DT wobbler:[1]",20)
		
		VMsetValue112("Filter:FilterMode",1)		
		VMsetValue112("Filter:SlitIn",0)
		VMsetValue112("Filter:SlitWidth",10)
		VMsetValue112("Filter:MaxSlitWidth",250)		
		VMsetValue112("Filter:SlitDelay",0)
		VMsetValue112("Filter:EnergyShiftDelay",0.25)
		VMsetValue112("Filter:CameraID",1)
		VMsetValue112("Filter:EELS reduction",10)

		VMsetValue112("FEG:FWHM",0.8)	
		VMsetValue112("FEG:Energy Drift_eVPh",0)	
		VMsetValue112("FEG:Energy Ripple_sigma_eV",0.2)
		
		//remove old stored filter configurations
		Ptg.TagGroupDeleteTagWithLabel(lab112()+":VirtualTEM:Filter temp")
		
result("\n2.0 Microscope Info loaded ")
		}
	}
	
//Setting particle info if not exist
void MakeParticle112(number version)
	{
	number minGalo,size,Transparancy,sizeCore,Thickness,Al,AlCore
	size = VMgetvalue112("Particle:Size_nm")
	if(size==0)
		{
		size = 10
		minGalo = 1
		Transparancy = 0.5
		VMsetvalue112("Particle:Size_nm",size)
		VMsetvalue112("Particle:Galo_nm",minGalo)
		VMsetvalue112("Particle:Transparancy",Transparancy)
		result("\nmaking Particle ")
		}
	if(version<2) 
		{
		sizeCore =5
		Thickness = 0.5
		Al= 0.4
		AlCore = 1
		VMsetvalue112("Particle:Size Core_nm",sizeCore)
		VMsetvalue112("Particle:Thickness",Thickness)
		VMsetvalue112("Particle:Al",Al)
		VMsetvalue112("Particle:Al Core",AlCore)
result("\nadding chemistry to Particle ")
		}
	}

//making virtual STEM tags

TagGroup CreateSignal_112(number Selected)
{
TagGroup Signal =  NewTagGroup()
Signal.TagGroupSetTagAsShort("Depth",2)
Signal.TagGroupSetTagAsShort("Selected",Selected)

return Signal
}

TagGroup CreateSTEMacquisition112(number Width,number Time,number Mode)
{
TagGroup Record = NewTagGroup()
Record.TagGroupSetTagAsShort("Scan Mode",Mode)
Record.TagGroupSetTagAsShort("Synchronize Line",0)
Record.TagGroupSetTagAsLong("Image Width",Width)
Record.TagGroupSetTagAsLong("Image Height",Width)
Record.TagGroupSetTagAsFloat("Sample Time",Time)

Record.TagGroupSetTagAsTagGroup("Signal 0",CreateSignal_112(0))
Record.TagGroupSetTagAsTagGroup("Signal 1",CreateSignal_112(0))
Record.TagGroupSetTagAsTagGroup("Signal 2",CreateSignal_112(1))

return Record
}

TagGroup CreateDetector112(number Rad,string Name)
{
TagGroup Detector =  NewTagGroup()

Detector.TagGroupSetTagAsFloat("Radius",Rad)
Detector.TagGroupSetTagAsString("Name",Name)
Detector.TagGroupSetTagAsString("Location","wide_angle")

return Detector
}


void MakeVirtualSTEM112(number version)	
{
if(version<3)
	{
	//native Digiscan tags
	TagGroup Ptg = GetPersistentTagGroup()
	TagGroup DiGi = NewTagGroup()
	Ptg.TagGroupSetTagAsTagGroup(DigiScanPath112(),DiGi)

	TagGroup Settings = NewTagGroup()
	DiGi.TagGroupSetTagAsTagGroup("Digiscan 2:Setup",Settings)

	Settings.TagGroupSetTagAsTagGroup("Search",CreateSTEMacquisition112(256,5,1))
	Settings.TagGroupSetTagAsTagGroup("Preview",CreateSTEMacquisition112(512,5,0))
	Settings.TagGroupSetTagAsTagGroup("Record",CreateSTEMacquisition112(512,20,0))

	//redefine Detectors in Search
	SetPersistentNumberNote(DigiScanPath112()+":Digiscan 2:Setup:Search:Signal 0:Selected",1)
	SetPersistentNumberNote(DigiScanPath112()+":Digiscan 2:Setup:Search:Signal 1:Selected",1)
	SetPersistentNumberNote(DigiScanPath112()+":Digiscan 2:Setup:Search:Signal 2:Selected",0)
	
	SetPersistentNumberNote(DigiScanPath112()+":Control Beam",0)
	SetPersistentNumberNote(DigiScanPath112()+":Flyback Time",50)
	SetPersistentNumberNote(DigiScanPath112()+":Line Sync Frequency",50)
	SetPersistentNumberNote(DigiScanPath112()+":Rotation Offset",0)
	SetPersistentNumberNote(DigiScanPath112()+":Rotation",0)
	SetPersistentNumberNote(DigiScanPath112()+":X Beam Park Position",50000)
	SetPersistentNumberNote(DigiScanPath112()+":Y Beam Park Position",50000)
	SetPersistentNumberNote(DigiScanPath112()+":Do Flip",0)	

	//Virtual TEM tags
	TagGroup Det = NewTagList()
	Det.TagGroupInsertTagAsTagGroup(1,CreateDetector112(0,"BF"))
	Det.TagGroupInsertTagAsTagGroup(2,CreateDetector112(0.3,"DF"))
	Det.TagGroupInsertTagAsTagGroup(3,CreateDetector112(1,"HAADF"))
	Ptg.TagGroupSetTagAsTagGroup(lab112()+":VirtualTEM:DigiScan:Detectors",Det)
	number EffectSize = 3 //effective PHYSICAL size of camera in mm
	Ptg.TagGroupSetTagAsFloat(lab112()+":VirtualTEM:DigiScan:Effective size",EffectSize)
	
	TagGroup Par = NewTagList()
	//Par.TagGroupInsertTagAsShort(1,0)
	Ptg.TagGroupSetTagAsTagGroup(lab112()+":VirtualTEM:DigiScan:Parameters",Par)
	
	SetPersistentStringNote(lab112()+":VirtualTEM:Illumination Mode","TEM")
	VMsetCouple112("DigiScan:Beam Position",50000,50000)
	VMsetValue112("DigiScan:Rotation",0)
	
result("\n3.0 DigiScan info loaded ")
	}
}

/*************************************
Close UIFrames
*************************************/
void CloseUIFrameinV1V2DM112(object Frame)	
	{
	Try { Frame.Close();} //this is for DM2.x
	catch 
		{
		Frame.GetFrameWindow().WindowClose(0); //this is for DM1.x
		break;
		}
	}
	
/*************************************
Key Listener to the live image
*************************************/
interface KeyToSimulator
	{ 
	void Pause(object self);  
	void Release(object self);  
	void IncreaseExposure(object self); 
	void DecreaseExposure(object self); 
	}
	
number HandleKey112(number Key)
	{
	number ContSimullatorID = VMgetvalue112("Running ContiniousSimulator")

	object ContSimullator = GetScriptObjectFromID(ContSimullatorID)
	if( ContSimullator.ScriptObjectIsValid())
		{      
		if(Key==32) ContSimullator.Pause()
		if(Key==30) ContSimullator.IncreaseExposure()
		if(Key==31) ContSimullator.DecreaseExposure()
		}
		
	return 1
	}

/******************************************************
calling OFF-line check and creating the virtualTEM tags 
******************************************************/
result("\nVirtualTEM ")
OFFlineCHECK112()
number OFFLine 
GetPersistentNumberNote(lab112()+":OFFLine",OFFLine);

number version  = VMgetValue112("version")
if(OffLine==1)
	{
	MakeVirtualCameraManager112(version) 
	MakeVirtualCameras112(version)
	MakeMagTable112(version)
	MakeLengthTable112(version)
	MakeMicroscopeInfo112(version)
	MakeVirtualTEM(version)
	MakeDispersionTable112(version)
	MakeFilterAppertureTable112(version)
	MakeParticle112(version)
	MakeVirtualSTEM112(version)
	}
result("\n1)")