// temDM Scripting Example

/* AUTOACQUISITION */
/* automatic determination of the acquisition time required for the target dose*/

//finding the active camera, 
//preparating it for acquisition 
//(insert camera, retract all higher cameras et cet.)
number CamID = CameraGetActiveCameraID() 
CameraPrepareForAcquire(CamID)

//parameters
number TargetMaxCount = 10000	//target max count desired in image
number testExposure = 0.1		//test exposure in sec
number binning = 1				//binning of camera pixels

//acquisition of the test image
image testImage := CameraAcquire(CamID,testExposure,binning,binning)

//calculation of the maximum count in the test image
number MaxCount = max(testImage)

//finding the final ascquisition time
number Exposure = testExposure*TargetMaxCount/MaxCount

//acquisition of the final image
image targetImage := CameraAcquire(CamID,Exposure,binning,binning)

//output
result("\ntarget maximal intensity: "+TargetMaxCount+"; Exposure: "+Exposure+" sec")
showimage(targetImage)