// temDM Scripting Example

/* FOCAL SERIES */
/* acquisition of image series with varying the focus*/

//finding the active camera, 
//preparating it for acquisition 
//(insert camera, retract all higher cameras et cet.)
number CamID = CameraGetActiveCameraID() 
CameraPrepareForAcquire(CamID)

//parameters
number N = 3 				//number of images in series
number minFocus = -200		//minimal focus value in series
number maxFocus = 200		//maximal focus value in series
number Exposure = 0.4		//exposure in sec
number binning = 2			//binning of camera pixels

//acquisition loop
number i
for(i=0; i<N; i++)
	{
	//calculate and set the current focus value 
	number Focus = minFocus + (maxFocus - minFocus)*i/(N-1)
	EMsetFocus(Focus)
	
	//acquise the current image
	image Current := CameraAcquire(CamID,Exposure,binning,binning)
	setName(Current,"Focus "+Focus)
	
	//output
	result("\nacquired image at focus "+Focus +"nm")
	showimage(Current)
	}

//restore focus
EMsetFocus(0)