// $BACKGROUND$

// temDM Scripting Example

/* Z-MAPPING */
/* acquisition of STEM image with HAAD detector
whose signal is assumed to be roughly proportional 
to the mean Z-number of material  */

//SET CAMERA LENGTH IN DIFFRACTION MODE TO 100mm OR SMALLER !!

//preparation of HAADF images
image HAADF := integerImage("HAADF",2,0,512,512)
HAADF.showimage()

//parameters for scanning
number pixelTime = 10
number rotation = 0
number lineSync = 0

//acquisition
DSacquireData(HAADF,2,pixelTime,rotation,lineSync)
DSwaitUntilFinished()

//subtract background and normalize HAADF
image Zmap := realImage("Z-map",4,512,512)
Zmap = (HAADF - min(HAADF))
Zmap = Zmap/max(Zmap)
number Assumed_Z_in_Core = 13 //pure Al
Zmap = Zmap*Assumed_Z_in_Core

Zmap.showimage()

// You see that assuming the pure Al in the partice core
// we deduce the mean Z-number in the particle shell of ~10
// This means that the example particle in VirtualTEM
// might be Al surrounded by Al2O3 (13*0.4+8*0.6 = 10 )
// Great discovery !!
